dnl Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
dnl See the file "license.terms" for details.
dnl
dnl $tvt: ipl.m4,v 1.4 2001/06/15 03:06:50 samc Exp $

dnl -------------------------------------------------------------------------
dnl TVT_IPL - setup paths to IPL config files
dnl -------------------------------------------------------------------------
AC_DEFUN([TVT_IPL],
[
  AC_MSG_CHECKING(for IPL)
  AC_ARG_WITH(iplconfdir, [  --with-iplconfdir=DIR   ipl configuration dir])
  if test $with_iplconfdir; then
    if test -d "$with_iplconfdir"; then
      iplconfdir=$with_iplconfdir
      AC_SUBST(iplconfdir)
      AC_MSG_RESULT($iplconfdir)
    else
      AC_MSG_RESULT(no)
      AC_MSG_ERROR(ipl configuration dir 'with-iplconfdir=$with_iplconfdir' not found)
    fi
  else
    dnl If no option given then look for IPL in in the parent directories.
    abssrcdir=`pwd`/$srcdir
    iplconfdir=""
    if test -d "$abssrcdir/../ipl/config"; then
      iplconfdir="$abssrcdir/../ipl/config"
    elif test -d "$abssrcdir/../../ipl/config"; then
      iplconfdir="$abssrcdir/../../ipl/config"
    fi
    if test "$iplconfdir" != ""; then
      AC_SUBST(iplconfdir)
      AC_MSG_RESULT($iplconfdir)
    else
      AC_MSG_RESULT(no)
    fi
  fi
])
