#include "ipl.h"
#include <stdio.h>


int main ( int argc, char* argv[] )
{
	char buf[16];
	int n , i, c;

	if ( argc > 1 ){
		ipl_initKeyboard();

		while ( 1 ) {
			n = read( ipl_kbdFd, buf, sizeof(buf));

			c = buf[0];

			if ( n == 1 ){
				printf( "%3d '%c'\n", c, c);
			}
			else {
				for ( i=0; i<n; i++ ){
					c = buf[i];
					printf( "%3d ", c);
					if ( (c > 31) && (c < 128) )
						printf( "'%c' ", c);
				}
				putchar( '\n');
			}
		}
		
		ipl_resetKeyboard();
	}
	else {
		puts( "struct keyTab {");
		for ( i=0; i<255; i++ ){
			printf( "/* %3d (%02x) */  { '%c', VK_%c, 0 },\n", i, i, 
					((i > 31)) ? i : ' ', 
					((i >= 'A') && (i <= 'Z')) ? i :
					   ((i >= 'a') && (i <= 'z')) ? i -0x20 : ' ' );
		}
		puts( "};");
	}
}
