# Makefile.frag for kaffevm JIT
#
# Copyright (c) 1996, 1997
#	Transvirtual Technologies, Inc.  All rights reserved.
#
# See the file "license.terms" for information on usage and redistribution 
# of this file. 

DISASM_DIR = /home/mikey/gdb-4.18

ENGINE4_CFLAGS=	-I$(srcdir)/jit4 -I$(DISASM_DIR)/bfd -I$(DISASM_DIR)/include -I$(DISASM_DIR)/opcodes

ENGINE4_OBJECTS=\
		consts$(OBJEXT) \
		list$(OBJEXT) \
		expr$(OBJEXT) \
		exprgen$(OBJEXT) \
		reduce$(OBJEXT) \
		regs$(OBJEXT) \
		cfg$(OBJEXT) \
		asm$(OBJEXT) \
		lab$(OBJEXT) \
		schedule$(OBJEXT) \
		scanner$(OBJEXT) \
		bitvector$(OBJEXT) \
		print$(OBJEXT) \
		scanner$(OBJEXT) \
		schedule$(OBJEXT) \
		jitstats$(OBJEXT) \
		jitsupport$(OBJEXT) \
		$(DISASM_DIR)/opcodes/dis-buf.o \
		$(DISASM_DIR)/opcodes/disassemble.o \
		$(DISASM_DIR)/opcodes/i386-dis.o

asm.o: asm.h asm.c asm-i386.def asm-mips.def asm-sparc.def asm-arm.def

regs.o: regs.h regs.c regs-i386.def regs-mips.def regs-sparc.def regs-arm.def

exprgen.o: exprgen.c expr.h kaffe.def

print.o: print.h print.c
