# Xlib based AWT support for standard Java libraries
#
# Copyright (c) 1998
#	Transvirtual Technologies, Inc.  All rights reserved.
#
# See the file "lib-license.terms" for information on usage and redistribution 
# of this file. 

# potential files containing exported (native) methods
EXPORTS=$(srcdir)/*.c $(srcdir)/X/*.c

HEADERS=X/toolkit.h X/grlib.h

OBJECT+=\
		X/tlk$(OBJEXT) \
		X/wnd$(OBJEXT) \
		X/evt$(OBJEXT) \
		X/gra$(OBJEXT) \
		X/fnt$(OBJEXT) \
		X/clr$(OBJEXT) \
		X/img$(OBJEXT) \
		X/cbd$(OBJEXT) \
		imggif$(OBJEXT)  \
		imgjpeg$(OBJEXT) \
		imgpng$(OBJEXT)  \
		imgtiff$(OBJEXT) \
		imgxbm$(OBJEXT)  \
		theme$(OBJEXT) \
		flash$(OBJEXT)



X/tlk$(OBJEXT): X/tlk.c $(HEADERS)

X/wnd$(OBJEXT): X/wnd.c $(HEADERS)

X/evt$(OBJEXT): X/evt.c $(HEADERS)

X/gra$(OBJEXT): X/gra.c $(HEADERS)

X/fnt$(OBJEXT): X/fnt.c $(HEADERS)

X/clr$(OBJEXT): X/clr.c $(HEADERS)

X/img$(OBJEXT): X/img.c $(HEADERS)

X/cbd$(OBJEXT): X/cbd.c $(HEADERS)

imggif$(OBJEXT): imggif.c $(HEADERS)

imgjpeg$(OBJEXT): imgjpeg.c $(HEADERS)

imgpng$(OBJEXT): imgpng.c $(HEADERS)

imgtiff$(OBJEXT): imgtiff.c $(HEADERS)

imgxbm$(OBJEXT): imgxbm.c $(HEADERS)

theme$(OBJEXT): theme.c $(HEADERS)

flash$(OBJEXT): flash.c $(HEADERS)
