# Allegro based AWT support for standard Java libraries
#
# Copyright (c) 1998
#	Transvirtual Technologies, Inc.  All rights reserved.
#
# See the file "lib-license.terms" for information on usage and redistribution 
# of this file. 

TDIR=no-native-wm/allegro
CDIR=no-native-wm

OBJECT+=\
		$(TDIR)/tlk$(OBJEXT) \
		$(TDIR)/wnd$(OBJEXT) \
		$(TDIR)/evt$(OBJEXT) \
		$(TDIR)/gra$(OBJEXT) \
		$(TDIR)/fnt$(OBJEXT) \
		$(TDIR)/clr$(OBJEXT) \
		$(TDIR)/img$(OBJEXT) \
		$(CDIR)/imggif$(OBJEXT)  \
		$(CDIR)/imgjpeg$(OBJEXT) \
		$(CDIR)/imgpng$(OBJEXT)  \
		$(CDIR)/cbd$(OBJEXT) \
		$(CDIR)/geometry$(OBJEXT)


HDRS=$(TDIR)/toolkit.h \
     $(CDIR)/toolkit-common-pre.h \
     $(CDIR)/toolkit-common-post.h \
     $(TDIR)/grlib.def

$(TDIR)/tlk$(OBJEXT): $(TDIR)/tlk.c $(HDRS)

$(TDIR)/wnd$(OBJEXT): $(TDIR)/wnd.c $(CDIR)/wnd-common.c $(HDRS)

$(TDIR)/evt$(OBJEXT): $(TDIR)/evt.c $(CDIR)/evt-common.c $(HDRS)

$(TDIR)/gra$(OBJEXT): $(TDIR)/gra.c $(CDIR)/gra-common.c $(HDRS)

$(TDIR)/fnt$(OBJEXT): $(TDIR)/fnt.c $(HDRS)

$(TDIR)/clr$(OBJEXT): $(TDIR)/clr.c $(CDIR)/clr-common.c $(HDRS)

$(TDIR)/img$(OBJEXT): $(TDIR)/img.c $(CDIR)/img-common.c $(HDRS)

$(TDIR)/imggif$(OBJEXT): $(TDIR)/imggif.c $(HDRS)

$(TDIR)/imgjpeg$(OBJEXT): $(TDIR)/imgjpeg.c $(HDRS)

$(TDIR)/imgpng$(OBJEXT): $(TDIR)/imgpng.c $(HDRS)

$(TDIR)/cbd$(OBJEXT): $(TDIR)/cbd.c $(HDRS)

$(TDIR)/geometry$(OBJEXT): $(TDIR)/geometry.c $(HDRS)
