# GRX based AWT support for standard Java libraries
#
# Copyright (c) 1998
#	Transvirtual Technologies, Inc.  All rights reserved.
#
# See the file "lib-license.terms" for information on usage and redistribution 
# of this file. 

TDIR=no-native-wm/grx
CDIR=no-native-wm

# files containing exported (native) methods
EXPORTS=$(srcdir)/$(CDIR)/*.c $(srcdir)/$(TDIR)/*.c

OBJECT+=\
		$(TDIR)/tlk$(OBJEXT) \
		$(TDIR)/wnd$(OBJEXT) \
		$(TDIR)/evt$(OBJEXT) \
		$(TDIR)/gra$(OBJEXT) \
		$(TDIR)/fnt$(OBJEXT) \
		$(TDIR)/clr$(OBJEXT) \
		$(TDIR)/img$(OBJEXT) \
		$(CDIR)/cbd$(OBJEXT) \
		$(CDIR)/geometry$(OBJEXT) \
		imggif$(OBJEXT)  \
		imgjpeg$(OBJEXT) \
		imgpng$(OBJEXT)  \
		imgtiff$(OBJEXT)  \
		imgxbm$(OBJEXT)  \
		theme$(OBJEXT)


HDRS=$(TDIR)/toolkit.h \
     $(CDIR)/toolkit-common.h \
     $(TDIR)/grlib.h

$(TDIR)/tlk$(OBJEXT): $(TDIR)/tlk.c $(HDRS)

$(TDIR)/wnd$(OBJEXT): $(TDIR)/wnd.c $(CDIR)/wnd-common.c $(HDRS)

$(TDIR)/evt$(OBJEXT): $(TDIR)/evt.c $(CDIR)/evt-common.c $(HDRS)

$(TDIR)/gra$(OBJEXT): $(TDIR)/gra.c $(CDIR)/gra-common.c $(HDRS)

$(TDIR)/fnt$(OBJEXT): $(TDIR)/fnt.c $(HDRS)

$(TDIR)/clr$(OBJEXT): $(TDIR)/clr.c $(CDIR)/clr-common.c $(HDRS)

$(TDIR)/img$(OBJEXT): $(TDIR)/img.c $(CDIR)/img-common.c $(HDRS)

$(CDIR)/cbd$(OBJEXT): $(CDIR)/cbd.c $(HDRS)

$(CDIR)/geometry$(OBJEXT): $(CDIR)/geometry.c $(HDRS)

imggif$(OBJEXT): imggif.c $(HDRS)

imgjpeg$(OBJEXT): imgjpeg.c $(HDRS)

imgpng$(OBJEXT): imgpng.c $(HDRS)

imgtiff$(OBJEXT): imgtiff.c $(HDRS)

imgxbm$(OBJEXT): imgxbm.c $(HDRS)

theme$(OBJEXT): theme.c $(HDRS)
