#
# rebuildLib_frag - rebuild AWT classes for generic no-native-wm implementations
# 
# Copyright (c) 1998
#      Transvirtual Technologies, Inc.  All rights reserved.
#
# See the file "license.terms" for information on usage and redistribution
# of this file.
#

echo "Adding GRX specific AWT classes ..."

# additional awt classes
EXTRA_CLASSES="$EXTRA_CLASSES \
    $SRCDIR/java/awt/no-native-wm/*.java \
	$SRCDIR/kaffe/awt/no-native-wm/*.java \
"

# copy font properties (use local settings if avail)
if test -f java/awt/no-native-wm/grx/font.properties; then
  fprop=java/awt/no-native-wm/grx/font.properties
else
  fprop=$SRCDIR/../clib/awt/no-native-wm/grx/font.properties
fi

copy "$fprop lib/java/awt"
