/*
 * dummy java.security class to enable a java.awt.AWTPermission compile
 */

package java.security;

public class AccessControlException extends SecurityException {
	private final Permission p;

	public AccessControlException(String msg) {
		super(msg);
		p = null;
	}

	public AccessControlException(String msg, Permission p) {
		super(msg);
		this.p = p;
	}

	public Permission getPermission() {
		return p;
	}
}

