/*
 * dummy java.security class to enable a java.awt.AWTPermission compile
 */

package java.security;

public abstract class Permission {
	private String name;

	public Permission(String name) {
		this.name = name;
	}

	public void checkGuard(Object object) throws SecurityException {
	}

	public abstract boolean implies(Permission permission);

	public abstract boolean equals(Object obj);

	public abstract int hashCode();

	public final String getName() {
		return name;
	}

	public abstract String getActions();

	public String toString() {
		StringBuffer b = new StringBuffer();
		b.append('(');
		b.append(this.getClass().getName());
		b.append(' ');
		b.append(getName());
		b.append(' ');
		b.append(getActions());
		b.append(')');
		return new String(b);
	}
}

