@set JAVAC=jikes

@set CLASSPATH=%WIND_BASE%\host\java\lib\pj.jar

@set src_dir=..\..\..\src\libraries\javalib

@md java\awt > NUL

@echo converting standard AWT classes..
@sed -f mod1.sed  %src_dir%\java\awt\Toolkit.java > java\awt\Toolkit.java
@sed -f mod1.sed  %src_dir%\java\awt\Component.java > java\awt\Component.java
@sed -f mod1.sed  %src_dir%\java\awt\AWTEvent.java > java\awt\AWTEvent.java
@sed -f mod1.sed  %src_dir%\java\awt\Image.java > java\awt\Image.java
@sed -f mod1.sed  %src_dir%\java\awt\Font.java > java\awt\Font.java
@sed -f mod1.sed  %src_dir%\java\awt\FontMetrics.java > java\awt\FontMetrics.java
@sed -f mod1.sed  %src_dir%\java\awt\NativeClipboard.java > java\awt\NativeClipboard.java
@sed -f mod1.sed  %src_dir%\java\awt\NativeGraphics.java > java\awt\NativeGraphics.java
@sed -f mod1.sed  %src_dir%\java\awt\NativeDataProducer.java > java\awt\NativeDataProducer.java
@sed -f mod1.sed  %src_dir%\java\awt\NativeFileProducer.java > java\awt\NativeFileProducer.java
@sed -f mod1.sed  %src_dir%\java\awt\NativeImageProducer.java > java\awt\NativeImageProducer.java
@sed -f mod1.sed  %src_dir%\java\awt\NativeSelfProducer.java > java\awt\NativeSelfProducer.java
@sed -f mod1.sed  %src_dir%\java\awt\PiggybackProducer.java > java\awt\PiggybackProducer.java
@sed -f mod1.sed  %src_dir%\java\awt\ImageLoader.java > java\awt\ImageLoader.java

@echo converting no-native-wm AWT classes..
@sed -f mod2.sed  %src_dir%\java\awt\no-native-wm\Window.java > java\awt\Window.java
@sed -f mod2.sed  %src_dir%\java\awt\no-native-wm\Frame.java > java\awt\Frame.java
@sed -f mod2.sed  %src_dir%\java\awt\no-native-wm\Dialog.java > java\awt\Dialog.java
@sed -f mod2.sed  %src_dir%\java\awt\no-native-wm\RootWindow.java > java\awt\RootWindow.java
@sed -f mod2.sed  %src_dir%\java\awt\no-native-wm\ControlBox.java > java\awt\ControlBox.java
@sed -f mod2.sed  %src_dir%\java\awt\no-native-wm\MinBox.java > java\awt\MinBox.java

@del /S /Q lib > NUL
@md lib > NUL

@set classes0=%classes0% %src_dir%\kaffe\util\Ptr.java
@set classes0=%classes0% %src_dir%\kaffe\util\Timer.java
@set classes0=%classes0% %src_dir%\kaffe\util\TimerClient.java
@set classes0=%classes0% %src_dir%\kaffe\util\VectorSnapshot.java
@set classes0=%classes0% %src_dir%\kaffe\util\DoubleLinkedObject.java
@set classes0=%classes0% %src_dir%\kaffe\util\Queue.java
@set classes0=%classes0% %src_dir%\kaffe\util\NotImplemented.java
@set classes0=%classes0% %src_dir%\kaffe\util\log\LogClient.java
@set classes0=%classes0% %src_dir%\kaffe\util\log\LogStream.java
@set classes0=%classes0% %src_dir%\kaffe\io\AccessibleBIStream.java
@set classes0=%classes0% %src_dir%\kaffe\io\NullOutputStream.java
@set classes0=%classes0% %src_dir%\kaffe\net\URLConnectionWrapper.java
@set classes0=%classes0% java\lang\ref\WeakReference.java
@set classes0=%classes0% java\security\*.java
@set classes0=%classes0% kaffe\lang\Application*.java
@set classes0=%classes0% kaffe\management\Classpath*.java


@set classes1=%src_dir%\java\awt\*.java
@set classes1=%classes1% %src_dir%\kaffe\awt\*.java
rem @set classes1=%classes1% %src_dir%\kaffe\applet\*.java
@set classes1=%classes1% %src_dir%\kaffe\awt\no-native-wm\GoodStuff.java
@set classes1=%classes1% %src_dir%\java\applet\*.java
@set classes1=%classes1% %src_dir%\java\awt\datatransfer\*.java
@set classes1=%classes1% %src_dir%\java\awt\event\*.java
@set classes1=%classes1% %src_dir%\java\awt\image\*.java
@set classes1=%classes1% %src_dir%\java\awt\peer\*.java
@set classes1=%classes1% %src_dir%\java\awt\widgets\*.java
@set classes1=%classes1% %src_dir%\java\util\mime\*.java

@set classes2=java\awt\*.java
@set classes2=%classes2% %src_dir%\java\awt\no-native-wm\WinTaskBar.java
@set classes2=%classes2% %src_dir%\java\awt\no-native-wm\WindowTheme.java

@set classes3=%src_dir%\java\awt\GraphicsLink.java
@set classes3=%classes3% %src_dir%\java\awt\Component.java
@set classes3=%classes3% %src_dir%\java\awt\BarMenu.java


@echo Compiling utility classes..
@%JAVAC% -g -d lib -classpath lib;%CLASSPATH%  %classes0%

@echo Compiling standard AWT classes..
@%JAVAC% -g -d lib -classpath lib;%CLASSPATH% %classes1%

@echo Compiling no-native-wm and Ptr classes..
@%JAVAC% -g -d lib -classpath lib;%CLASSPATH% %classes2%

@echo Re-compiling Ptr client classes..
@%JAVAC% -g -d lib -classpath lib;%CLASSPATH% %classes3%

@echo copy font.properties into class lib..
@copy ..\..\..\src\libraries\clib\awt\no-native-wm\ugl\font.properties lib\java\awt

@del /Q awt.jar
@cd lib
@echo building awt.jar..
@zip -rq ..\awt.jar *
@cd ..
@echo installing awt.jar in host dir..
@copy awt.jar %WIND_BASE%\host\java\lib

@echo done.
