/*
 * config-std.h
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __config_std_h
#define __config_std_h

#if defined(HAVE_STDIO_H)
#include <stdio.h>
#endif
#include <stdlib.h>
#if defined(HAVE_ASSERT_H)
#include <assert.h>
#endif
#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif
#if defined(HAVE_SYS_TIME_H)
#include <sys/time.h>
#endif
#if defined(HAVE_SYS_TIMES_H)
/* pjo, 23 feb 2000 */
#include <sys/times.h>
#endif
#if defined(HAVE_SYS_TYPES_H)
#include <sys/types.h>
#endif
#if defined(HAVE_WINDOWS_H)
#include <windows.h>
#endif
#if defined(HAVE_WINDEF_H)
#include <windef.h>
#endif
#if defined(HAVE_WINNT_H)
#include <winnt.h>
#endif
#if defined(HAVE_WINTYPES_H)
#include <wintypes.h>
#endif
#if defined(HAVE_WTYPES_H)
#include <wtypes.h>
#endif
#if defined(HAVE_WINBASE_H)
#include <winbase.h>
#endif
#if defined(HAVE_BSD_LIBC_H)
#include <bsd/libc.h>
#endif

#undef	__NORETURN__
#if defined(__GNUC__)
#define	__NORETURN__ __attribute__((noreturn))
#else
#define	__NORETURN__
#endif

#if !defined(EXTERN_C)
#if defined(_cplusplus)
#define EXTERN_C extern "C"
#else
#define EXTERN_C extern
#endif
#endif

#endif
