/*
 * i386/vxworks/md.h
 * VxWorks i386 configuration information.
 *
 * Copyright (c) 1996, 1997, 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __i386_vxworks_md_h
#define __i386_vxworks_md_h

#include "i386/common.h"
#include "i386/threads.h"

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

#if !defined(EXTERN_C)
#define EXTERN_C extern
#endif

/* since we have no SEGV or DIV handler in VxWorks, check manually */
#define CREATE_NULLPOINTER_CHECKS 1
#define CREATE_DIVZERO_CHECKS 1

/*
 * We don't support UNIX style exceptions.
 */
#define	NO_UNIX_EXCEPTIONS	1

#endif
