/*
 * m68k/uclinux/jit-md.h
 * ucLinux m68k JIT configuration information.
 *
 * Copyright (c) 1999
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __m68k_uclinux_jit_md_h
#define __m68k_uclinux_jit_md_h

/**/
/* Include common information. */
/**/
#include "m68k/jit.h"

/**/
/* Define where addresses are returned.  */
/**/

#define M68K_RETURN_REF		REG_d0	/* d0 */

/*
 * uCLinux port uses the coldfire processor.
 */
#include "m68k/coldfire.h"

/*
 * Override the standard trampoline function.
 */
#define	TRAMPOLINE_FUNCTION()					\
  asm("								\
	.text							\n\
	.even							\n\
	.globl m68k_do_fixup_trampoline				\n\
m68k_do_fixup_trampoline					\n\
        jsr	soft_fixup_trampoline				\n\
        addql   #4,%sp						\n\
        movel   %d0,%a0						\n\
        jmp     (%a0)						\
  ");

#endif
