/*
 * This method *must* be inlined otherwise we end up fixing up
 * the wrong stack frame (ie. mine rather than my parents).
 */
inline
static
void
__mipsFixup(int npc, int nfp)
{
	int* pc;
	int* fp;

here:;
	asm("move %0,$fp" : "=r" (fp));

	/* Walk backwards down the code looking for where the return
	 * pc is stored.
	 */
	for (pc = &&here;; pc--) {
		unsigned short high = (unsigned short)((*pc) >> 16);
		short low = (short)*pc;
		if (high == 0xafbf) {	/* sw $ra,i($sp) */
			fp[low / sizeof(int)] = npc;
			break;
		}
	}

	/* Walk backwards down the code looking for where we stored the
	 * previous frame pointer.
	 */
	for (pc = &&here;; pc--) {
		unsigned short high = (unsigned short)((*pc) >> 16);
		short low = (short)*pc;
		if (high == 0xafbe) {	/* sw $fp,i($sp) */
			fp[low / sizeof(int)] = nfp;
			break;
		}
	}
}
