/*
 * sparc/sunos4/md.h
 * SunOS4 sparc configuration information.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __sparc_sunos_md_h
#define __sparc_sunos_md_h

#include "sparc/common.h"
#include "sparc/threads.h"

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

/* SunOS has some missing prototypes - so put them here
 * This is a bit of a hack really and we should work this out magically.
 */

#ifndef __P
#if defined(__STDC__) || defined(__cplusplus)
#define __P(p)     p
#else
#define __P(p)     ()
#endif
#endif

int	rename __P((char *, char *));
int	remove __P((char *));
int	sendto __P((int, char *, int, int, struct sockaddr *, int));
int	socket __P((int, int, int));
int	setsockopt __P((int, int, int, char *, int *));
int	getsockopt __P((int, int, int, char *, int));
int	getsockname __P((int, struct sockaddr *, int *));
int	getpeername __P((int, struct sockaddr *, int *));
int	select __P((int, fd_set *, fd_set *, fd_set *, struct timeval *));

#endif
