/*
 * Configuration header for JNI includes.
 * 
 * We ship a configured as well as unconfigured (.in) version of this header
 * so that people can include jni.h from an unconfigured kaffe source tree.
 * The default one assumes the presence of malloc.h and stdio.h.
 *
 * Copyright (c) 1996, 1997, 1998, 1999
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: jconfig.h,v 1.1 2001/08/15 20:35:07 samc Exp $
 */

#ifndef __jconfig_h
#define __jconfig_h

#define HAVE_STDIO_H 1
#define HAVE_MALLOC_H 1

#endif
