/*
 * Definitions for this system.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: system.h,v 1.9 2001/07/09 22:43:00 samc Exp $
 */

#ifndef __system_h
#define __system_h

#define	java_version		"1.2"
#define	kaffe_version		KAFFEVERSION
#define	kaffe_vendor		"Transvirtual Technologies, Inc."
#define	kaffe_vendor_url	"http://www.transvirtual.com"
#define	kaffe_class_version	"1"

#if defined(__WIN32__) || defined(__OS2__) || defined(MSDOS)
#define	file_separator		"\\"
#define	path_separator		";"
#define	line_separator		"\r\n"
#define drive_spec          "*:\\"

#define IS_FSEPARATOR(_c)  ((_c=='\\') || (_c=='/'))

#elif defined(__amigaos__)
#define	file_separator		"/"
#define	path_separator		";"
#define	line_separator		"\n"

#define IS_FSEPARATOR(_c)  (_c== '/')

#else
/* We default to 'unix' like ones */
#define	file_separator		"/"
#define	path_separator		":"
#define	line_separator		"\n"

#define IS_FSEPARATOR(_c)  (_c== '/')
#endif

#define	KAFFEHOME		"KAFFEHOME"
#define	KAFFECLASSPATH		"CLASSPATH"

#endif
