/*
 * file.h
 * File support routines.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __file_h
#define __file_h

#define	readbyte(f)	(*(f->data++))

#define	readu1(c, f)	((*(c)) = readbyte(f))
#define	readu2(c, f)	((*(c)) = readbyte(f) << 8, (*c) |= readbyte(f))
#define	readu4(c, f)	((*(c)) = readbyte(f) << 24, (*c) |= readbyte(f) << 16, (*c) |= readbyte(f) << 8, (*c) |= readbyte(f))

#endif
