/*
 * Handle method calls to other languages.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: external.h,v 1.11 2001/08/17 04:59:43 tim Exp $
 */

#ifndef __external_h
#define __external_h

#define	MAXLIBS		16

struct _methods;
struct Hjava_lang_Class;
struct Hjava_lang_ClassLoader;
JNIEXPORT char* realLibraryPath;

JNIEXPORT void	JNICALL initNative(void);
JNIEXPORT char*	JNICALL loadNativeLibrary(char*, struct Hjava_lang_ClassLoader*);
JNIEXPORT void	JNICALL unloadNativeLibraries(struct Hjava_lang_ClassLoader*);
JNIEXPORT void	JNICALL native(struct _methods*, struct Hjava_lang_Class*);
JNIEXPORT void	JNICALL addNativeFunc(char*, void*);
JNIEXPORT int   JNICALL checkNativeCall(Method*, struct Hjava_lang_Class*);

#endif /* __external_h */
