/*
 * consts.h
 *
 * Copyright (c) 1999 - 2001 
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __consts_h
#define __consts_h

typedef struct _const_info {
	int16			index;
        uint8			type;
	constant_info		val;
        struct _const_info *	next;
        struct {
		Method * 	method;
        } aux;
} const_info;

extern const_info * CONST_lookup( cfg_info *, expr * );
extern void CONST_generate_all( cfg_info * );
extern void CONST_done( cfg_info * );

#endif

