/*
 * env-mips.h
 *
 * Copyright (c) 1999 - 2001
 *      Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#define SE_negative		0x40000000
#define SE_reserved		0x80000000
#define SE_imm16		0x400000
#define SE_imm			SE_imm16
#define USE_SOFT_LONG 		1
#define USE_RISC_LDST		1
#define INSTALL_CODE		1
#define HAS_DELAYSLOT		1
#define USE_CONSTANT_TABLE      1 /* Disabling will break tableswitch/lookupswitch */
#define FRAME_ALIGNMENT		4 /* words */
#define DWORD_ALIGN( _v, _a)	ALIGN_VALUE( _v, _a )
#define USE_DWORD_LDST		1
#define	R_fp			30
#define ENABLE_COUNTER		1

#define NUM_REGS 		64
#define SCH_AUX_REGS 		4

/* FP Registers */
#define FR( _e )		(_e)->loc.reg.base - 32
#define FR_L( _e )		(_e)->loc.reg.base - 32
#define FR_H( _e )		(_e)->loc.reg.pair - 32

#define cbranch_eq_func( _f, _a )	_f##cbranch##_a
#define cbranch_ne_func( _f, _a )	_f##cbranch##_a
#define cbranch_lt_func( _f, _a )	_f##cc_cbranch##_a
#define cbranch_ge_func( _f, _a )	_f##cc_cbranch##_a
#define cbranch_gt_func( _f, _a )	_f##cc_cbranch##_a
#define cbranch_le_func( _f, _a )	_f##cc_cbranch##_a
#define cbranch_ult_func( _f, _a )	_f##cc_cbranch##_a

