/*
 * reduce.h
 *
 * Copyright (c) 1999 - 2001 
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __reduce_h
#define __reduce_h

#define CSE_TERMINATE 0x1

typedef expr * (*cseFunc)( expr *, expr **, instr_block *, boolean );
typedef void (*cpFunc)( expr * );
typedef boolean (*loopFunc)( instr_block * blk, expr *, loop_info * );
extern cpFunc CP_funcs[];
extern cpFunc PP_funcs[];
extern cseFunc CSE_funcs[];
extern loopFunc LOOP_funcs[];
extern expr * CSE_call( expr *, expr **, instr_block *, boolean );
extern expr * CSE_const( expr *, expr **, instr_block *, boolean );

#endif
