/*
 * throw.h
 *
 * Copyright (c) 1999 - 2001 
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __throw_h
#define __throw_h

typedef struct _throw_info {
        struct _throw_info *	next;
        uint8 *			where;
	uint			length;
	uint8			buffer[1];
} throw_info;

extern throw_info * TRW_new( struct _cfg_info *, struct _instr_block *, struct _label_info * );
extern void TRW_generate_all( struct _cfg_info * );
extern void TRW_done( struct _cfg_info * );

#endif
