/*
 * Java Native Interface - internal references
 *
 * Copyright (c) 1996 - 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * $tvt: jnidefs.h,v 1.2 2001/08/15 19:54:21 samc Exp $
 */

#ifndef __jnidefs_h
#define __jnidefs_h

struct Hjava_lang_Throwable;
struct _stackTraceInfo;

extern jmethodID Kaffe_GetMethodID(JNIEnv* env, jclass cls, const char* name, const char* sig);

extern jobject Kaffe_NewObject(JNIEnv* env, jclass cls, jmethodID meth, ...);
extern jstring Kaffe_NewStringUTF(JNIEnv* env, const char* data);
extern jobject Kaffe_AllocObject(JNIEnv* env, jclass cls);

extern void Kaffe_CallVoidMethod(JNIEnv* env, jobject obj, jmethodID meth, ...);
extern jobject Kaffe_CallObjectMethod(JNIEnv* env, jobject obj, jmethodID meth, ...);

extern void Kaffe_JNIExceptionHandler(struct _stackTraceInfo*, struct Hjava_lang_Throwable*);

#endif /* __jnidefs_h */
