/*
 * Copyright (c) 1996 - 2001
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: strings.h,v 1.5 2001/08/21 07:28:20 tim Exp $
 */

#ifndef __strings_h
#define	__strings_h

#include "config.h"

JNIEXPORT char* addUtf(char* data);
JNIEXPORT char* addUtfCopy(char* data, int len);
JNIEXPORT void rmUtf(char* data);

struct Hjava_lang_String;

JNIEXPORT void initStrings(void);

JNIEXPORT struct Hjava_lang_String* JNICALL internJavaString(struct Hjava_lang_String*);
JNIEXPORT void JNICALL uninternJavaString(struct Hjava_lang_String*);

JNIEXPORT struct Hjava_lang_String* JNICALL makeReplaceJavaStringFromUtf(char*, int len, int search, int replace);

#define	UTF_REPLACE(TO, FROM, SEARCH, REPLACE)				\
	(TO) = alloca(strlen(FROM) + 1);				\
	{								\
		int i;							\
		int l = strlen(FROM);					\
		for (i = l - 1; i >= 0; i--) {				\
			if (((FROM)[i]) == (SEARCH)) {			\
				(TO)[i] = (REPLACE);			\
			}						\
			else {						\
				(TO)[i] = (FROM)[i];			\
			}						\
		}							\
		(TO)[l] = 0;						\
	}

#define	STRING_SIZE(STR) (unhand(STR)->count)
#define	STRING_HASH(STR) (unhand(STR)->hash)
#define	STRING_DATA(STR) (&(unhand(unhand(STR)->value)->body[unhand(STR)->offset]))

#endif /* __strings_h */
