/**
 * cbd.c - clipboard handling  (just a dummy for stand-alone AWTs - there are
 *      no external owners, and everything can be done in Java)
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "toolkit.h"


/*
 * This is just a dummy module - in a no-native-wm environment, there
 * is no desktop-related IPC
 */

typedef void ClipBoard;

jobject
EXPORT(cbdInitClipboard) ( JNIEnv* env, jclass clazz )
{
  return 0;
}

void
EXPORT(cbdFreeClipboard) ( JNIEnv* env, jclass clazz, ClipBoard* cbd )
{
}

jboolean
EXPORT(cbdSetOwner) ( JNIEnv* env, jclass clazz, ClipBoard* cbd )
{
  return 1;
}

jobject
EXPORT(cbdGetContents) ( JNIEnv* env, jclass clazz, ClipBoard* cbd )
{
  return 0;
}
