/**
 * vk_constants.h - java.awt.event.KeyEvent constants
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#define VK_ENTER		 '\n'
#define VK_BACK_SPACE	 '\b'
#define VK_TAB		     '\t'
#define VK_CANCEL		 0x03
#define VK_CLEAR		 0x0C
#define VK_SHIFT		 0x10
#define VK_CONTROL		 0x11
#define VK_ALT		     0x12
#define VK_PAUSE		 0x13
#define VK_CAPS_LOCK	 0x14
#define VK_ESCAPE		 0x1B
#define VK_SPACE		 0x20
#define VK_PAGE_UP		 0x21
#define VK_PAGE_DOWN	 0x22
#define VK_END		     0x23
#define VK_HOME		     0x24
#define VK_LEFT		     0x25
#define VK_UP		     0x26
#define VK_RIGHT		 0x27
#define VK_DOWN		     0x28
#define VK_COMMA		 0x2C
#define VK_PERIOD		 0x2E
#define VK_SLASH		 0x2F
#define VK_0		     0x30
#define VK_1		     0x31
#define VK_2		     0x32
#define VK_3		     0x33
#define VK_4		     0x34
#define VK_5		     0x35
#define VK_6		     0x36
#define VK_7		     0x37
#define VK_8		     0x38
#define VK_9		     0x39
#define VK_SEMICOLON	 0x3B
#define VK_EQUALS		 0x3D
#define VK_A		     0x41
#define VK_B		     0x42
#define VK_C		     0x43
#define VK_D		     0x44
#define VK_E		     0x45
#define VK_F		     0x46
#define VK_G		     0x47
#define VK_H		     0x48
#define VK_I		     0x49
#define VK_J		     0x4A
#define VK_K		     0x4B
#define VK_L		     0x4C
#define VK_M		     0x4D
#define VK_N		     0x4E
#define VK_O		     0x4F
#define VK_P		     0x50
#define VK_Q		     0x51
#define VK_R		     0x52
#define VK_S		     0x53
#define VK_T		     0x54
#define VK_U		     0x55
#define VK_V		     0x56
#define VK_W		     0x57
#define VK_X		     0x58
#define VK_Y		     0x59
#define VK_Z		     0x5A
#define VK_OPEN_BRACKET	 0x5B
#define VK_BACK_SLASH	 0x5C
#define VK_CLOSE_BRACKET 0x5D
#define VK_NUMPAD0		 0x60
#define VK_NUMPAD1		 0x61
#define VK_NUMPAD2		 0x62
#define VK_NUMPAD3		 0x63
#define VK_NUMPAD4		 0x64
#define VK_NUMPAD5		 0x65
#define VK_NUMPAD6		 0x66
#define VK_NUMPAD7		 0x67
#define VK_NUMPAD8		 0x68
#define VK_NUMPAD9		 0x69
#define VK_MULTIPLY		 0x6A
#define VK_ADD		     0x6B
#define VK_SEPARATER	 0x6C
#define VK_SUBTRACT		 0x6D
#define VK_DECIMAL		 0x6E
#define VK_DIVIDE		 0x6F
#define VK_F1		     0x70
#define VK_F2		     0x71
#define VK_F3		     0x72
#define VK_F4		     0x73
#define VK_F5		     0x74
#define VK_F6		     0x75
#define VK_F7		     0x76
#define VK_F8		     0x77
#define VK_F9		     0x78
#define VK_F10		     0x79
#define VK_F11		     0x7A
#define VK_F12		     0x7B
#define VK_DELETE		 0x7F
#define VK_NUM_LOCK		 0x90
#define VK_SCROLL_LOCK	 0x91
#define VK_PRINTSCREEN	 0x9A
#define VK_INSERT		 0x9B
#define VK_HELP		     0x9C
#define VK_META		     0x9D
#define VK_BACK_QUOTE	 0xC0
#define VK_QUOTE		 0xDE
#define VK_FINAL		 0x18
#define VK_CONVERT		 0x1C
#define VK_NONCONVERT	 0x1D
#define VK_ACCEPT		 0x1E
#define VK_MODECHANGE	 0x1F
#define VK_KANA		     0x15
#define VK_KANJI		 0x19
#define VK_UNDEFINED	 0x0
