/*
 * kaffe.lang.Application.c
 *
 * Copyright (c) 1996, 1997, 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "../../../kaffe/kaffevm/gtypes.h"
#include <jni.h>
#include "../../../kaffe/kaffevm/engine.h"
#include "../../../kaffe/kaffevm/classMethod.h"
#include "../../../kaffe/kaffevm/support.h"

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

/*
 * This is a last resort in case we need output before the System streams
 * are initialized
 */
JNIEXPORT void JNICALL
Java_kaffe_lang_Application_debug(JNIEnv* env, jclass clazz, jstring str)
{
	const char* s = (*env)->GetStringUTFChars(env, str, 0);
	kprintf("%s\n", s);
	(*env)->ReleaseStringUTFChars(env, str, s);
}
