/*     
 * java.lang.reflect.Array.c
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include "../../../kaffe/kaffevm/objects.h"
#include "../../../kaffe/kaffevm/classMethod.h"
#include <jni.h>
#include "../../../kaffe/kaffevm/soft.h"
#include "defs.h"

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

JNIEXPORT jint JNICALL
Java_java_lang_reflect_Array_getLength(JNIEnv* env, jobject array)
{
	return ((*env)->GetArrayLength(env, array));
}


JNIEXPORT jobject JNICALL
Java_java_lang_reflect_Array_newObjectArray0(JNIEnv* env, jclass clazz, jclass this, jint size)
{
	return ((*env)->NewObjectArray(env, size, this, 0));
}
