/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package java.net;

import java.lang.String;

public class URLEncoder
{
private URLEncoder() {}
    
public static String encode(String s) {
	StringBuffer result = new StringBuffer();
        try
         { 
           byte b[] = s.getBytes("UTF8");
           for (int pos = 0; pos <b.length; pos++) {
               char chr = (char)(b[pos] & 0x00ff);
               if ((chr >= 'A' && chr <= 'Z') ||
                   (chr >= 'a' && chr <= 'z') ||
                   (chr >= '0' && chr <= '9') ||
                   chr == '.' ||
		    chr == '-' ||
		    chr == '*' ||
                    chr == '_') {
                    result.append(chr);
               }
               else if (chr == ' ') {
                   result.append('+');
               }
               else {
                   result.append('%' + ((int)chr < 16 ? "0" : "") + Integer.toString((int)chr, 16));
               }
           }
         }
        catch (java.io.UnsupportedEncodingException uee)
          {
          }
        return result.toString();
}
}
