/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: UnsupportedAudioFileException.java,v 1.2 2001/11/20 21:17:57 samc Exp $ 
 */
package javax.sound.sampled;

/**
 * An UnsupportedAudioFileException is an exception indicating that
 * an operation failed because a file did not contain valid data of a
 * recognized file type and format.
 */
public class UnsupportedAudioFileException 
  extends Exception
{
  public UnsupportedAudioFileException (String message)
  {
    super (message);
  }

  public UnsupportedAudioFileException ()
  {
    super ();
  }
}
