package kaffe.awt.dialogs;

import java.awt.Font;
import java.awt.Frame;

public class DialogTest
  extends Frame
{
public DialogTest() {
	super( "DialogTest");
	setBounds( 100, 100, 500, 500);
	setVisible( true);
}

public static void main( String[] args) {
	DialogTest dt = new DialogTest();
	
	dt.runFontDialog();
	dt.runTextPrompter();
	dt.runMessageBox();
	dt.runPasswordPrompter();
	
	dt.dispose();
}

void runFontDialog() {
	Font f = FontDialog.prompt( "FontDialog", 6, 15, this);
	System.out.println( "you selected: " + f);
}

void runMessageBox() {
	String s = "This is a quite\nlong text\n" +
	"this line might even be too long to fit in one\n" +
	"another break. Ok?";

//	notify( "This is a big one", fr);
//	System.out.println( confirm( "Are you sure ?", fr));

	MessageBox mb = new MessageBox( "MessageBox", s, "Yes,Maybe,Never", this);
	mb.process();

	System.out.println( "selected index: " + mb.getSelectionIdx() );
}

void runPasswordPrompter() {
	PasswordPrompter pp = new PasswordPrompter( "Prompter", "please enter your username and password", "user", this);
	pp.process();
	System.out.println( "username: " + pp.getUsername() );
	System.out.println( "pasword: " + pp.getPassword() );
	
//	String s = PasswordPrompter.prompt( "Prompter", "your authorization:", "", this);
//	System.out.println( "you entered: " + s);
}

void runTextPrompter() {
//	String s = TextPrompter.prompt( "Prompter", null, "stuff", this);
	String s = TextPrompter.prompt( "Prompter", "Enter your stuff:", "stuff", this);
	System.out.println( "you entered: " + s);
}
}
