package kaffe.awt.doc;

import java.awt.Button;
import java.awt.Font;
import java.awt.event.ActionListener;
import org.w3c.dom.*;

public class DocButton
  extends DocWidget
{
	Button btn;

public DocButton() {
	btn = new Button();
	add(btn);
}

public void setAttributeNS(String namespaceURI, String localName, String value) {
	if ( localName.equalsIgnoreCase( "label") ) {
		setLabel(value);
	}
	else {
		super.setAttributeNS( namespaceURI, localName, value);
	}
}

public void setLabel( String label){
	btn.setLabel( label);
}

void setLink(String link) {
	super.setLink(link);
	btn.addMouseListener(LinkListener.getInstance());
}
}
