package kaffe.awt.theme;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Scrollbar;

public interface ScrollbarDeco
{
public int getAdjustmentCode( Scrollbar s, int offs, int len, int jOffs, int jLen);

public int getJewelExtent( Scrollbar s, int w, int pgInc, int range);

public Dimension getPreferredSize( Scrollbar s);

public Rectangle getRailArea( Scrollbar s, Rectangle r);

public void paintArrows( Scrollbar s, Graphics g, int w, int h, int state);

public void paintJewel( Scrollbar s, Graphics g, int x, int y, int w, int h, boolean tracking);

public void paintRail( Scrollbar s, Graphics g, int x, int y, int w, int h);
}
