package kaffe.awt.theme;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import kaffe.awt.Defaults;

public class SimpleChoiceDeco
  extends SimpleComponentDeco
{
SimpleChoiceDeco () {
	super( Color.lightGray, null, null);
	
	insets.left = 0;
	insets.right = Defaults.ChoiceBtnWidth + 2*Defaults.WidgetBorderWidth;;
	insets.top = 0;
	insets.bottom = 0;
}

public void paintBorder( Component c, Graphics g, int x, int y, int w, int h, int state) {
	boolean active = ((state & CS_ACTIVE) > 0);
	int db = Defaults.WidgetBorderWidth;
	int x0, y0;
	
	g.setColor( ((state & CS_CURSOR_OVER) > 0) ? Defaults.BtnPointClr : Defaults.BtnClr);
	g.fill3DRect (x+ w-insets.right+db, y+db, insets.right-2*db, h-2*db, !active );

	//draw button marker
	x0 = x + w - insets.right/2;
	y0 = y + h - (h-7)/2;
	g.setColor( Color.white);
	g.drawLine( x0, y0, x0-3, y0-7);
	g.drawLine( x0, y0, x0+3, y0-7);
	x0--;
	g.setColor( ((state & CS_CURSOR_OVER) > 0) ? Defaults.FocusClr : Color.black);
	g.drawLine( x0, y0, x0-3, y0-7);
	g.drawLine( x0, y0, x0+3, y0-7);
	
	//draw non focus border around button
	g.setColor( Defaults.BtnClr);
	x0 = x + w - insets.right;
	g.draw3DRect( x0, y,  insets.right-1, h-1, true);
	g.draw3DRect( x0+1, y+1, insets.right-3, h-3, false);
}
}
