package com.transvirtual.net.www.protocol.ehttp.server;

public class WebMimeTypes {

static private String[] map = new String[]{

	".html",	"text/html",
	".htm",		"text/html",
	".txt",		"text/plain",
	".gif",		"image/gif",
	".jpeg",	"image/jpeg",
	".jpe",		"image/jpeg",
	".jpg",		"image/jpeg",
	".png",		"image/png",

};

static public String getContentTypeFor(String filename) {
	int len = filename.length();
	int mlen = map.length;
	for (int i = 0; i < mlen; i += 2) {
		String match = map[i];
		int matchlen= map[i].length();
		if (filename.regionMatches(true, len-matchlen, match, 0, matchlen)) {
			return (map[i+1]);
		}
	}
	// Default
	return ("text/plain");
}

}
