package com.transvirtual.net.www.protocol.ehttp.server;

import java.io.*;
import javax.servlet.*;

class WebOutputStream extends ServletOutputStream {

private ByteArrayOutputStream buffer;

WebOutputStream() {
	buffer = new ByteArrayOutputStream();
}

int size() {
	return (buffer.size());
}

void writeTo(OutputStream strm) throws IOException {
	buffer.writeTo(strm);
}

void reset() {
	buffer.reset();
}

public void write(byte[] data, int off, int len) throws IOException {
	buffer.write(data, off, len);
}

public void write(int data) throws IOException {
	buffer.write(data);
}

}
