import kaffe.lang.ref.*;

public class RecycleTest extends Thread {

static Object obj;

public RecycleTest () {
}

static class RObject implements Recycleable {
	public RObject() {
	}

	public void recycle() {
		System.out.println("Got recycled");
		obj = this;
	}

	protected void finalize () {
		System.out.println("Got finalized");
	}
}

public void run() {
        RObject o = new RObject();
	kaffe.lang.ref.Recycle.add(o);
}
  
public static void main ( String[] args ) throws Throwable {
	Thread t = new RecycleTest();
	t.start();
	t.join();

	System.out.println("run gc");
        System.gc();
        
	System.out.println("run finalize");
	System.runFinalization();

	System.out.println("done");
}

}

/* Expected Output:
run gc
Got recycled
run finalize
done
*/
