#include <fgl.h>

u32 spd_cmap[] = {
	0x000000,
	0xffff00,
	0xff0000
};

u8 spd_data2[] = {
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,2,1,2,2,2,2,2,2,2,2,2,2,1,0,0,0,
1,2,1,2,2,2,2,2,2,1,1,1,1,0,0,0,0,
1,2,1,2,2,2,2,1,1,0,0,0,0,0,0,0,0,
1,2,1,2,2,2,2,1,0,0,0,0,0,0,0,0,0,
1,2,1,2,2,1,1,2,1,0,0,0,0,0,0,0,0,
1,2,1,2,2,1,0,1,2,1,0,0,0,0,0,0,0,
1,2,1,2,1,0,0,0,1,2,1,0,0,0,0,0,0,
1,2,1,2,1,0,0,0,0,1,2,1,0,0,0,0,0,
1,2,1,2,1,0,0,0,0,0,1,2,1,0,0,0,0,
1,2,1,2,1,0,0,0,0,0,0,1,2,1,0,0,0,
1,2,1,1,0,0,0,0,0,0,0,0,1,2,1,0,0,
1,2,1,0,0,0,0,0,0,0,0,0,0,1,2,1,0,
1,2,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,
1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

u8 spd_data1[] = {
   
	1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	1,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,1,2,2,1,1,0,0,0,0,0,0,0,0,0,0,0,
	0,1,2,2,2,2,1,1,0,0,0,0,0,0,0,0,0,
	0,0,1,2,2,2,2,2,1,1,0,0,0,0,0,0,0,
	0,0,1,2,2,2,2,2,2,2,1,1,0,0,0,0,0,
	0,0,0,1,2,2,2,2,2,2,2,2,1,1,0,0,0,
	0,0,0,1,2,2,2,2,2,2,2,2,2,2,1,0,0,
	0,0,0,0,1,2,2,2,2,2,2,2,1,1,0,0,0,
	0,0,0,0,1,2,2,2,2,2,1,1,0,0,0,0,0,
	0,0,0,0,0,1,2,2,2,1,2,1,0,0,0,0,0,
	0,0,0,0,0,1,2,2,2,1,1,2,1,0,0,0,0,
	0,0,0,0,0,0,1,2,1,0,0,1,2,1,0,0,0,
	0,0,0,0,0,0,1,2,1,0,0,0,1,2,1,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,1,2,1,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

fgl_spriteData_t spd1 = {
	17, 17,                                   /* width, height */
	0, 0,                                     /* xh0t, yh0t */
	3, 0,                                     /* nC0l0rs, transp */
	spd_cmap,
	spd_data1
};

fgl_spriteData_t spd2 = {
	17, 17,                                   /* width, height */
	0, 0,                                     /* xh0t, yh0t */
	3, 0,                                     /* nC0l0rs, transp */
	spd_cmap,
	spd_data2
};

void sprite_test ( fgl_context_t *gc, int ox, int oy, int os )
{
	int i, l;
        
        
	fgl_sprite_t *sp1 = fgl_createSprite( &spd1 );
	fgl_sprite_t *sp2 = fgl_createSprite( &spd2 );
        fgl_setCursor ( sp1 );

        //fgl_PServerInit ();
	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillRect( gc, ox+20, oy+80, ox+280, oy+120);
	fgl_setColor( gc, fgl_clrOrange);
	fgl_fillRect( gc, ox+20, oy+100, ox+280, oy+120);
	fgl_setColor( gc, fgl_clrRed);
	fgl_fillRect( gc, ox+150, oy+80, ox+280, oy+120);

        fgl_moveCursor( ox+30, oy+92);
	fgl_showCursor();


	for ( i=30; i<142; i++ ){
	  fgl_moveCursor( ox+i, oy+92);
	  for ( l=1000000/os; l; l-- );
	}
        //fgl_hideCursor();
        fgl_setCursor ( sp2 );
        //fgl_showCursor();
        fgl_setColor( gc, fgl_clrGreen);
        fgl_fillRect( gc, ox+20, oy+80, ox+280, oy+120);

	for ( i=142; i<270; i++ ){
	  fgl_moveCursor( ox+i, oy+92);
	  for ( l=1000000/os; l; l-- );
	}
}

int main ( int argc, char* argv[] ) /*{{{*/
{   
	int i=1, stop=0;
	fgl_context_t *gc;
	int ox,oy,os,c;
        int rot = 0;

	ox = 0;
	oy = 0;
        os = 1;

	if ( argc >= 1 ){
	  for(c = 1;c<argc;c++) {
	 
	    if(strcmp(argv[c],"-h")==0) {
	      fprintf(stderr,"usage: tfgl001 <-x x_offset> <-y y_offset> <-t test>\n");
	      fprintf(stderr,"               <-s speed> <-h>\n");
	      exit(0);
	    }
	    if(strcmp(argv[c],"-x")==0) ox  = atoi( argv[c+1]);
	    if(strcmp(argv[c],"-y")==0) oy  = atoi( argv[c+1]);
	    if(strcmp(argv[c],"-o")==0) rot = atoi( argv[c+1]);
	    if(strcmp(argv[c],"-s")==0) os  = atoi( argv[c+1]);
	  }
	}

	if ( !fgl_init( 0, 0, 0) ){
		puts( "ab0rting..");
		return 1;
	}
        fgl_setScreenRotation(rot);
        fgl_setLocale("jp");
	gc = fgl_getContext( fgl_screenBmp);

		fgl_setColor( gc, fgl_clrBlack);
		fgl_clear( gc);
                sprite_test ( gc, ox, oy, os );

	fgl_terminate();

	return 1;
}
