/* -*- mode: C; mode: fold -*- */ 

#include "fgl.h"
#define TEST 4
#define SIZE 37

int main ( int argc, char* argv[] ) /*{{{*/
{
  fgl_slc_t *src[TEST];
  int i,test,error[TEST];
  fgl_color_t test_value = 0xfabc;

  src[0] = (fgl_slc_t *)malloc((SIZE+4)*sizeof(u32));

  /* set the test cases */

  /* run test 0 */

  for(test = 0; test < TEST; test++ ) {
    
    for( i = 0; i < SIZE+4 ; i++ ) {
      src[0][i] = 0;
    }

    src[test] = src[0] + test;

    fgl_setSlcCols(src[test],0,SIZE,test_value);
    error[test] = 0;


    for( i = 0; i < SIZE ; i++ ) {
      if ( src[test][i] != test_value) error[test]++;
    }
    
    if (error[test] ) {
      fprintf(stderr,"TEST (%i) ALIGNMENT (%2lx) ERRORS  (%i)\n",
	      test,(unsigned long)src[test]%8,error[test]);
      for( i = 0; i < SIZE ; i++ ) {
	printf("%4x: %4x\n",i,src[test][i]);
      }
      
    }
    else {
      fprintf(stderr,"TEST (%i) ALIGNMENT (%2lx) SUCCESS (%i)\n",
	      test,(unsigned long)src[test]%8,error[test]);
    }
  }

  free(src[0]);

  return 1;
}
/*}}}*/
