/* -*- mode: C; mode: fold -*- */ 

#include "fgl.h"
#include <sys/timeb.h>
#include <unistd.h>

#define TEST 4
#define SIZE 200
#define VERIFY 100000

int main ( int argc, char* argv[] ) /*{{{*/
{

  fgl_slc_t *src[TEST];
  int v,s,test;
  fgl_color_t test_value = 0xfabc;
  struct timeb start,end;
  float time;

  src[0] = (fgl_slc_t *)malloc((SIZE+4)*sizeof(u32));

  /* set the test cases */

  /* run test 0 */

  ftime(&start);
  for (test = 0; test < TEST; test++ ) {    
    src[test] = src[0] + test;  
    for (s = 1; s < SIZE ; s++) {
      for (v = 0; v <VERIFY ;v ++) {
	fgl_setSlcCols(src[test],0,s,test_value);
      }
    }
  }
  ftime(&end);
  time = end.time - start.time + (end.millitm - start.millitm)/1000.0;
  
  fprintf(stderr,"MS TEST TIME (%8.3f)\n",time);

  free(src[0]);

  return 1;
}
/*}}}*/
