#!/bin/sh
#
# Shell script that should be run to generate all the initial makefile.
# This script calls the generic autogen.sh in the 'macros' module.
#
# $tvt: autogen.sh,v 1.4 2001/11/21 22:02:53 samc Exp $

srcdir=`dirname $0`
test -z "$srcdir" && srcdir=.

MACROS=$srcdir/macros
ACLOCAL_FLAGS="-I $MACROS"
RUN_AUTOHEADER=1

. $MACROS/autogen.sh $*
