/*
 * accel.h - fgl acceleration module
 * 
 * Copyright (c) 2000, 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 *
 * 07/18/01 Damian Kowalewski 
 */

#ifndef FGL_ACCEL_INCLUDED
#define FGL_ACCEL_INCLUDED

#include "libfgl.h"
#include "../include/fgl.h"

#define IMAGE_ON_SCREEN 4 
#define FGL_ACCEL_DRAWLINE_OP 10

#ifdef USE_ACCEL
        
void (*fgl_accel_init)( ) = 0;

void (*fgl_accel_drawHLine)( fgl_context_t*, int, int, int ) = 0;
void (*fgl_accel_drawVLine)( fgl_context_t*, int, int, int ) = 0;
void (*fgl_accel_drawLine)( fgl_context_t*, int, int, int, int ) = 0;

#endif /* USE_ACCEL */

#endif /* FGL_ACCEL_INCLUDED */

