/*
 * rect.c - fgl module to draw and fill rectangles
 * 
 * Copyright (c) 2000, 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 */

#include "rect.h"

void fgl_drawRect ( fgl_context_t *ctx,	i32 x0, i32 y0, i32 x1, i32 y1 ) 
{
  _fgl_drawRect ( ctx, x0, y0, x1, y1 );
}

void fgl_fillRectClr ( fgl_context_t *ctx, i32 x0, i32 y0,  i32 x1, i32 y1, fgl_color_t clr ) 
{
	_fgl_fillRectClr ( ctx, x0, y0, x1, y1, clr );
}

void fgl_fillRect ( fgl_context_t *ctx, i32 x0, i32 y0, i32 x1, i32 y1 ) 
{
	_fgl_fillRectClr ( ctx, x0, y0, x1, y1, ctx->clr );
}
