package com.pocketlinux.awt.theme;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import kaffe.awt.*;

public class Deco11I
  extends StyleComponentDeco
{
	final private static String[] filenames = new String[]{
	"topleft.gif",
	"topmiddle.gif",
	"topright.gif",
	"middleleft.gif",
	"middlemiddle.gif",
	"middleright.gif",
	"bottomleft.gif",
	"bottommiddle.gif",
	"bottomright.gif",
	"arrowdown.gif",
	"arrowup.gif",
};
	private int i5w;
	private int i9w;
	private int i9h;

public Deco11I(Style style, String widgetname) {
	super(style, widgetname, filenames);
}

public boolean hasBackgroundImage() {
	return (true);
}

public boolean paintBackground( Component c, Component p, Graphics g, int cx, int cy, int cw, int ch, int x, int y, int w, int h, int xOff, int yOff, int state) {
	if (c instanceof java.awt.Choice) {
		AWT.extension.drawBorder( g, x, y, w, h, Theme.ALIGN_OUTER, images[0], images[1], images[2], images[3], images[5], images[6], images[7], images[8] );
		AWT.extension.drawBackground( g, cx, cy, cw + i5w + i9w, ch, x, y, w, h, xOff, yOff, images[4], null, Theme.FILL_TILE);
		g.drawImage(images[9], w - insets.right + i5w, (h - i9h) / 2, null);
	}
	else {
		AWT.extension.drawBackground( g, cx, cy, cw, ch, x, y, w, h, xOff, yOff, images[4], null, Theme.FILL_TILE);
	}
	return true;
}

public void reload() {
	super.reload();
	i5w = images[5].getWidth(null);
	i9w = images[9].getWidth(null);
	i9h = images[9].getHeight(null);
	insets.top = images[1].getHeight(null);
	insets.left = images[3].getWidth(null);
	insets.bottom = images[7].getHeight(null);
	insets.right = i5w * 2 + i9w;
}
}
