package com.pocketlinux.awt.theme;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import kaffe.awt.*;

public class Deco1I
  extends StyleComponentDeco
{
	final private static String[] filenames = new String[]{
	"background.gif",
};

public Deco1I(Style style, String widgetname) {
	super(style, widgetname, filenames);
}

public boolean hasBackgroundImage() {
	return (true);
}

public boolean paintBackground( Component c, Component p, Graphics g, int cx, int cy, int cw, int ch, int x, int y, int w, int h, int xOff, int yOff, int state) {
	if (p instanceof BackgroundImage) {
		Image img = ((BackgroundImage)p).getBackgroundImage();
                if (img != null && Theme.toolkit.prepareImage(img, -1, -1, null)) {
			AWT.extension.drawBackground( g, cx, cy, cw, ch, x, y, w, h, xOff, yOff, img, null, Theme.FILL_TILE);
			return true;
		}
	}
	if (doBorder(c, p, x, y, w, h)) {
		AWT.extension.drawBorder( g, x, y, w, h, Theme.ALIGN_OUTER, images[0], images[0], images[0], images[0], images[0], images[0], images[0], images[0] );
	}
	AWT.extension.drawBackground( g, cx, cy, cw, ch, x, y, w, h, xOff, yOff, images[0], null, Theme.FILL_TILE);
	return true;
}

}
