/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: ContentSubsystem.java,v 1.4 2001/10/22 20:42:34 colin Exp $
 */
package org.xoe.core;

import org.w3c.dom.Document;

import org.xoe.core.Constants;
import org.xoe.core.content.Stash;


public class ContentSubsystem
  implements ISubsystem, Constants
{
  public void initSubsystem (Document doc)
    throws Exception
  {
    String stashPath = Engine.getConfig (STASH_DIR_PROPERTY);
    if (stashPath == null)
      {
        stashPath = Engine.getBootstrapDirectory ().toString ();
      }
    Stash.setPath (stashPath);
  }
}
