/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IPower.java,v 1.2 2001/11/10 01:05:32 samc Exp $
 */
package org.xoe.core.device;

import java.io.IOException;

import org.xoe.core.services.IService;

/**
 * Interface to basic power management features.
 */
public interface IPower
  extends IService
{
  public void setBacklight (int intensity);
  public long getBatteryTimeRemaining ();
  public boolean hasExternalPower ();
  public void halt ();
  public void standby ();
  public void suspend ();
}
