/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IScreenRotate.java,v 1.3 2001/10/22 20:42:51 colin Exp $
 */
package org.xoe.core.device;

import java.awt.Container;

import org.xoe.core.services.IService;


public interface IScreenRotate
  extends IService
{
  public static final String INTERFACE = IScreenRotate.class.getName ();
  public static final String FUNCTIONALITY = "rotate";

  public void setRotation (int angle);
  public int getRotation ();
  public int[] getSupportedRotations ();
  public int getDefaultRotation ();
}
