/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: EmptyNodeList.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class EmptyNodeList 
  implements NodeList 
{
  private static NodeList singleton = new EmptyNodeList ();    

  public static NodeList getInstance () 
  {
    return (singleton);
  }

  public Node item (int index) 
  {
    return (null);
  }

  public int getLength () 
  {
    return (0);
  }
}
