/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: SingleNodeList.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class SingleNodeList
  implements NodeList
{
  private Node theone;

  public SingleNodeList () 
  {
  }

  public SingleNodeList (Node theone) 
  {
    set (theone);
  }

  public Node item (int i)
  {
    return (theone);
  }
    
  public int getLength ()
  {
    return (theone == null ? 0 : 1);
  }

  public void set (Node theone) 
  {
    this.theone = theone;
  }
}
