/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XCDATASection.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import org.w3c.dom.CDATASection;
import org.w3c.dom.Document;


public class XCDATASection
  extends XText
  implements CDATASection
{
  static final String CDATA_SECTION_NAME= "#cdata-section";

  // -------------------------------------------------------------------------
  // constructor

  XCDATASection (Document owner, String data) 
  {
    super (owner);
    setData (data);
  }


  // -------------------------------------------------------------------------
  // org.w3c.dom.Node Interface

  public String getNodeName () 
  {
    return (CDATA_SECTION_NAME);
  }

  public short getNodeType () 
  {
    return (CDATA_SECTION_NODE);
  }
}
