/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XComment.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import org.w3c.dom.Comment;
import org.w3c.dom.Document;


public class XComment
  extends XCharacterData
  implements Comment
{
  static final String COMMENT_NODE_NAME= "#comment";

  // -------------------------------------------------------------------------
  // constructor

  XComment (Document owner, String data) 
  {
    this.owner = owner;
    setData (data);
  }

  // -------------------------------------------------------------------------
  // org.w3c.dom.Node Interface

  public String getNodeName () 
  {
    return (COMMENT_NODE_NAME);
  }
  
  public short getNodeType () 
  {
    return (COMMENT_NODE);
  }
}
