/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XDocumentFragment.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Node;

import org.xoe.core.util.Logger;


public class XDocumentFragment
  extends ParentNode
  implements DocumentFragment
{
  public static String DOCUMENT_FRAGMENT_NODE_NAME = "#document-fragment";

  public XDocumentFragment (Document owner)
  {
    this.owner = owner;
  }

  public String getNodeName ()
  {
    return DOCUMENT_FRAGMENT_NODE_NAME;
  }
  
  public short getNodeType ()
  {
    return Node.DOCUMENT_FRAGMENT_NODE;
  }

/* These don't seem to have a purpose?  
  public Node insertBefore (Node newChild, Node refChild) throws DOMException 
  {
    return super.insertBefore (newChild, refChild);
  }
  
  public Node replaceChild(Node newChild, Node oldChild) throws DOMException 
  { 
    return super.replaceChild (newChild, oldChild);
  } 

  public Node appendChild (Node newChild) throws DOMException 
  {
    return super.appendChild (newChild);
  }
*/
}
