/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: IPackageQueryHandler.java,v 1.2 2001/12/13 23:51:18 erik Exp $
 */
package org.xoe.core.packages;

import java.util.Vector;

/**
 * Represents an abstract collection of queryable packages
 */
public interface IPackageQueryHandler
{
  /**
   * Performs the specified query and adds all matching packages to <code>out_results</code>
   */
  public void performQuery (IPackageQuery in_q, Vector out_results);
}
