/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: PackageNotFoundException.java,v 1.1 2001/10/22 20:19:04 colin Exp $
 */
package org.xoe.core.packages;

import java.net.URL;
import java.util.Vector;


public class PackageNotFoundException
  extends PackageException
{
  public PackageNotFoundException (PackageDescription desc, Vector urls)
  {
    super (buildDesc (desc, urls));
  }

  static private String buildDesc (PackageDescription desc, Vector urls)
  {
    StringBuffer strb = new StringBuffer ("Failed to find package '" 
                                         + desc.getXoeFilename () 
                                         + "' at the following URL(s):\n");
    for (int i = 0; i < urls.size(); i++)
      {
	strb.append (urls.elementAt (i));
      }
    return strb.toString ();
  }
}
