/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: File.java,v 1.1 2001/10/21 04:10:52 colin Exp $
 */ 
package org.xoe.core.protocol;

import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;

import kaffe.net.www.protocol.file.Handler;

import org.w3c.dom.Document;


public class File
  extends Handler
  implements IProtocolHandlerFactory
{
  // -------------------------------------------------------------------------
  // kaffe.net.www.protocol.file.Hander

  protected URLConnection openConnection (URL u)
  {
    return new FileURLConnection (u);
  }

  // -------------------------------------------------------------------------
  // org.xoe.core.services.IProtocolHandler

  public URLStreamHandler newInstance () 
  {
    return (this);
  }

  // -------------------------------------------------------------------------
  // org.xoe.core.services.IService

  public void init (Document configDoc) 
  {
  }

  public String[] getFunctionalities ()
  {
    return new String[] { IProtocolHandlerFactory.FUNCTIONALITY };
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals (IProtocolHandlerFactory.FUNCTIONALITY))
      {
	return new String[] { IProtocolHandlerFactory.INTERFACE };
      }
    return null;
  }

  public String[] getFeatures (String func)
  {
    if (func.equals (IProtocolHandlerFactory.FUNCTIONALITY))
      {
	return new String[] { IProtocolHandlerFactory.FEATURE, "file" };
      }
    return null;
  }

  public String[] getInformation () 
  { 
    return null; 
  }
}
