/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: IProtocolHandlerFactory.java,v 1.1 2001/10/21 04:10:52 colin Exp $
 */ 
package org.xoe.core.protocol;

import java.net.URLStreamHandler;

import org.xoe.core.services.IService;


public interface IProtocolHandlerFactory 
  extends IService
{
  /**
   *  constant used for service function lookup
   */
  public static final String INTERFACE = IProtocolHandlerFactory.class.getName ();
  public static final String FUNCTIONALITY = "protocolhandler";
  public static final String FEATURE = "protocol";

  public URLStreamHandler newInstance();
}
