/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XPathVariable.java,v 1.1 2001/10/21 04:44:20 colin Exp $
 */
package org.xoe.core.xpath;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public abstract class XPathVariable
{
  public abstract boolean getBooleanValue ();
  public abstract Node getNodeValue ();
  public abstract NodeList getNodeListValue ();
  public abstract double getNumberValue ();
  public abstract void result (XPathContext context, int resultType);
}
