#!/bin/sh
#
# Shell script that should be run to generate all the initial makefile.
# This script calls the generic autogen.sh in the 'macros' module.
#
# $tvt: autogen.sh,v 1.2 2001/10/17 02:53:32 samc Exp $

srcdir=`dirname $0`
test -z "$srcdir" && srcdir=.

MACROS=$srcdir/macros
ACLOCAL_FLAGS="-I $MACROS"

. $MACROS/autogen.sh
