package com.pocketlinux.packages;

import org.xoe.test.Test;
import org.xoe.test.AssertionFailedException;

public class InstallScriptHandlerTest extends Test
{
  private static final String SCRIPT_PACKAGE = "script-test";
  
  protected void test()
    throws AssertionFailedException
  {
    installPackage(SCRIPT_PACKAGE);
    ASSERT(TestInstallScript.postinstall == true,
	   "TestInstallScript.postinstall == true");
    uninstallPackage(SCRIPT_PACKAGE);
    ASSERT(TestInstallScript.preuninstall == true,
	   "TestInstallScript.preuninstall == true");
  }
}
