package org.xoe.test;

import java.io.PrintWriter;
import java.io.StringWriter;

public final class AssertionFailedException extends Exception
{
  private String m_message;

  AssertionFailedException(String message)
  {
    super();
    m_message = message;
  }

  public String getMessage()
  {
    StringWriter sw = new StringWriter ();
    PrintWriter pw = new PrintWriter (sw);
    printStackTrace (pw);

    String trace = sw.toString();
    int i = trace.indexOf('\n');
    if(i > 0)
      {
	i = trace.indexOf('\n', i + 1);
      }
    String temp = "ASSERTION FAILED: " + (m_message != null ? m_message : "");
    if(i > 0)
      {
	int j = trace.indexOf('(', i);

	if(j > 0)
	  {
	    int k = trace.indexOf(')', j);

	    if(k > 0)
	      {
		String filename = trace.substring(j, k + 1);
		temp += " " + filename;
	      }
	  }
      }
    return temp;
  }
}
