/**
 * IAuthConversation - interface for conversation objects used from
 *                     IAuth authorization objects to obtain user names,
 *                     passwords, and report errors
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * @author P.C.Mehlitz
 * @see AuthProcess
 * @see AuthFactory
 * @see IAuth
 */

package org.xoe.auth;

public interface IAuthConversation
{
	public String getResponse ( String msg );
}
