/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: System.c,v 1.1 2001/11/10 00:49:14 samc Exp $
 */
#include <jni.h>
#include <sys/time.h>

JNIEXPORT jboolean JNICALL
Java_org_xoe_device_LinuxSystem_setTimeMillis0 (JNIEnv* env, jobject device, jlong time)
{
  struct timeval tm;
  tm.tv_sec = time / 1000;
  tm.tv_usec = time - tm.tv_sec*1000;
  if (settimeofday (&tm, 0))
    {
      return JNI_FALSE;
    }
  return JNI_TRUE;
}
