// for the moment, it's important to include jfilesystem.h before ssl.h
#include <stdio.h>
#include <stdlib.h>
#include "kaffe/jni.h"
#include "kaffe/jfilesystem.h"

#include <openssl/ssl.h>

#define TLS_V1 0
#define TLS_V1_CLIENT 1
#define TLS_V1_SERVER 2
#define SSL_V2 3
#define SSL_V2_CLIENT 4
#define SSL_V2_SERVER 5
#define SSL_V3 6
#define SSL_V3_CLIENT 7
#define SSL_V3_SERVER 8
#define SSL_V23 9
#define SSL_V23_CLIENT 10
#define SSL_V23_SERVER 11

void throwSSLException(JNIEnv* env, char* msg);
void throwSSLRuntimeException(JNIEnv* env, char* msg);
jstring ASN1_TIME_to_jstring(JNIEnv* env, ASN1_TIME *a);
char *BIO_get_mem_string(BIO *bio, char *buffer, int blen);
