package org.xoe.mime;

import java.net.InetAddress;
import java.net.UnknownHostException;


/**
  * A Utility class for Multipart mime objects
  * 
  */
public class Util
{
  static int counter = 0;

  /**
    * This generates a unique id
    *
    */
  public synchronized static String generateCID ()
  {
    try
      {
	return (Long.toString (System.currentTimeMillis (), 36) + "." +
		Integer.toString (counter++, 36) + ".xoe" + "_" + 
		System.getProperty ("user.name") + "_" +
		InetAddress.getLocalHost ().getHostName ());
      }
    catch (UnknownHostException e)
      {
	throw new RuntimeException ("UnknownHostException of localhost " +
				    "caused generateCID to fail.");
      }
  }
}
