/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: ExceptionSoapParameter.java,v 1.2 2001/11/16 21:04:59 ben Exp $
 */ 
package org.xoe.soap;

import org.w3c.dom.Element;
import org.xoe.core.util.DOMUtils;

public class ExceptionSoapParameter 
  implements SoapParameter
{
  private Exception paramObj;
  
  public void setParameter (Object obj)
  {
    paramObj = (Exception)obj;
  }

  public void generate (SoapDocument soapDocument)
  {
    Element c1 = soapDocument.createElementNS (null, "Fault");    
    c1.setAttribute (SoapConstants.ATTRIBUTE_PREFIX + SoapConstants.COLON + SoapConstants.ENCODING_STYLE , 
		     SoapConstants.LITERAL_XML_ENCODING_STYLE_URL);
          
    //c1.appendChild (soapDocument.importNode (paramObj, true));
    DOMUtils.setTextContent ( c1, paramObj.toString()); 
    soapDocument.getCurrentMethodElement ().appendChild (c1);    
  }
}
