/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: SwfPlayerService.java,v 1.1.1.1 2001/11/11 08:14:40 joerg Exp $
 */

package org.xoe.plugin;

import org.xoe.core.Constants;

import org.xoe.core.services.IService;
import org.xoe.core.services.ServiceFactory;

import org.xoe.display.dom.plugin.NPServiceBase;

public class SwfPlayerService
    extends NPServiceBase
    implements ServiceFactory
{

  static final String LIB_PATH = "/tmp/libswfplayer.so";
  static SwfPlayerService defaultInstance = new SwfPlayerService();

  public IService newInstance(){
      return defaultInstance;
  }


  public String[] getFeatures (String func)
  {
    if( func.equals( FUNCTION_CONTENT_HANDLER) )
      {
	 return new String[]{ FEATURE_MIMETYPE,  "application/x-shockwave-flash" ,
			      FEATURE_EXTENSION, "swf" };
      }
     return new String[0];
  }
   

  public String getLibrary() {
     return LIB_PATH;
  }
   
}








