package org.xoe.syncmanagement;



import java.util.Hashtable;
import java.util.Date;
import java.net.URL;
import org.xoe.core.content.ContentElement;



public class SyncManager
{

  //keys: URL obj
  //values: Date obj
  private static Hashtable db = new Hashtable();

  public static String BEGINNING_OF_TIME = "Mon Jan 01 00:00:01 PDT 1900";

  public static Date getNow()
  {
    return new Date();
  }

  public static Date getSyncDate( URL url )
  {
    Date date = (Date)db.get( url );
    //if( date != null )
    //System.err.println( "SyncManager.getSyncDate(): {" + url.toString() + "][" + date.toString() + "]" );
    return date;
  }

  public static Date getSyncDate( ContentElement ce )
  {
    Date date = (Date)db.get( ce.getURL() );
    //if( date != null )
    //System.err.println( "SyncManager.getSyncDate(): {" + ce.getURL().toString() + "][" + date.toString() + "]" );
    return date;
  }

  public static void addSyncDate( URL url, Date date )
  {
    //System.err.println( "SyncManager.addSyncDate(): [" + url.toString() + "][" + date.toString() + "]" );
    db.put( url, date );
  }

  public static void addSyncDate( ContentElement ce, Date date )
  {
    //System.err.println( "SyncManager.addSyncDate(): [" + ce.getURL().toString() + "][" + date.toString() + "]" );
    db.put( ce.getURL(), date );
  }

}
