/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: INPService.java,v 1.2 2001/12/09 00:22:22 joerg Exp $
 */ 
package org.xoe.display.dom.plugin;

import org.xoe.core.services.IService;

/**
 * A XOE Service for Netscape-Plugin libraries
 * 
 */
public interface INPService 
  extends IService
{
  public static final String FUNCTIONALITY = "NP_service";
  public static final String INTERFACE = INPService.class.getName();

  /**
   * Get the plugin content-specific rendering widget class
   * 
   * @return: Class
   * @author: Joerg Mehlitz
   * @version: 1.0
   */
  public Class getPluginClass();
	
  /**
   * Get the plugin library pathname
   * 
   * @return: String
   * @author: Joerg Mehlitz
   * @version: 1.0
   */
  public String getLibrary();
}
