/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: PPlayer.java,v 1.4 2001/11/21 21:07:21 joerg Exp $
 */
package org.xoe.display.dom.plugin;

import java.util.Vector;
import org.w3c.dom.Document;

import org.xoe.display.dom.ViewElement;   
import org.xoe.display.dom.LayoutCursor;   

import org.xoe.core.services.ServiceFactory;                                        

class PPlayer
  extends ViewElement 
{ 

  int rot;
   
  PPlayer () 
  {
  }

  protected void makeVis () 
  {
    vis = new PluginPlayer ();
  }

  public void setAttributeNS (String namespaceURI, String qualifiedName, String value) 
  {
    String localName = getLocalName (qualifiedName);
    if ("src".equalsIgnoreCase (localName)) 
      {
	((PluginPlayer)getVis()).setSource (value);
      }
     super.setAttributeNS( namespaceURI, qualifiedName, value);
  }

  public void start () 
  {
    ((PluginPlayer)getVis ()).start ();
  }

  public void stop () 
  {
    ((PluginPlayer)getVis ()).stop ();
  }
}
