/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: DescItem.java,v 1.4 2001/10/22 22:18:42 colin Exp $
 */ 
package org.xoe.display.dom.xhtml;

import java.awt.Component;
import java.awt.Graphics;

import org.w3c.dom.Node;

import org.xoe.display.dom.ViewElement;
import org.xoe.display.dom.LayoutCursor;


public class DescItem
	extends ViewElement 
{
  
  private static final int INDENT = 40;

  public void layout (LayoutCursor cur) 
  {
    if (cur.x > cur.leftindent) 
      {
	cur.newline ();
      }
    if ("dd".equalsIgnoreCase (getLocalName ())) 
      {
	cur.move (INDENT, 0);
	cur.leftindent += INDENT;
	layoutChildren (cur);
	cur.leftindent -= INDENT;
      }
    else {
      layoutChildren (cur);
    }
    cur.newline ();
  }

}
