package org.xoe.display.dom;

import org.w3c.dom.Node;


public class FloatViewElement
  extends ViewElement 
{
  int falign;
  int fminwidth;
  int fmaxwidth;
  int fheight;
  int fendy;
  
  public void setFloat (int align, int minwidth, int maxwidth, int height) 
  {
    falign = align;
    fminwidth = minwidth;
    fmaxwidth = maxwidth;
    fheight = height;
    fendy = 0;
  }
  
  public Node cloneNode (boolean deep)
  {
    FloatViewElement nnode = (FloatViewElement)super.cloneNode (deep);
    nnode.falign = falign;
    nnode.fminwidth = fminwidth;
    nnode.fmaxwidth = fmaxwidth;
    nnode.fheight = fheight;
    nnode.fendy = fendy;
    return nnode;
  }
}
