/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IEditableDocumentBuilder.java,v 1.3 2001/10/26 01:40:16 colin Exp $
 */
package org.xoe.display.dom;

import java.io.IOException;

import org.xoe.core.content.ContentElement;
import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;


public interface IEditableDocumentBuilder 
  extends IService
{
  public static final String INTERFACE = IEditableDocumentBuilder.class.getName ();
  public static final String FUNCTIONALITY = "EditableDocumentBuilder";

  public XDocument getEditableDocument (ContentElement content)
    throws IOException;

  public void save (XDocument d);
}
