package com.pocketlinux.xs;

import kaffe.xs.XsObject;
import kaffe.xs.XsString;

public class XsDocument
  extends XsObject
{
  private DOM0Adaptor doc;

  public XsDocument (DOM0Adaptor doc)
  {
    this.doc = doc;
  }

  public DOM0Adaptor getDocument ()
  {
    return (doc);
  }

  public XsObject xsPut (String key, XsObject val)
  {
    if ("location".equalsIgnoreCase (key))
      {
	if (val instanceof XsString)
	  {
	    return (xsGet ("location").xsPut ("href", val));
	  }
      }
    return (super.xsPut (key, val));
  }
}
