/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IIconResolver.java,v 1.2 2001/10/22 21:41:12 colin Exp $
 */
package org.xoe.services;

import java.io.IOException;
import java.net.URL;

import org.xoe.core.content.ContentElement;
import org.xoe.core.content.ContentType;
import org.xoe.core.services.IService;


public interface IIconResolver
  extends IService
{
  public static final String FUNCTIONALITY = "IconResolver";
  public static final String INTERFACE = IIconResolver.class.getName ();

  public URL getIconURL (ContentElement resource)
    throws IOException;

  public URL getIconURL (ContentType type);
}
