package org.xoe.services;

import java.io.IOException;
import java.net.URL;

import org.xoe.core.content.ContentElement;
import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;


public interface IURLViewer
  extends IService
{
  public static final String INTERFACE = IURLViewer.class.getName ();
  public static final String FUNCTIONALITY = "url-viewing";

  public XDocument getPage (String src)
    throws IOException;

  public XDocument getPage (URL url)
    throws IOException;

  public XDocument getPage (ContentElement content)
    throws IOException;
}
