/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: XsString.java,v 1.39 2001/08/14 17:03:07 philippe Exp $
 */
package kaffe.xs;

import java.util.*;

//use Stringbuffers instead of String concatenations

final 
public class XsString
  extends XsObject
{
        String str;
        boolean isObject = false;
	static XsString typeStr = new XsString("string");

        protected static XsObject string__proto__; 


static {
        string__proto__ = new XsObject();

        XsPropertyAttributes propattrs;
        XsFunc func;

        string__proto__.xsPut( "anchor", func = (XsFunc) XsFunc.getFunc("anchor", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("anchor"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        


        
        string__proto__.xsPut( "big", func = (XsFunc) XsFunc.getFunc("big", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("big"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "blink", func = (XsFunc) XsFunc.getFunc("blink", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("blink"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "bold", func = (XsFunc) XsFunc.getFunc("bold", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("bold"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
     



       	string__proto__.xsPut( "charAt", func = (XsFunc) XsFunc.getFunc("charAt", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("charAt"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
    



        string__proto__.xsPut( "charCodeAt", func = (XsFunc) XsFunc.getFunc("charCodeAt", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("charCodeAt"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "concat", func = (XsFunc) XsFunc.getFunc("concat", XsString.class));	
        func.xsPut("length", new XsNumber(1)); 
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("concat"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "fixed", func = (XsFunc) XsFunc.getFunc("fixed", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("fixed"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "fontcolor", func = (XsFunc) XsFunc.getFunc("fontcolor", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("fontcolor"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "fontsize", func = (XsFunc) XsFunc.getFunc("fontsize", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("fontsize"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "indexOf", func = (XsFunc) XsFunc.getFunc("indexOf", XsString.class));
        func.xsPut("length", new XsNumber(1)); 
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("indexOf"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "italics", func = (XsFunc) XsFunc.getFunc("italics", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("italics"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "lastIndexOf", func = (XsFunc) XsFunc.getFunc("lastIndexOf", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("lastIndexOf"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "localeCompare", func = (XsFunc) XsFunc.getFunc("localeCompare", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("localeCompare"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        



        string__proto__.xsPut( "match", func = (XsFunc) XsFunc.getFunc("match", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("match"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        



        string__proto__.xsPut( "link", func = (XsFunc) XsFunc.getFunc("link", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("link"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "replace", func = (XsFunc) XsFunc.getFunc("replace", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("replace"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       

  

        string__proto__.xsPut( "search", func = (XsFunc) XsFunc.getFunc("search", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("search"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "slice", func = (XsFunc) XsFunc.getFunc("slice", XsString.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("slice"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "small", func = (XsFunc) XsFunc.getFunc("small", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("small"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "split", func = (XsFunc) XsFunc.getFunc("split", XsString.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("split"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "strike", func = (XsFunc) XsFunc.getFunc("strike", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("strike"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        



        string__proto__.xsPut( "sub", func = (XsFunc) XsFunc.getFunc("sub", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("sub"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "substr", func = (XsFunc) XsFunc.getFunc("substr", XsString.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("substr"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "substring", func = (XsFunc) XsFunc.getFunc("substring", XsString.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("substring"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "sup", func = (XsFunc) XsFunc.getFunc("sup", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("sup"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
    



        string__proto__.xsPut( "toLowerCase", func = (XsFunc) XsFunc.getFunc("toLowerCase", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("toLowerCase"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "toLocaleLowerCase", func = (XsFunc) XsFunc.getFunc("toLocaleLowerCase", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("toLocaleLowerCase"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        string__proto__.xsPut( "toUpperCase", func = (XsFunc) XsFunc.getFunc("toUpperCase", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("toUpperCase"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        string__proto__.xsPut( "toLocaleUpperCase", func = (XsFunc) XsFunc.getFunc("toLocaleUpperCase", XsString.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)string__proto__.properties_attributes.get("toLocaleUpperCase"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
     

       
        string__proto__.__proto__ = XsFunc.function__proto__;
}

public XsString(){
	this(null);
}

public XsString ( Object o ) {
	this(o.toString());
}

public XsString ( String s ) {
	str = s;
        __proto__ = string__proto__;
}

public static XsObject __String ( XsObject xThis, XsArray args ){
	XsString xs = (XsString) xThis;
        
	if(args.count == 0){
		xs.str = "";
	}
	else{
		xs.str = args.elements[0].call("toString").toString();
	}
	
        xs.isObject = true;

        return xThis;
}

//static methods

public static XsString _fromCharCode(XsObject xThis, XsArray args){
                
	if(args.count == 0){
		return new XsString("");
        }
		      
        char chars[] = new char[args.count];
                
        for(int i = 0; i < args.count; i++){
		XsNumber x = XsNumber.getNumberFromObject(args.elements[i]);
                
                if(x.type == XsNumber.TYPE_INT)
			chars[i] = (char)x.ival;
                else  
                        chars[i] = (char)x.dval; 
        }

        return new XsString(new String(chars));	
}

// object methods

public static XsObject _anchor(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
                xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer name,
                     result;

        if(args.count == 0){
                name = new StringBuffer("undefined");
        }      
        else{
		name = new StringBuffer(args.elements[0].toString());
        }

        //name needs to be escaped for \" etc
        result = new StringBuffer("<A name=\"");
        result.append(escape_double_quotes(name));
        result.append("\">");
        result.append(((XsString)xThis).str); 
        result.append("</A>");       
         
        return new XsString(result.toString());
}

public static XsObject _big(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<BIG>");
        result.append(((XsString)xThis).str); 
        result.append("</BIG>");       
         
        return new XsString(result.toString());
}

public static XsObject _blink(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
                xThis = new XsString(xThis.call("toString").toString());
	}
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<BLINK>");
        result.append(((XsString)xThis).str); 
        result.append("</BLINK>");       
         
        return new XsString(result.toString());
}

public static XsObject _bold(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
                xThis = new XsString(xThis.call("toString").toString());
	}
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<BOLD>");
        result.append(((XsString)xThis).str); 
        result.append("</BOLD>");       
         
        return new XsString(result.toString());
}

public static XsObject _charAt(XsObject xThis, XsArray args){
	
        //returns XsString
        if(!(xThis instanceof XsString)){
                //ok since xThis is a local copy
                xThis = new XsString(xThis.call("toString").toString());
	}

        char chars[] = new char[1];
        
        if(args.count == 0){
                chars[0] = ((XsString)xThis).str.charAt(0);
                return new XsString(new String(chars));
	}      

        XsNumber x = XsNumber.getNumberFromObject(args.elements[0]);
 
        try{       
		if(x.type == XsNumber.TYPE_INT)
			chars[0] = ((XsString)xThis).str.charAt(x.ival);
		else  
			chars[0] = ((XsString)xThis).str.charAt((int)x.dval); 
        }
        catch(StringIndexOutOfBoundsException e){
		return new XsString("");
        }
        
        return new XsString(new String(chars));
}

public static XsObject _charCodeAt(XsObject xThis, XsArray args){

        if(!(xThis instanceof XsString)){
                xThis = new XsString(xThis.call("toString").toString());
        }
        
        if(args.count == 0){
		return new XsNumber((int) ((XsString)xThis).str.charAt(0));
	}      

        XsNumber x = XsNumber.getNumberFromObject(args.elements[0]);
 
        try{      
		if(x.type == XsNumber.TYPE_INT)
			return new XsNumber((int)((XsString)xThis).str.charAt(x.ival));
		else  
			return new XsNumber((int)((XsString)xThis).str.charAt((int)x.dval)); 
        }
        catch(StringIndexOutOfBoundsException e){
		return XsNumber.NaN; 
        }
}

public static XsObject _concat(XsObject xThis, XsArray args){
  
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
        
        if(args.count == 0){
		return new XsString(xThis);
	}      

        String result = ((XsString)xThis).str;

        for(int i = 0; i < args.count; i++)
		result += args.elements[i].call("toString").toString();
           
        return new XsString(result);
}

public static XsObject _fixed(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<TT>");
        result.append(((XsString)xThis).str); 
        result.append("</TT>");       
         
        return new XsString(result.toString());
}

public static XsObject _fontcolor(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer color,
                     result;

        if(args.count == 0){
                color = new StringBuffer("undefined");
        }      
        else{
		color = new StringBuffer(args.elements[0].toString());
        }

        //name needs to be escaped for \" etc
        result = new StringBuffer("<FONT color=\"");
        result.append(escape_double_quotes(color));
        result.append("\">");
        result.append(((XsString)xThis).str); 
        result.append("</FONT>");       
         
        return new XsString(result.toString());
}

public static XsObject _fontsize(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer size,
                     result;

        if(args.count == 0){
                size = new StringBuffer("undefined");
        }      
        else{
		size = new StringBuffer(args.elements[0].toString());
        }

        //name needs to be escaped for \" etc
        result = new StringBuffer("<FONT size=\"");
        result.append(escape_double_quotes(size));
        result.append("\">");
        result.append(((XsString)xThis).str); 
        result.append("</FONT>");       
         
        return new XsString(result.toString());
}

public static XsObject _indexOf(XsObject xThis, XsArray args){
  
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
        
        if(args.count == 0){
		return new XsNumber(-1);
	}      

        if(args.count == 1){
		return new XsNumber(((XsString)xThis).str.indexOf(args.elements[0].call("toString").toString()));
        }
        else{
                XsNumber x = XsNumber.getNumberFromObject(args.elements[1]);

                if(x == XsNumber.NaN){
			x = new XsNumber(0);
                }     
 
                if(x.type == XsNumber.TYPE_INT)
			return new XsNumber(((XsString)xThis).str.indexOf(args.elements[0].call("toString").toString(), x.ival));
                else  
                        return new XsNumber(((XsString)xThis).str.indexOf(args.elements[0].call("toString").toString(), (int)x.dval));
        }
}

public static XsObject _italics(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<I>");
        result.append(((XsString)xThis).str); 
        result.append("</I>");       
         
        return new XsString(result.toString());
}

public static XsObject _lastIndexOf(XsObject xThis, XsArray args){
  
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
        
        if(args.count == 0){
		return new XsNumber(-1);
	}      

        if(args.count == 1){
		return new XsNumber(((XsString)xThis).str.lastIndexOf(args.elements[0].call("toString").toString()));
        }
        else{
                XsNumber x = XsNumber.getNumberFromObject(args.elements[1]);
 
                if(x == XsNumber.NaN){
			x = new XsNumber(((XsString)xThis).str.length());
                } 

                if(x.type == XsNumber.TYPE_INT)
			return new XsNumber(((XsString)xThis).str.lastIndexOf(args.elements[0].call("toString").toString(), x.ival));
                else  
                        return new XsNumber(((XsString)xThis).str.lastIndexOf(args.elements[0].call("toString").toString(), (int)x.dval));
        }
}

public static XsObject _localeCompare(XsObject xThis, XsArray args){
  
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
        
        if(args.count == 0){
		return new XsNumber(-1);
        }

        return new XsNumber(((XsString)xThis).str.compareTo(args.elements[0].call("toString").toString()));
}

public static XsObject _match(XsObject xThis, XsArray args){
	System.err.println("match not yet implemented");
        return _undefined;
}

public static XsObject _link(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer href,
                     result;

        if(args.count == 0){
                href = new StringBuffer("undefined");
        }      
        else{
		href = new StringBuffer(args.elements[0].toString());
        }

        //name needs to be escaped for \" etc
        result = new StringBuffer("<A href=\"");
        result.append(escape_double_quotes(href));
        result.append("\">");
        result.append(((XsString)xThis).str); 
        result.append("</A>");       
         
        return new XsString(result.toString());
}

public static XsObject _replace(XsObject xThis, XsArray args){
	System.err.println("replace not yet implemented");
        return _undefined;
}

public static XsObject _search(XsObject xThis, XsArray args){
	System.err.println("search not yet implemented");
        return _undefined;
}

public static XsObject _slice(XsObject xThis, XsArray args){
  
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }

        if(args.count == 0){
		return new XsString(((XsString)xThis).str.substring(0));
	}      
	
        int start_index, end_index;
        
        //avoid exceptions
        if(args.count == 1){
                XsNumber x = XsNumber.getNumberFromObject(args.elements[0]);
                
                if(x.type == XsNumber.TYPE_INT){
			start_index = x.ival;
                }
                else{   
			start_index = (int)x.dval;
                }
                
                if(start_index > ((XsString)xThis).str.length())
			return new XsString("");
                else 
			return new XsString(((XsString)xThis).str.substring(start_index));
        }
        else{
                XsNumber start = XsNumber.getNumberFromObject(args.elements[0]);
                XsNumber end = XsNumber.getNumberFromObject(args.elements[1]);
 
                if(start.type == XsNumber.TYPE_INT){
                         start_index = start.ival;
                }
                else{
                         start_index = start.ival;
                }  

                if(args.elements[1] == _undefined){
			 end = new XsNumber(((XsString)xThis).str.length());
                }

                if(end.type == XsNumber.TYPE_INT){
			 end_index = end.ival;
                }
                else{
			 end_index = (int)end.dval;
                }
                
                int len = ((XsString)xThis).str.length();

                if(start_index > len)
			return new XsString("");
                else if(start_index < 0)
                        start_index = len + start_index;

                if(end_index > len)
			end_index = len;
                else if(end_index < 0)
                        end_index = len + end_index;

                if(start_index > end_index)
			return new XsString("");
                else
			return new XsString(((XsString)xThis).str.substring(start_index, end_index)); 
        }
}

public static XsObject _small(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<SMALL>");
        result.append(((XsString)xThis).str); 
        result.append("</SMALL>");       
         
        return new XsString(result.toString());
}

//finish review when doing RegExps
public static XsObject _split(XsObject xThis, XsArray args){
        //returns XsArray
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }

	XsArray ret_array;
      
        if(((XsString)xThis).str.equals("")){
		ret_array = new XsArray(1);
                ret_array.xsPut(0, new XsString("")); 
		return ret_array;
        }

        if(args.count == 0 || args.elements[0] == _undefined){
                ret_array = new XsArray(1);
                ret_array.xsPut(0, new XsString(((XsString)xThis).str)); 
		return ret_array;
	}      
        else{	
                int limit;
		
                String separator = args.elements[0].call("toString").toString();


		StringTokenizer st = new StringTokenizer(((XsString)xThis).str, separator); 

		ret_array = new XsArray(st.countTokens());

		for(int i = 0; st.hasMoreTokens(); i++)
			ret_array.xsPut(i, new XsString(st.nextToken()));  
        
                if(args.count == 2){
			XsNumber xn = XsNumber.getNumberFromObject(args.elements[1]);
                        
                        if(xn == XsNumber.NaN){
				ret_array = new XsArray(0);
				return ret_array;	
                        } 
                        else if(xn.type == XsNumber.TYPE_INT){
				limit = xn.ival; 
                        }
                        else{
				limit = (int)xn.dval;
                        }

                        if(ret_array.count > limit && limit > 0){
				ret_array.count = limit;
                        } 
                } 

		return ret_array;
        }
}

public static XsObject _strike(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<STRIKE>");
        result.append(((XsString)xThis).str); 
        result.append("</STRIKE>");       
         
        return new XsString(result.toString());
}

public static XsObject _sub(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<SUB>");
        result.append(((XsString)xThis).str); 
        result.append("</SUB>");       
         
        return new XsString(result.toString());
}

public static XsObject _substr(XsObject xThis, XsArray args){
  
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }

        if(args.count == 0){
		return new XsString(((XsString)xThis).str.substring(0));
	}      
	
        int start_index, end_index, length;
        
        //avoid exceptions
        if(args.count == 1){
                XsNumber x = XsNumber.getNumberFromObject(args.elements[0]);
                
                if(x == XsNumber.NaN){
			start_index = 0;
                }
                else if(x.type == XsNumber.TYPE_INT){
			start_index = x.ival;
                }
                else{   
			start_index = (int)x.dval;
                }
                
                if(start_index < 0){
			start_index = 0;
                }
                
                if(start_index > ((XsString)xThis).str.length())
			return new XsString("");
                else 
			return new XsString(((XsString)xThis).str.substring(start_index));
        }
        else{
                XsNumber start = XsNumber.getNumberFromObject(args.elements[0]);
                XsNumber xn_length = XsNumber.getNumberFromObject(args.elements[1]);
 
                if(start == XsNumber.NaN){
			start_index = 0;
                } 
                else if(start.type == XsNumber.TYPE_INT){
                         start_index = start.ival;
                }
                else{
                         start_index = start.ival;
                }
  
                if(start_index < 0){
			start_index = 0;
                }

                if(xn_length.type == XsNumber.TYPE_INT){
			 length = xn_length.ival;
                }
                else{
			 length = (int)xn_length.dval;
                }

                if(length < 0 )
			return new XsString("");

                end_index = start_index + length;

                if(start_index > ((XsString)xThis).str.length())
			return new XsString("");
                else if(start_index < 0)
                        start_index = ((XsString)xThis).str.length() + start_index;

                if(end_index > ((XsString)xThis).str.length())
			end_index = ((XsString)xThis).str.length();
                else if(end_index < 0)
                        end_index = ((XsString)xThis).str.length() + end_index;

                if(start_index > end_index)
			return new XsString("");
                else
			return new XsString(((XsString)xThis).str.substring(start_index, end_index)); 
        }
}

public static XsObject _substring(XsObject xThis, XsArray args){
  
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }

        if(args.count == 0){
		return new XsString(((XsString)xThis).str.substring(0));
	}      
	
        int start_index, end_index, length;
        
        //avoid exceptions
        if(args.count == 1){
                XsNumber x = XsNumber.getNumberFromObject(args.elements[0]);
                
                if(x == XsNumber.NaN){
			start_index = 0;
                }
                else if(x.type == XsNumber.TYPE_INT){
			start_index = x.ival;
                }
                else{   
			start_index = (int)x.dval;
                }
                
                if(start_index < 0){
			start_index = 0;
                }
                
                if(start_index > ((XsString)xThis).str.length())
			return new XsString("");
                else 
			return new XsString(((XsString)xThis).str.substring(start_index));
        }
        else{ 
                XsNumber start = XsNumber.getNumberFromObject(args.elements[0]);
                XsNumber end = XsNumber.getNumberFromObject(args.elements[1]);
 
                if(start == XsNumber.NaN){
			start_index = 0;
                } 
                else if(start.type == XsNumber.TYPE_INT){
                         start_index = start.ival;
                }
                else{
                         start_index = start.ival;
                }
  
                if(start_index < 0){
			start_index = 0;
                }
 
                
                if(end == XsNumber.NaN){
			 end_index = 0;
                }
                else if(end.type == XsNumber.TYPE_INT){
			 end_index = end.ival;
                }
                else{
			 end_index = (int)end.dval;
                }

                if(end_index < 0){
			end_index = 0;
                }

                if(start_index > ((XsString)xThis).str.length())
			return new XsString("");
                else if(start_index < 0)
                        start_index = 0;

                if(end_index > ((XsString)xThis).str.length())
			end_index = ((XsString)xThis).str.length();
                else if(end_index < 0){
                        end_index = start_index;
                        start_index = 0;
                }
                        
                if(start_index > end_index){
                        int temp = start_index;
                        start_index = end_index;
                        end_index = temp;
                }
		 
                 return new XsString(((XsString)xThis).str.substring(start_index, end_index)); 
        }
}

public static XsObject _sup(XsObject xThis, XsArray args){
        //returns XsString
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
       
        StringBuffer result;

        //name needs to be escaped for \" etc
        result = new StringBuffer("<SUP>");
        result.append(((XsString)xThis).str); 
        result.append("</SUP>");       
         
        return new XsString(result.toString());
}

public static XsObject _toLowerCase(XsObject xThis, XsArray args){
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }

        return new XsString(((XsString)xThis).str.toLowerCase());
}

public static XsObject _toLocaleLowerCase(XsObject xThis, XsArray args){
        return _toLocaleLowerCase(xThis, args);
}

public static XsObject _toUpperCase(XsObject xThis, XsArray args){
        if(!(xThis instanceof XsString)){
		xThis = new XsString(xThis.call("toString").toString());
        }
        
        return new XsString(((XsString)xThis).str.toUpperCase());
}

public static XsObject _toLocaleUpperCase(XsObject xThis, XsArray args){
        return _toLocaleUpperCase(xThis, args);
}

//replaces " by ' in strings
//bad method name
private static final StringBuffer escape_double_quotes(StringBuffer in){
        StringBuffer out = new StringBuffer();

        char read;

        for(int i = 0; i < in.length(); i++){
		if((read = in.charAt(i)) == '\"'){
			out.append('\'');
                }
                else{
                        out.append(read);
                }
        }

        return out;
}

public static XsString getStringFromObject(XsObject x){
  
	XsObject ret;
        int[] n_iter = new int[1];
                        
        //check for valueOf 
        XsObject func = x.xsGet("valueOf", n_iter);

        //check exceptions on invoke ??
	//System.err.println("in getStringFromObjec");
        if(!(func instanceof XsFunc) || n_iter[0] != 2){
		//check for toString
                func  = x.xsGet("toString", n_iter);
                if(func instanceof XsFunc || n_iter[0] != 2){
			ret = func.invoke(x);
		        return new XsString(ret.toString());
                }
                else{   
			System.err.println("TypeError: can't convert to primitive type");
                        return new XsString("undefined");//this is not correct
                }                                  	
	}                       
        else{   //System.err.println("in getStringFromObjec 2");
		ret = func.invoke(x);
		return new XsString(ret.toString());
        }
}

public XsObject and ( String s ){
	int i= 0;
	double d = 0.0;
        	
        try {
		if ( XsNumber.assumedFloat( s) ){
			d = Double.parseDouble(s);
			return and(d);
	       	}
		else {
			i = Integer.parseInt(s);
			return and(i);
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject and ( XsObject x ){
       	XsNumber xn = XsNumber.getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == XsNumber.TYPE_INT ){
			return and(xn.ival);
		}
		else {
			return and(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}
	
public XsObject and ( double d ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
		return new XsNumber( si & (int)d);
	}
	else {
		return new XsNumber( (int)sd & (int)d);
	}
}

public XsObject and ( int i ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
                return new XsNumber( si & i);
	}
	else {
		return new XsNumber( (int)sd & i);
	}
}

public static XsNumber isInfinity(String s){

	if(s.indexOf("Infinity") > 0){
		if(s.indexOf("-") > 0){
			return XsNumber.NEGATIVE_INFINITY;
                }
                else{
			return XsNumber.POSITIVE_INFINITY;
                }
        }
        else{
		return XsNumber.NaN;
        }
}
	
public XsObject div (String s){
        int i = 0, si = 0;
	double d = 0.0, sd = 0.0;
	int type, stype;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
	        return XsNumber.NaN;
	}

       

        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.parseInt(s);
			stype = XsNumber.TYPE_INT;
                }
	}
	catch ( NumberFormatException xx ) {
                if(s.equals(""))
			return XsNumber.POSITIVE_INFINITY;
                else
                        return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT ){
		if ( stype == XsNumber.TYPE_INT ){
			return new XsNumber( (double)i / si);
		}
		else {
                        return new XsNumber( i / sd);
		}
	}
	else {
		if ( stype == XsNumber.TYPE_INT ){
			return new XsNumber( d / si);
		}
		else {
			return new XsNumber( d / sd);
		}
	}


       
}

public XsObject div ( XsObject x ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
	        return XsNumber.NaN;
	}


        XsNumber xn = XsNumber.getNumberFromObject(x);

        
        if ( type == XsNumber.TYPE_INT ){
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber( i / xn.ival);
		}
		else {
			return new XsNumber( i / xn.dval);
		}
	}
	else {
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber( d / xn.ival);
		}
		else {
			return new XsNumber( d / xn.dval);
		}
        }
}

public XsObject div ( double xd ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT )
		return new XsNumber( i / xd);
	else 
	        return new XsNumber( d / xd);
}

public XsObject div ( int xi ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT )
		return new XsNumber( (double)i / xi);
	else 
	        return new XsNumber( d / xi);
}

public boolean equals ( Object o ){
	if ( o instanceof String ){
		return (str.equals( o));
	}
	else if ( o instanceof XsString ){
		return (str.equals( ((XsString)o).str));
	}
	else {
		return (str.equals( o.toString()));
	}
}

public XsObject eq ( String s ){
	return (str.equals(s)) ? xTrue : xFalse;
}

public XsObject eq ( XsObject x ) {
        if(x instanceof XsString)
         	return eq(x.toString());
        else if(x instanceof XsNumber){
		XsNumber xn = (XsNumber) x;
                
                if ( xn.type == XsNumber.TYPE_INT ){
			return eq(xn.ival);
		}
		else {
			return eq(xn.dval);
		}
               
	}
        else if(x == xTrue || x == xFalse){
                return eq((x == xTrue) ? 1 : 0);
        }
        else if(x instanceof XsArray){
                XsArray array = (XsArray)x;
                                 
                if(array.count == 0)
			return xFalse;
                else if(array.count == 1){
			return eq(array.xsGet(0));
                }
                else
                        return xFalse;
        }
        else{   
                XsObject o = XsObject.getPrimitiveFromObject(x);
                if(x.xsGet("constructor") != o.xsGet("constructor")){
			return eq(XsObject.getPrimitiveFromObject(x));
                }
                else{
			return xFalse;
                } 
        }         
}

public XsObject eq ( double d ) {
	int si = 0;
	double sd = 0.0;
	int stype;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
		        si = Integer.decode(str).intValue();
			stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}

        if ( stype == XsNumber.TYPE_INT ){
		return (si == d) ? xTrue : xFalse;
	}
	else {
		return (sd == d) ? xTrue : xFalse;
        }
}

public XsObject eq ( int i ) {
	int si = 0;
	double sd = 0.0;
	int stype;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
		        si = Integer.decode(str).intValue();
			stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}

        if ( stype == XsNumber.TYPE_INT ){
		return (si == i) ? xTrue : xFalse;
	}
	else {
		return (sd == i) ? xTrue : xFalse;
        }
}

public XsObject ge ( String s ){
        return ((str.compareTo(s) >= 0) ? xTrue : xFalse);        
}

public XsObject ge ( XsObject x ) {
	if ( x instanceof XsString ){
                return ge(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return ge(((XsNumber)x).ival);
		}
		else {
			return ge(((XsNumber)x).dval);
		}
        }
        else{
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return ge(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return ge(((XsNumber)p).ival);
		        }
			else {
				return ge(((XsNumber)p).dval);
			}
                } 
                else if(p == xTrue){
		        return ge(1);
                }
	        else if(p == xFalse || p == _undefined || p == _null){
		        return ge(0);
	        } 
                else{
                        return xFalse;
                }
        }
}

public XsObject ge ( double x ) {
        int i = 0;
	double d = 0.0;
	int type;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}


        if ( type == XsNumber.TYPE_INT ){
       		return ((double)i >= x) ? xTrue : xFalse;
	}
	else {
		return (d >= x) ? xTrue : xFalse;
	}


}

public XsObject ge ( int x ) {
        int i = 0;
	double d = 0.0;
	int type;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}


        if ( type == XsNumber.TYPE_INT ){
       		return (i >= x) ? xTrue : xFalse;
	}
	else {
		return (d >= (double)x) ? xTrue : xFalse;
	}
}

public XsObject gt ( String s ){
        return ((str.compareTo(s) > 0) ? xTrue : xFalse);        
}

public XsObject gt ( XsObject x ) {
	if ( x instanceof XsString ){
                return gt(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return gt(((XsNumber)x).ival);
		}
		else {
			return gt(((XsNumber)x).dval);
		}
        }
        else{
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return gt(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return gt(((XsNumber)p).ival);
		        }
			else {
				return gt(((XsNumber)p).dval);
			}
                }
                else if(p == xTrue){
		        return gt(1);
                }
	        else if(p == xFalse || p == _undefined || p == _null){
		        return gt(0);
	        }
                else{
                        return xFalse;
                }
	}
}

public XsObject gt ( double x ) {
        int i = 0;
	double d = 0.0;
	int type;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}


        if ( type == XsNumber.TYPE_INT ){
       		return ((double)i > x) ? xTrue : xFalse;
	}
	else {
		return (d > x) ? xTrue : xFalse;
	}


}

public XsObject gt ( int x ) {
        int i = 0;
	double d = 0.0;
	int type;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}


        if ( type == XsNumber.TYPE_INT ){
       		return (i > x) ? xTrue : xFalse;
	}
	else {
		return (d > (double)x) ? xTrue : xFalse;
	}
}


public int hashCode() {
	return str.hashCode();
}

public XsObject le ( String s ){
        return ((str.compareTo(s) <= 0) ? xTrue : xFalse);        
}

public XsObject le ( XsObject x ) {
	if ( x instanceof XsString ){
                return le(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return le(((XsNumber)x).ival);
		}
		else {
			return le(((XsNumber)x).dval);
		}
        }
        else{
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return le(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return le(((XsNumber)p).ival);
		        }
			else {
				return le(((XsNumber)p).dval);
			}
                }
                else if(p == xTrue){
		        return le(1);
                }
	        else if(p == xFalse || p == _undefined || p == _null){
		        return le(0);
	        } 
                else{
                        return xFalse;
                }                
        }
}

public XsObject le ( double x ) {
        int i = 0;
	double d = 0.0;
	int type;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}


        if ( type == XsNumber.TYPE_INT ){
       		return ((double)i <= x) ? xTrue : xFalse;
	}
	else {
		return (d <= x) ? xTrue : xFalse;
	}


}

public XsObject le ( int x ) {
        int i = 0;
	double d = 0.0;
	int type;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}


        if ( type == XsNumber.TYPE_INT ){
       		return (i <= x) ? xTrue : xFalse;
	}
	else {
		return (d <= (double)x) ? xTrue : xFalse;
	}
}

public XsObject lt ( String s ){
        return ((str.compareTo(s) < 0) ? xTrue : xFalse);        
}

public XsObject lt ( XsObject x ) {
	if ( x instanceof XsString ){
                return lt(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return lt(((XsNumber)x).ival);
		}
		else {
			return lt(((XsNumber)x).dval);
		}
        }
        else{
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return lt(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return lt(((XsNumber)p).ival);
		        }
			else {
				return lt(((XsNumber)p).dval);
			}
                }
                else if(p == xTrue){
		        return lt(1);
                }
	        else if(p == xFalse || p == _undefined || p == _null){
		        return lt(0);
	        }
                else{
                        return xFalse;
                }
         }
}

public XsObject lt ( double x ) {
        int i = 0;
	double d = 0.0;
	int type;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}


        if ( type == XsNumber.TYPE_INT ){
       		return ((double)i < x) ? xTrue : xFalse;
	}
	else {
		return (d < x) ? xTrue : xFalse;
	}


}

public XsObject lt ( int x ) {
        int i = 0;
	double d = 0.0;
	int type;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return xFalse;
	}


        if ( type == XsNumber.TYPE_INT ){
       		return (i < x) ? xTrue : xFalse;
	}
	else {
		return (d < (double)x) ? xTrue : xFalse;
	}
}

public XsObject minus (String s){
        int i = 0, si = 0;
	double d = 0.0, sd = 0.0;
	int type, stype;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		if(str.equals("")){
			i = 0;
			type = XsNumber.TYPE_INT;
                }
                else
                        return XsNumber.NaN;
	}

       
        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.parseInt(s);
			stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xx ) {
		if(s.equals("")){
			si = 0;
			stype = XsNumber.TYPE_INT;
                }
                else 
                        return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT ){
		if ( stype == XsNumber.TYPE_INT ){
			return new XsNumber( i - si);
		}
		else {
                        return new XsNumber( i - sd);
		}
	}
	else {
		if ( stype == XsNumber.TYPE_INT ){
			return new XsNumber( d - si);
		}
		else {
			return new XsNumber( d - sd);
		}
	}
}

public XsObject minus ( XsObject x ){

        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}

        XsNumber xn = XsNumber.getNumberFromObject(x);

        if ( type == XsNumber.TYPE_INT ){
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber( i - xn.ival);
		}
		else {
			return new XsNumber( i - xn.dval);
		}
	}
	else {
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber( d - xn.ival);
		}
		else {
			return new XsNumber( d - xn.dval);
		}
	}
}

public XsObject minus ( double xd ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}

        if ( type == XsNumber.TYPE_INT )
		return new XsNumber( i - xd);
	else 
	        return new XsNumber( d - xd);
}

public XsObject minus ( int xi ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT )
		return new XsNumber( i - xi);
	else 
	        return new XsNumber( d - xi);
}

public XsObject mod (String s){
        int i = 0, si = 0;
	double d = 0.0, sd = 0.0;
	int type, stype;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		if(str.equals(""))
			return new XsNumber(0.0);
                else
		        return XsNumber.NaN;
	}

       
        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.parseInt(s);
			stype = XsNumber.TYPE_INT;
        	}
	}
	catch ( NumberFormatException xx ) {
	        return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT ){
		if ( stype == XsNumber.TYPE_INT ){
			return new XsNumber( i % (double)si);
		}
		else {
                        return new XsNumber( i % sd);
		}
	}
	else {
		if ( stype == XsNumber.TYPE_INT ){
			return new XsNumber( d % si);
		}
		else {
			return new XsNumber( d % sd);
		}
	}


       
}

public XsObject mod ( XsObject x ){
	int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
                if(str.equals(""))
			return new XsNumber(0.0);
                else
		        return XsNumber.NaN;
	}

        XsNumber xn = XsNumber.getNumberFromObject(x);

        if ( type == XsNumber.TYPE_INT ){
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber( i % xn.ival);
		}
		else {
			return new XsNumber( i % xn.dval);
		}
	}
	else {
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber( d % xn.ival);
		}
		else {
			return new XsNumber( d % xn.dval);
		}
	}
}

public XsObject mod ( double xd ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT )
		return new XsNumber( i % xd);
	else 
	        return new XsNumber( d % xd);
}

public XsObject mod ( int xi ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT )
		return new XsNumber( i % xi);
	else 
	        return new XsNumber( d % xi);
}

public XsObject mul (String s){
        int i = 0, si = 0;
	double d = 0.0, sd = 0.0;
	int type, stype;
	

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
                if(str.equals(""))
		        return new XsNumber(0.0);
                else 
                        return XsNumber.NaN;
	}


        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.parseInt(s);
			stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xx ) {
		if(s.equals(""))
		        return new XsNumber(0.0);
                else 
                        return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT ){
		if ( stype == XsNumber.TYPE_INT ){
			return new XsNumber( i * si);
		}
		else {
                        return new XsNumber( i * sd);
		}
	}
	else {
		if ( stype == XsNumber.TYPE_INT ){
			return new XsNumber( d * si);
		}
		else {
			return new XsNumber( d * sd);
		}
	}
}

public XsObject mul ( XsObject x ){

	int i = 0, xi=0;
	double d = 0.0, xd = 0.0;
	int type, xtype;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}

        XsNumber xn = XsNumber.getNumberFromObject(x);
	//        System.out.println("HERE " + xn);
        if ( type == XsNumber.TYPE_INT ){
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber( i * xn.ival);
		}
		else {
			return new XsNumber( i * xn.dval);
		}
	}
	else {
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber( d * xn.ival);
		}
		else {
			return new XsNumber( d * xn.dval);
		}
	}      
}

public XsObject mul ( double xd ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT )
		return new XsNumber( i * xd);
	else 
	        return new XsNumber( d * xd);
}

public XsObject mul ( int xi ){
        int i = 0;
	double d = 0.0;
	int type;
	
	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
		if(str.equals(""))
                	return new XsNumber(0);
                else
                        return XsNumber.NaN;
	}


        if ( type == XsNumber.TYPE_INT )
		return new XsNumber( i * xi);
	else 
	        return new XsNumber( d * xi);
}

public XsObject neg ( ) {
        int i = 0;
	double d = 0.0;
	int type;

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
	        return XsNumber.NaN; 
	}

        
        if ( type == XsNumber.TYPE_INT )
		return new XsNumber(-i);
	else 
	        return new XsNumber(-d);
}

public XsObject not ( ) {
        int i = 0;
	double d = 0.0;
	int type;

	try {
		if ( XsNumber.assumedFloat( str) ){
			d = Double.parseDouble(str);
			type = XsNumber.TYPE_FLOAT;
		}
		else {
			i = Integer.decode(str).intValue();
			type = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException xxx ) {
	        return new XsNumber(-1); // js behavior
	}

        
        if ( type == XsNumber.TYPE_INT )
		return new XsNumber(~i);
	else 
	        return new XsNumber(~(int)d);


}

public XsObject or ( String s ){
	int i= 0;
	double d = 0.0;
        	
        try {
		if ( XsNumber.assumedFloat( s) ){
			d = Double.parseDouble(s);
			return or(d);
	       	}
		else {
			i = Integer.parseInt(s);
			return or(i);
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject or ( XsObject x ){
       	XsNumber xn = XsNumber.getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == XsNumber.TYPE_INT ){
			return or(xn.ival);
		}
		else {
			return or(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}
	
public XsObject or ( double d ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
		return new XsNumber( si | (int)d);
	}
	else {
		return new XsNumber( (int)sd | (int)d);
	}
}

public XsObject or ( int i ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
                
		return new XsNumber( si | i);
	}
	else {
		return new XsNumber( (int)sd | i);
	}
}

public XsObject plus ( String s ){
	return new XsString( str + s);
}

public XsObject plus ( XsObject x ){
        XsObject p;

        if(!(x instanceof XsDate)){
		p = XsObject.getPrimitiveFromObject(x);
        }
        else{
		p = XsObject.getPrimitiveFromDate(x);
        }
 
        if(p instanceof XsString){
                return plus(p.toString());
        }
        else if(p instanceof XsNumber){
		if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
			return plus(((XsNumber)p).ival);
		}
		else {
			return plus(((XsNumber)p).dval);
		}
        }
        else{   
                //try toString
		
                XsObject func;

                if(!(x instanceof XsDate)){
			func = x.xsGet("toString");
		}
		else{
			func = x.xsGet("valueOf");
		}
                
                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
                        if(x == _null || x == _undefined){
				return plus(x.toString());
                        }
                        else{
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
                        } 
                }                                  	
	        else{   
                       XsObject o = func.invoke(x);
                       
                       if(o instanceof XsString ||
                          o instanceof XsNumber ||
                          o instanceof XsArray  ||
                          o instanceof XsFunc 
                         )
		       {
				       return plus(o);
		       } 
                       else{//System.err.println("HERE HERE");
			       System.err.println("TypeError: can't convert Object to primitive type");
			       return _undefined;
                       }   
                }
        }  
}

public XsObject plus ( double d ){
	return new XsString( str + Double.toString(d));
}

public XsObject plus ( int i ){
	return new XsString( str + Integer.toString( i));
}

public XsObject seq ( String s ){
	return (str.equals(s)) ? xTrue : xFalse;
}

public XsObject seq ( XsObject x ) {
        if(x instanceof XsString)
         	return eq(x.toString());
        else 
		return xFalse;         
}

public XsObject seq ( double d ) {
	return xFalse;
}

public XsObject seq ( int i ) {
	return xFalse;
}
	/*
void set ( String s ){
	str = s;
}
	*/
public XsObject shl ( String s ){
	int i= 0;
	double d = 0.0;
        	
        try {
		if ( XsNumber.assumedFloat( s) ){
			d = Double.parseDouble(s);
			return shl(d);
	       	}
		else {
			i = Integer.parseInt(s);
			return shl(i);
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject shl ( XsObject x ){
       	XsNumber xn = XsNumber.getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == XsNumber.TYPE_INT ){
			return shl(xn.ival);
		}
		else {
			return shl(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}
	
public XsObject shl ( double d ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
		return new XsNumber( si << (int)d);
	}
	else {
		return new XsNumber( (int)sd << (int)d);
	}
}

public XsObject shl ( int i ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
      		return new XsNumber( si << i);
	}
	else {
		return new XsNumber( (int)sd << i);
	}
}

public XsObject shr ( String s ){
	int i= 0;
	double d = 0.0;
        	
        try {
		if ( XsNumber.assumedFloat( s) ){
			d = Double.parseDouble(s);
			return shr(d);
	       	}
		else {
			i = Integer.parseInt(s);
			return shr(i);
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject shr ( XsObject x ){
       	XsNumber xn = XsNumber.getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == XsNumber.TYPE_INT ){
			return shr(xn.ival);
		}
		else {
			return shr(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}
	
public XsObject shr ( double d ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
		return new XsNumber( si >> (int)d);
	}
	else {
		return new XsNumber( (int)sd >> (int)d);
	}
}

public XsObject shr ( int i ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
                return new XsNumber( si >> i);
	}
	else {
		return new XsNumber( (int)sd >> i);
	}
}

public XsObject toBoolean(){
        if(str.equals(""))
		return xFalse;
        else
                return xTrue;
}

public String toString() {
	return str;
}

public XsObject ushr ( String s ){
	int i= 0;
	double d = 0.0;
        	
        try {
		if ( XsNumber.assumedFloat( s) ){
			d = Double.parseDouble(s);
			return ushr(d);
	       	}
		else {
			i = Integer.parseInt(s);
			return ushr(i);
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject ushr ( XsObject x ){
       	XsNumber xn = XsNumber.getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == XsNumber.TYPE_INT ){
			return ushr(xn.ival);
		}
		else {
			return ushr(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}
	
public XsObject ushr ( double d ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
		return new XsNumber( si >>> (int)d);
	}
	else {
		return new XsNumber( (int)sd >>> (int)d);
	}
}

public XsObject ushr ( int i ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
                return new XsNumber( si >>> i);
	}
	else {
		return new XsNumber( (int)sd >>> i);
	}
}

public XsObject valueOf (){
	return new XsString(str);
}

public XsObject xor ( String s ){
	int i= 0;
	double d = 0.0;
        	
        try {
		if ( XsNumber.assumedFloat( s) ){
			d = Double.parseDouble(s);
			return xor(d);
	       	}
		else {
			i = Integer.parseInt(s);
			return xor(i);
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject xor ( XsObject x ){
       	XsNumber xn = XsNumber.getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == XsNumber.TYPE_INT ){
			return xor(xn.ival);
		}
		else {
			return xor(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}
	
public XsObject xor ( double d ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
		return new XsNumber( si ^ (int)d);
	}
	else {
		return new XsNumber( (int)sd ^ (int)d);
	}
}

public XsObject xor ( int i ){
        int si= 0;
	double sd = 0.0;
        int stype = 0; 	

        try {
		if ( XsNumber.assumedFloat( str) ){
			sd = Double.parseDouble(str);
		        stype = XsNumber.TYPE_FLOAT;
                }
		else {
			si = Integer.decode(str).intValue();
                        stype = XsNumber.TYPE_INT;
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}


        if ( stype == XsNumber.TYPE_INT ){
                
		return new XsNumber( si ^ i);
	}
	else {
		return new XsNumber( (int)sd ^ i);
	}
}

public XsObject xsGet ( String key ) {

	//System.out.println("IN HERE key is " + key);
	char c = key.charAt(0);
        
	if ( (c >= '0') && (c <= '9') ){
	        try {
	                int idx = Integer.parseInt( key);
			return xsGet( idx);
		}
		catch ( Exception x ) {
                       return super.xsGet(key);
                }
        }
        else if(key.equals("length")){
                return new XsNumber(str.length());
        }
	/*  else if(key.equals( "prototype") ){
                System.out.println("IN HERE String");
      		return string__proto__; 
		}*/
        else{
		return super.xsGet(key);
        }
}

public XsObject xsGet(XsNumber xn){
        if ( xn.type == XsNumber.TYPE_INT ){
                return xsGet(xn.ival); 
	}
        else{
                return xsGet((int)xn.dval); 
        }  
}

//Netscape extension
public XsObject xsGet ( int idx ){
	
        char chars[] = new char[1];

        try{
		chars[0] = str.charAt(idx);
        }
        catch(StringIndexOutOfBoundsException e){
		return _undefined; 
        }
	
        return new XsString(new String(chars));
}

public XsString xsGetType() {
        if(isObject)
		return typeStrObj;
        else
                return typeStr;
}
	
//not sure about this one yet
public XsObject xsPut ( String key, XsObject val ) {
	if ( key.equals("prototype") ){
                if(canPut(key)){ 
			string__proto__ = val;
                }
	}
	else {
		super.xsPut( key, val);
	}
	
	return val;
}



} // class















