/*
 * calibrate.h - calibrate master header (only included part in clients)
 * 
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: calibrate.h,v 1.6 2001/07/25 22:53:03 samc Exp $ 
 */

/* calibrate header epilog */ /*{{{*/
#ifndef CALIBRATE_H_INCLUDED
#define CALIBRATE_H_INCLUDED

/* include the main config file */
#include "config.h"

#include "fgl.h"
#include "buttons.h"
#include "cursor.h"
#include "screens.h"

/* define global variables */
fgl_font_t       *font;
fgl_bitmap_t     *background;

#endif /* CALIBRATE_H_INCLUDED */
