/* -*- mode: C; mode: fold -*- */ 

#include <sys/timeb.h>
#include <unistd.h>
#include <stdio.h>

int main ( int argc, char* argv[] ) /*{{{*/
{

  struct timeb start,end;
  float time,f,fp,fp1,fp2,fp3;

  /* set the test cases */

  /* run test 0 */

  ftime(&start);
  for (f = -2.35; f < 1.567 ;f += 0.1) {
    for (fp = -100000.35; fp <1000000.567 ;fp += 0.05) {
      fp1 = fp * fp;
      fp2 = fp1 /fp;
      fp3 = fp2 + fp1 + fp1;
      fp2 = fp2 + fp3 - fp1;
      fp1 = fp1 / fp2 * fp3;
    }
  }
  ftime(&end);
  time = end.time - start.time + (end.millitm - start.millitm)/1000.0;
  
  fprintf(stderr,"FP TEST TIME (%8.3f)\n",time);

  return 1;
}
/*}}}*/
