/*
 * ximage_ge.c - fgl module to map a virtual framebuffer to X
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 *
 * $tvt: xpixel_gen.c,v 1.3 2001/07/04 00:47:55 samc Exp $
 */

void
setupXPixelMap ()
{
	/* nothing to do, we use the fgl RGB values */
}

u32
getXPixelBackground ()
{
	return BlackPixel( xDsp, xScr);
}

inline
unsigned long
getXPixel ( fgl_color_t c )
{
	int r, g, b;

	fgl_getRgbValues( c, &r, &g, &b);

	return  (slshift( (b & xBlueMask), xBlueShift) |
			 slshift( (g & xGreenMask), xGreenShift) |
			 slshift( (r & xRedMask), xRedShift));
}
