/*
 * io_posix.h - header file for (blocked) posix-like IO
 *
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


static inline
int _ipl_select ( int  n,
				  fd_set *readfds, fd_set *writefds, fd_set *exceptfds,
				  struct timeval *timeout )
{
	return select( n, readfds, writefds, exceptfds, timeout);
}

static inline
int _ipl_threadedFd ( int fd )
{
	return fd;
}

static inline
int _ipl_read ( int fd, void *buf, size_t count )
{
	return read( fd, buf, count);
}

static inline
int _ipl_write ( int fd, void *buf, size_t count )
{
	return write( fd, buf, count);
}
