# Makefile.frag for kaffevm MEM support
#
# Copyright (c) 1996-2000
#	Transvirtual Technologies, Inc.  All rights reserved.
#
# See the file "license.terms" for information on usage and redistribution 
# of this file. 

BOEHM_SRCDIR=$(srcdir)/mem3/boehm
BOEHM_OBJECTS=\
		allchblk.o \
		alloc.o \
		blacklst.o \
		dbg_mlc.o \
		dyn_load.o \
		finalize.o \
		gc_dlopen.o \
		headers.o \
		linux_threads.o \
		mach_dep.o \
		malloc.o \
		mallocx.o \
		mark.o \
		mark_rts.o \
		misc.o \
		new_hblk.o \
		obj_map.o \
		os_dep.o \
		ptr_chck.o \
		reclaim.o \
		specific.o \
		stubborn.o \
		typd_mlc.o

BOEHM_INCLUDE=	-I$(srcdir)/mem3/boehm/include
BOEHM_DEFINES=\
		-DATOMIC_UNCOLLECTABLE \
		-DNO_SIGNALS \
		-DGC_LINUX_THREADS \
		-DSILENT \
		-DNO_DEBUGGING \
		-D_REENTRANT

MEM_OBJECTS=	$(BOEHM_OBJECTS)
MEM_CFLAGS=

$(MEM_OBJECTS):
	$(CC) $(CFLAGS) $(BOEHM_INCLUDE) $(BOEHM_DEFINES) -c $(BOEHM_SRCDIR)/$*.c -o $*.o
