/*
 * dummy java.security class to enable a java.awt.AWTPermission compile
 */

package java.security;

public abstract class BasicPermission extends Permission  {

	public BasicPermission(String name) {
		super(name);
	}

	public BasicPermission(String name, String actions) {
		super(name);
	}

	public boolean implies(Permission p) {
		return false;
	}

	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (!obj.getClass().equals(getClass())) {
			return false;
		}
		return getName().equals(((BasicPermission)obj).getName());
	}

	public int hashCode() {
		return getName().hashCode();
	}

	public String getActions() {
		return "";
	}
}

