/* config/config.h.  Generated automatically by configure.  */
/*
 * config.h.in
 * Template for autoconf configuration.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

/* Define this is dlsym need an underscore prefix */
/* #undef	HAVE_DYN_UNDERSCORE */

/* Define this if C name's have a prepended underscore */
/* #undef	HAVE_UNDERSCORED_C_NAMES */

/* Do we have memcpy */
#define	HAVE_MEMCPY 1

/* Do we have memmove */
/* #undef	HAVE_MEMMOVE */

/* Do we have stdio.h */
#define HAVE_STDIO_H 1

/* Do we have stddef.h */
/* #undef HAVE_STDDEF_H */

/* Do we have errno.h */
#define HAVE_ERRNO_H 1

/* Do we have assert.h */
#define HAVE_ASSERT_H 1

/* Do we have sys_errlist[] */
/* #undef HAVE_SYS_ERRLIST */

/* Do we have unistd.h */
/* #undef	HAVE_UNISTD_H */

/* Do we have io.h */
#define	HAVE_IO_H 1

/* Do we have socket.h */
/* #undef	HAVE_SOCKET_H */

/* Do we have sys/socket.h */
/* #undef	HAVE_SYS_SOCKET_H */

/* Do we have sys/select.h */
/* #undef	HAVE_SYS_SELECT_H */

/* Is function select declared */
/* #undef  HAVE_DECLARED_SELECT */

/* Do we have sys/time.h */
/* #undef	HAVE_SYS_TIME_H */

/* Do we have sys/timeb.h */
#define	HAVE_SYS_TIMEB_H 1

/* Do we have sys/ioctl.h */
/* #undef	HAVE_SYS_IOCTL_H */

/* Do we have fcntl.h */
#define	HAVE_FCNTL_H 1

/* Do we have sys/param.h */
/* #undef	HAVE_SYS_PARAM_H */

/* Do we have sys/utsname.h */
#define	HAVE_SYS_UTSNAME_H 1

/* Do we have pwd.h */
/* #undef	HAVE_PWD_H */

/* Do we have dlfcn.h */
/* #undef  HAVE_DLFCN_H */

/* Do we have dl.h */
/* #undef  HAVE_DL_H */

/* Do we have windows.h */
/* #undef HAVE_WINDOWS_H */

/* Do we have windef.h */
/* #undef HAVE_WINDEF_H */

/* Do we have winnt.h */
/* #undef	HAVE_WINNT_H */

/* Do we have wintypes.h */
/* #undef	HAVE_WINTYPES_H */

/* Do we have wtypes.h */
/* #undef  HAVE_WTYPES_H */

/* Do we have winbase.h */
#define	HAVE_WINBASE_H 1

/* Do we have winsock.h */
/* #undef	HAVE_WINSOCK_H */

/* Do we have winsoc2.h */
#define	HAVE_WINSOCK2_H 1

/* Do we have bsd/libc.h */
/* #undef	HAVE_BSD_LIBC_H */

/* Do we have sys/types.h */
#define	HAVE_SYS_TYPES_H 1

/* Do we have dirent.h */
/* #undef	HAVE_DIRENT_H */

/* Do we have sys/ndir.h */
/* #undef	HAVE_SYS_NDIR_H */

/* Do we have ndir.h */
/* #undef	HAVE_NDIR_H */

/* Do we have sys/dir.h */
/* #undef	HAVE_SYS_DIR_H */

/* Do we have direct.h */
#define HAVE_DIRECT_H 1

/* Do we have malloc.h */
#define	HAVE_MALLOC_H 1

/* Do we have alloca.h */
/* #undef	HAVE_ALLOCA_H */

/* Do we have memory.h */
#define	HAVE_MEMORY_H 1

/* Do we have sys/filio.h */
/* #undef	HAVE_SYS_FILIO_H */

/* Do we have asm/sigcontext.h - linuxism */
/* #undef	ASM_SIGCONTEXT_H */

/* Do we have asm/signal.h */
/* #undef	HAVE_ASM_SIGNAL_H */

/* Do we have sigcontext.h - linuxism */
/* #undef	HAVE_SIGCONTEXT_H */

/* Do we have signal.h */
#define	HAVE_SIGNAL_H 1

/* Do we have features.h. */
/* #undef	HAVE_FEATURES_H */

/* Do we have mach-o/rld.h - a Machism */
/* #undef	HAVE_MACH_O_RLD_H */

/* Do we have sys/stat.h */
#define	HAVE_SYS_STAT_H 1

/* Do we have string.h */
#define	HAVE_STRING_H 1

/* Do we have sys/wait.h */
/* #undef	HAVE_SYS_WAIT_H */

/* Do we have zlib.h */
/* #undef	HAVE_ZLIB_H */

/* Do we have jpeglib.h */
#define HAVE_JPEGLIB_H 1

/* Do we have png.h */
/* #undef HAVE_PNG_H */

/* Do we have gif_lib.h */
#define HAVE_GIF_LIB_H 1

/* Do we have libgif.a */
/* #undef HAVE_LIBGIF */

/* Do we have libungif.a */
#define	HAVE_LIBUNGIF 1

/* Do we have libjpeg.a */
#define	HAVE_LIBJPEG 1

/* Do we have netinet/tcp.h */
/* #undef	HAVE_NETINET_TCP_H */

/* Do we have netinet/in.h */
/* #undef	HAVE_NETINET_IN_H */

/* Do we have netdb.h */
/* #undef	HAVE_NETDB_H */

/* We we have gmp.h */
/* #undef	HAVE_GMP_H */

/* Do we have strerror */
/* #undef	HAVE_STRERROR */

/* Do we support the IEEE remainder operation */
/* #undef	HAVE_REMAINDER */

/* Do we support the IEEE remainderf operation */
/* #undef	HAVE_REMAINDERF */

/* Do we have IEEE finite */
/* #undef	HAVE_FINITE */

/* Do we have fmod */
/* #undef	HAVE_FMOD */

/* Do we have drem */
/* #define	HAVE_DREM */

/* Do we have floor */
#define	HAVE_FLOOR 1

/* Do we have ceil */
#define	HAVE_CEIL  1

/* Do we have isinf */
/* #undef	HAVE_ISINF */

/* Do we have isnan */
/* #undef	HAVE_ISNAN */

/* Do we have gettimeofday */
/* #undef	HAVE_GETTIMEOFDAY */

/* Do we have ftime */
/* #undef	HAVE_FTIME */

/* Do we have _ftime */
/* #undef HAVE__FTIME */

/* Do we have time */
/* #undef	HAVE_TIME */

/* Do we have localtime */
/* #undef	HAVE_LOCALTIME */

/* Do we have strftime */
/* #undef	HAVE_STRFTIME */

/* Do we have tzset */
/* #undef	HAVE_TZSET */

/* Do we have char* tzname[] */
/* #undef	HAVE_TZNAME */

/* Do we have asctime */
#define	HAVE_ASCTIME 1

/* Do we have getuid */
/* #undef	HAVE_GETUID */

/* Do we have uname */
#define	HAVE_UNAME 1

/* Do we have ioctl */
/* #undef	HAVE_IOCTL */

/* Do we have fcntl */
#define	HAVE_FCNTL 1

/* Do we have getpagesize */
/* #undef	HAVE_GETPAGESIZE */

/* Do we have strtod */
#define	HAVE_STRTOD 1

/* Do we have strdup */
#define	HAVE_STRDUP 1

/* Do we have sprintf */
#define	HAVE_SPRINTF 1

/* Do we have setitimer */
/* #undef	HAVE_SETITIMER */

/* Do we have sigprocmask */
/* #undef	HAVE_SIGPROCMASK *.

/* Do we have sigsetmask */
/* #undef	HAVE_SIGSETMASK */

/* Do we have sigemptyset */
/* #undef	HAVE_SIGEMPTYSET */

/* Do we have sigaddset */
/* #undef	HAVE_SIGADDSET */

/* We we have signal */
/* #undef	HAVE_SIGNAL */

/* Do we have sigaction */
/* #undef	HAVE_SIGACTION */

/* Do we have alarm */
/* #undef	HAVE_ALARM */

/* Do we have getcwd */
#define	HAVE_GETCWD 1

/* Do we have getwd */
/* #undef	HAVE_GETWD */

/* Do we have mmap */
/* #undef	HAVE_MMAP */

/* Do we mallopt.h - linuxism */
/* #undef	HAVE_MALLOPT */

/* Do we have sbrk */
/* #undef	HAVE_SBRK */

/* Do we have memalign */
/* #undef	HAVE_MEMALIGN */

/* Do we have valloc */
/* #undef	HAVE_VALLOC */

/* Do we have dlerror */
/* #undef	HAVE_DLERROR */

/* Do we have fork */
/* #undef	HAVE_FORK */

/* Do we have execve */
/* #undef	HAVE_EXECVE */

/* Do we have execvp */
/* #undef	HAVE_EXECVP */

/* Do we have waitpid */
/* #undef	HAVE_WAITPID */

/* Do we have kill */
/* #undef	HAVE_KILL */

/* Do we have sync */
/* #undef	HAVE_SYNC */

/* Do we have fsync */
/* #undef	HAVE_FSYNC */

/* Do we have dlopen */
/* #undef	HAVE_DLOPEN */

/* Do we have rld_load */
/* #undef	HAVE_RLD_LOAD */

/* Do we have shl_load */
/* #undef	HAVE_SHL_LOAD */

/* Do we have LoadLibrary */
/* #undef	HAVE_LOADLIBRARY */

/* Do we have dld_link */
/* #undef	HAVE_DLD_LINK */

/* Do we have select */
#define	HAVE_SELECT 1

/* Do we have sprintf */

#define	HAVE_SPRINTF 1

/* Do we have wsprintf */
#define	HAVE_WSPRINTF 1

/* How big are shorts */
#define	SIZEOF_SHORT 2

/* How big are ints */
#define	SIZEOF_INT 4

/* How big are long */
#define	SIZEOF_LONG 4

/* How big are long longs */
#define	SIZEOF_LONG_LONG 0

/* How big are __int64s */
#define	SIZEOF___INT64 8

/* How big are pointers */
#define	SIZEOF_VOIDP 4

/* How big are booleans */
#define	SIZEOF_BOOLEAN 4

/* How are pointers aligned */
#define ALIGNMENTOF_VOIDP 4

/* Do we have sigcontext */
/* #undef	HAVE_STRUCT_SIGCONTEXT */

/* Do we have sigcontext_struct */
/* #undef	HAVE_STRUCT_SIGCONTEXT_STRUCT */

/* Do we have tm_zone */
#define	HAVE_TM_ZONE 1

/* Are we bigendian */
/* #undef	WORDS_BIGENDIAN */

/* Do we have amask instruction on alpha */
/* #undef  HAVE_ALPHA_ASM_AMASK */

/* Do we have 'standard' dynamic libraries */
/* #undef	HAVE_LIBDL */

/* Do we have Gnu's dynamic libraries */
/* #undef	HAVE_LIBDLD */

/* Do we have the maths library */
#define	HAVE_LIBM 1

/* Do we have the compression library */
/* #undef	HAVE_LIBZ */

/* Do we have the GNU MP library */
/* #undef	HAVE_LIBGMP */

/* Do we have X support */
/* #undef	HAVE_X */

/* Which libraries are we using */
#define	HAVE_LIBRARY_NATIVE 1
#define	HAVE_LIBRARY_IO 1
#define	HAVE_LIBRARY_NET 1
#define	HAVE_LIBRARY_MATH 1
#define	HAVE_LIBRARY_ZIP 1
#define	HAVE_LIBRARY_MANAGEMENT 1
#define HAVE_LIBRARY_AWT 1

#undef	HAVE_LIBRARY_MICROSOFT

/* Do we use native threads and locks */
/* #undef	USE_NATIVE_THREADS */
/* #undef	USE_NATIVE_LOCKS */

/* The shared library suffix */
#define	LIBRARYSUFFIX ".dll"

/* Kaffe version number */
#define	KAFFEVERSION "1.00"

/* Define default KAFFEHOME, CLASSPATH & LIBRARYHOME */
#define	DEFAULT_KAFFEHOME "C:\\KAFFE"
/* #undef	DEFAULT_CLASSPATH */
/* #undef	DEFAULT_LIBRARYHOME */

/* Define the version we're compiling for */
#define	ARCHOS "i386-win32"

/* What kind of engine are we using - these should be removed at some point */
#define	TRANSLATOR 1
/* #undef	INTERPRETER */

/* Do we include the code verifier */
#define	HAVE_VERIFIER 1

/* Do we impose a timelimit */
/* #undef	TIMELIMIT */

/* Define the linking configuration */
#define	NO_SHARED_VMLIBRARY 1
#define	NO_SHARED_LIBRARIES 1

/* Do we have GNU GCJ support */
/* #undef	HAVE_GCJ_SUPPORT */

/* Provide default types which might be missing */
/* #undef	size_t */
#define		ssize_t	int
/* #undef	off_t */
/* #undef	fd_set */
/* #undef	time_t */

/* Provide for inline */
/* #undef 	inline */

/* the thread system in use */
/* #undef UNIX_JTHREADS */

/* do we want the AWT to run multithreaded */
/* #undef USE_THREADED_AWT */

/* Include any fixups (hacks) */
#include "config-hacks.h"
