/*
 * arm/linux/md.h
 * Linux ARM configuration information.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __arm_linux_md_h
#define __arm_linux_md_h

#include "arm/common.h"
#include "arm/threads.h"

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

#undef	SP_OFFSET
#undef	FP_OFFSET
#define	SP_OFFSET	20
#define	FP_OFFSET	19

#endif
