/*
 * arm32/threads.h
 * arm32 threading information.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __arm32_threads_h
#define __arm32_threads_h

/**/
/* Thread handling */
/**/
#define	USE_INTERNAL_THREADS

#if defined(TRANSLATOR)
#define	THREADSTACKSIZE		(64 * 1024)
#else
#define	THREADSTACKSIZE		(128 * 1024)
#endif

/*
 * Stack offset.
 * This is the offset into the setjmp buffer where the stack pointer is
 * stored.  This may be different with different OSes.
 */
#define	SP_OFFSET		23

#endif
