/*
 * i386/msdos/md.h
 * MSDOS i386 configuration information.
 *
 * Copyright (c) 1996, 1997, 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __i386_msdos_md_h
#define __i386_msdos_md_h

#include "i386/common.h"
#include "i386/threads.h"

#undef	SP_OFFSET
#define	SP_OFFSET	7

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

/**/
/* Override standard paths.h settings */
/**/

#define	PATHSEP		";"
#define	DIRSEP		"\\"

/**/
/* Exception handling information. */
/**/

#include <setjmp.h>
#include <sys/exceptn.h>

/* Function prototype for signal handlers */
#define	EXCEPTIONPROTO							\
	int sig, void* ctx

/* Get the first exception frame from a signal handler */
#define	EXCEPTIONFRAME(f, c)						\
	(f).return_frame = (void*)__djgpp_exception_state->__ebp;	\
	(f).return_pc = (void*)__djgpp_exception_state->__eip 

/* We have a non-standard way of giving the maximum signal */
#define	NSIG	SIGMAX

#endif
