#include "m68k/jit-icode.h"

#define	HAVE_move_register_int		movereg_RR
#define	HAVE_move_register_ref		movereg_RR

#define HAVE_or_int_const               ori_RRC
#define HAVE_xor_int_const              xori_RRC

#define HAVE_or_int_const_rangecheck(v)         (1)
#define HAVE_xor_int_const_rangecheck(v)        (1)

#define	HAVE_load_addr_int		loadi_RxA
#define	HAVE_load_addr_ref		loadr_RxA
#undef	HAVE_load_addr_long
#undef	HAVE_load_addr_byte
#undef	HAVE_load_addr_char
#undef	HAVE_load_addr_short

#define	HAVE_store_addr_int		storei_xRA
#define	HAVE_store_addr_ref		storer_xRA
#undef	HAVE_store_addr_long
#undef	HAVE_store_addr_byte
#undef	HAVE_store_addr_char
#undef	HAVE_store_addr_short

#define	HAVE_load_offset_scaled_int_rangecheck(c) m68k_s8_rangecheck(c)
#define	HAVE_load_offset_scaled_ref_rangecheck(c) m68k_s8_rangecheck(c)
#undef	HAVE_load_offset_scaled_long_rangecheck
#define	HAVE_load_offset_scaled_byte_rangecheck(c) m68k_s8_rangecheck(c)
#define	HAVE_load_offset_scaled_char_rangecheck(c) m68k_s8_rangecheck(c)
#undef	HAVE_load_offset_scaled_short_rangecheck
#define	HAVE_load_offset_scaled_int	loadi_RRRC
#define	HAVE_load_offset_scaled_ref	loadr_RRRC
#undef	HAVE_load_offset_scaled_long
#define	HAVE_load_offset_scaled_byte	loadb_RRRC
#define	HAVE_load_offset_scaled_char	loadc_RRRC
#undef	HAVE_load_offset_scaled_short

#define	HAVE_store_offset_scaled_int_rangecheck(c) m68k_s8_rangecheck(c)
#define	HAVE_store_offset_scaled_ref_rangecheck(c) m68k_s8_rangecheck(c)
#undef	HAVE_store_offset_scaled_long_rangecheck
#define	HAVE_store_offset_scaled_byte_rangecheck(c) m68k_s8_rangecheck(c)
#define	HAVE_store_offset_scaled_char_rangecheck(c) m68k_s8_rangecheck(c)
#undef	HAVE_store_offset_scaled_short_rangecheck
#define	HAVE_store_offset_scaled_int	storei_RRRC
#define	HAVE_store_offset_scaled_ref	storer_RRRC
#undef	HAVE_store_offset_scaled_long
#define	HAVE_store_offset_scaled_byte	storeb_RRRC
#define	HAVE_store_offset_scaled_char	stores_RRRC
#define	HAVE_store_offset_scaled_short	stores_RRRC

#define	HAVE_store_offset_byte_rangecheck(c)	m68k_s16_rangecheck(c)
#define	HAVE_store_offset_char_rangecheck(c)	m68k_s16_rangecheck(c)
#define	HAVE_store_offset_short_rangecheck(c)	m68k_s16_rangecheck(c)
#define	HAVE_store_offset_byte		storeb_xRRC
#define	HAVE_store_offset_char		stores_xRRC
#define	HAVE_store_offset_short		stores_xRRC

#define	HAVE_fakecall			fakecall_xCC

#define	HAVE_cmp_offset_int		cmp_xRRC

#if !defined(HAVE_NO_FLOATING_POINT)

#undef	HAVE_load_offset_scaled_float
#undef	HAVE_load_offset_scaled_double

#undef	HAVE_store_offset_scaled_float
#undef	HAVE_store_offset_scaled_double

#undef	HAVE_load_addr_float
#undef	HAVE_load_addr_double

#undef	HAVE_store_addr_float
#undef	HAVE_store_addr_double

#undef	HAVE_neg_float
#undef	HAVE_neg_double

#endif
