/*
 * mips/irix5/md.h
 * Irix 5 MIPS configuration information.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __mips_irix5_md_h
#define __mips_irix5_md_h

#include "mips/threads.h"
#include "mips/common.h"

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

#include "mips/fixupinline.c"

#include <sys/ucontext.h>

/* Function prototype for signal handlers */
#define	EXCEPTIONPROTO						\
	int sig, siginfo_t *sip, ucontext_t *ctx

/* WAS int sig, int code, struct sigcontext* ctx, char* addr */

#define	EXCEPTIONFIXRETURN() \
	__mipsFixup(ctx->uc_mcontext.gregs[CTX_EPC], ctx->uc_mcontext.gregs[CTX_S8])

#define	EXCEPTIONFRAME(f, c)					\
	(f).return_frame = (void*)(c)->uc_mcontext.gregs[CTX_S8];      \
	(f).return_pc = (void*)(c)->uc_mcontext.gregs[CTX_EPC];

/* WAS	(f).return_frame = (c)->sc_regs[29];                    \
	(f).return_pc = (c)->sc_pc */

#endif
