/*
 * nets.h
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: nets.h,v 1.5 2001/07/09 22:43:00 samc Exp $
 */

#ifndef __nets_h
#define __nets_h

#include "config.h"
#include "config-mem.h"
#if defined(HAVE_ERRNO_H)
#include <errno.h>
#endif

extern int errno;
#if !defined(__WIN32__)
extern int h_errno;
#endif

#define	MAXHOSTNAME	128

#if defined(HAVE_STRERROR)
#define	SYS_ERROR	strerror(errno)
#elif defined(HAVE_SYS_ERRLIST)
extern char* sys_errlist[];
#define	SYS_ERROR	sys_errlist[errno]
#else
#define	SYS_ERROR	"Cannot determine error"
#endif

#if defined(HAVE_HSTRERROR)
#define	SYS_HERROR	hstrerror(h_errno)
#else
#define	SYS_HERROR	"Network error"
#endif

#endif
