/*
 * util.c
 * Extra routine need for support.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include "jtypes.h"
#include "constants.h"

Utf8Const*
makeUtf8Const(char* s, int len)
{
	Utf8Const* m;

	m = (Utf8Const*)malloc(sizeof(Utf8Const) + len + 1);
	memcpy(m->data, s, len);
	m->data[len] = 0;
	m->length = len;
	return (m);
}
