/*
 * callMethodInfo.h
 *
 * Copyright (c) 1996, 1997
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __callMethodInfo_h
#define __callMethodInfo_h

#define MAXMARGS                16

typedef struct _callMethodInfo {
        void*                   function;
        jvalue*                 args;
        jvalue*                 ret;
        int                     nrargs;
        int                     argsize;
        char                    retsize;
        char                    rettype;
        char                    callsize[MAXMARGS];
        char                    calltype[MAXMARGS];
} callMethodInfo;

#endif
