static
inline
codeinfo* 
allocCodeInfo(uint32 codelen)
{
        return ((codeinfo*)gc_malloc_fixed_typed(sizeof(codeinfo) + codelen * sizeof(uintp), GC_ALLOC_ANALYSE));
}

static
inline
void
freeCodeInfo(codeinfo* obj)
{
	gc_free_fixed(obj);
}

static
inline
localUse* 
allocLocalUse(uint32 n_locals)
{
        return ((localUse*)gc_malloc_fixed_typed(n_locals * sizeof(localUse), GC_ALLOC_ANALYSE));
}

static
inline
void
freeLocalUse(localUse* obj)
{
	gc_free_fixed(obj);
}

static
inline
frameElement* 
allocFrame(uint32 frame_sz)
{
        return ((frameElement*)gc_malloc_fixed_typed(frame_sz * sizeof(frameElement), GC_ALLOC_ANALYSE));
}

static
inline
void
freeFrame(frameElement* obj)
{
	gc_free_fixed(obj);
}
