/* 
 * jitsupport.c
 * Various auxiliary routinues
 *
 * Copyright (c) 1999 - 2001 
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __jitsupport_h
#define __jitsupport_h

extern boolean verify_strict( boolean, FILE *, const char *, ... );
extern boolean verify_check( boolean, FILE *, const char *, ... );

extern int count_bits( int, int * );
extern void * jit4_soft_multianewarray( Hjava_lang_Class *, jint, ... );
extern char * sigItemType( char ** );
extern int sigItemCount( char *, boolean );
extern char * sigReturnType( char * );
extern char sigToPrimType( char );

#define FAIL( _m ) \
	kprintf _m; \
	ABORT()

#endif
