/* 
 * stats.c
 * Garbage collector statistics.
 *
 * Copyright (c) 1999 - 2001
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "gc2.h"
#include "support.h"

#if defined (GC_STATS)
obj_stats gc_stats[MAX_GC_FUNCS];

void
gcPrintStats() 
{
	int n;
        kprintf("Detailed Allocation:\n");
        for (n = 0; n < 24; n++) {
		kprintf("%4s %4dK %4dKb\t",gcType(&gc_table[n]),gc_stats[n].cnt/1024,gc_stats[n].mem/1024);
		if ((n % 3) == 2) kprintf("\n");
        }
}
#endif
