/*
 * kvxworks.h
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __system_vxworks_kvxworks_h
#define __system_vxworks_kvxworks_h

/*
 * Thread structure.
 */
typedef struct nativeThread {
	int			tid;
	void*			stackBase;
	void*			stackEnd;
	Hjava_lang_Thread*	next;
} nativeThread;

/* Convert a Java timeout to a VxWorks one.
 */
#define	JAVATIMEOUT2VXWORKSTIMEOUT(T) \
	((unsigned long)((T)/(1000000/TICKS_PER_SEC)))

/* Convert a Java thread priority to a VxWorks one
 * We use 110 (high) to 100 (low)
 */
#define	JAVA_MAXPRIO	11
#define	JAVA_MINPRIO	1
#define	JAVAPRIO2VXWORKSPRIO(P)	(100+JAVA_MAXPRIO-(P))

/* Convert a Java thread pointer to a VxWorks one */
#define	NATIVE_THREAD(T)	((nativeThread*)unhand(T)->PrivateInfo)

#endif
