/**
 * clr.c - platform specific color management
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include "toolkit.h"


/******************************************************************************
 * generic exported methods
 */

#define _clrGetPixelValue     EXPORT(clrGetPixelValue)
#define _clrSetSystemColors   EXPORT(clrSetSystemColors)
#define _clrGetColorModel     EXPORT(clrGetColorModel)
#define _clrModBrightness     EXPORT(clrModBrightness)

/* go with the generic color initialization */
#define _initColorMapping     initColorMapping


/******************************************************************************
 * import generic color functionality
 */
#include "../clr-common.c"
