#include <jni.h>

#if !defined(NO_KAFFE)

#include <java_lang_Object.h>
#include <Arrays.h>

#endif

#include <java_lang_String.h>

/*
 * This is a last resort for debugging purposes, where something in the VM/libs is
 * so terribly broken that we can't rely on System.out/err anymore
 */
JNIEXPORT
void JNICALL
Java_kaffe_lang_Application_debug (JNIEnv* env, jclass clazz, jstring str)
{
        jboolean isCopy;
        jchar *jc = (jchar*) (*env)->GetStringChars( env, str, &isCopy);
        jint  len = (*env)->GetStringLength( env, str);
        int i;

        for ( i=0; i<len; i++ ){
                putchar( jc[i]);
        }
        putchar( '\n');

        (*env)->ReleaseStringChars( env, str, jc);
}
