#include "../vk_constants.h"


#define VK_ 0

unsigned char keyCodes[] = {
/* NULL                                       0x0000 */  VK_ ,
/* START_OF_HEADING                           0x0001 */  VK_ ,
/* START_OF_TEXT                              0x0002 */  VK_ ,
/* END_OF_TEXT                                0x0003 */  VK_ ,
/* END_OF_TRANSMISSION                        0x0004 */  VK_ ,
/* ENQUIRY                                    0x0005 */  VK_ ,
/* ACKNOWLEDGE                                0x0006 */  VK_ ,
/* BELL                                       0x0007 */  VK_ ,
/* BACKSPACE                                  0x0008 */  VK_BACK_SPACE ,
/* HORIZONTAL_TABULATION                      0x0009 */  VK_TAB ,
/* LINE_FEED                                  0x000A */  VK_ENTER ,
/* VERTICAL_TABULATION                        0x000B */  VK_ ,
/* FORM_FEED                                  0x000C */  VK_ ,
/* CARRIAGE_RETURN                            0x000D */  VK_ENTER ,
/* SHIFT_OUT                                  0x000E */  VK_ ,
/* SHIFT_IN                                   0x000F */  VK_ ,
/* DATA_LINK_ESCAPE                           0x0010 */  VK_ ,
/* DEVICE_CONTROL_ONE                         0x0011 */  VK_ ,
/* DEVICE_CONTROL_TWO                         0x0012 */  VK_ ,
/* DEVICE_CONTROL_THREE                       0x0013 */  VK_ ,
/* DEVICE_CONTROL_FOUR                        0x0014 */  VK_ ,
/* NEGATIVE_ACKNOWLEDGE                       0x0015 */  VK_ ,
/* SYNCHRONOUS_IDLE                           0x0016 */  VK_ ,
/* END_OF_TRANSMISSION_BLOCK                  0x0017 */  VK_ ,
/* CANCEL                                     0x0018 */  VK_CANCEL ,
/* END_OF_MEDIUM                              0x0019 */  VK_ ,
/* SUBSTITUTE                                 0x001A */  VK_ ,
/* ESCAPE                                     0x001B */  VK_ESCAPE ,
/* FILE_SEPARATOR                             0x001C */  VK_SEPARATER ,
/* GROUP_SEPARATOR                            0x001D */  VK_SEPARATER ,
/* RECORD_SEPARATOR                           0x001E */  VK_SEPARATER ,
/* UNIT_SEPARATOR                             0x001F */  VK_SEPARATER ,
/* SPACE                                      0x0020 */  VK_SPACE ,
/* EXCLAMATION_MARK                           0x0021 */  VK_ ,
/* QUOTATION_MARK                             0x0022 */  VK_ ,
/* NUMBER_SIGN                                0x0023 */  VK_ ,
/* DOLLAR_SIGN                                0x0024 */  VK_ ,
/* PERCENT_SIGN                               0x0025 */  VK_ ,
/* AMPERSAND                                  0x0026 */  VK_ ,
/* APOSTROPHE                                 0x0027 */  VK_ ,
/* LEFT_PARENTHESIS                           0x0028 */  VK_OPEN_BRACKET ,
/* RIGHT_PARENTHESIS                          0x0029 */  VK_CLOSE_BRACKET ,
/* ASTERISK                                   0x002A */  VK_MULTIPLY ,
/* PLUS_SIGN                                  0x002B */  VK_ADD ,
/* COMMA                                      0x002C */  VK_COMMA ,
/* HYPHEN_MINUS                               0x002D */  VK_SUBTRACT ,
/* FULL_STOP                                  0x002E */  VK_PERIOD ,
/* SOLIDUS                                    0x002F */  VK_ ,
/* DIGIT_ZERO                                 0x0030 */  VK_0 ,
/* DIGIT_ONE                                  0x0031 */  VK_1 ,
/* DIGIT_TWO                                  0x0032 */  VK_2 ,
/* DIGIT_THREE                                0x0033 */  VK_3 ,
/* DIGIT_FOUR                                 0x0034 */  VK_4 ,
/* DIGIT_FIVE                                 0x0035 */  VK_5 ,
/* DIGIT_SIX                                  0x0036 */  VK_6 ,
/* DIGIT_SEVEN                                0x0037 */  VK_7 ,
/* DIGIT_EIGHT                                0x0038 */  VK_8 ,
/* DIGIT_NINE                                 0x0039 */  VK_9 ,
/* COLON                                      0x003A */  VK_ ,
/* SEMICOLON                                  0x003B */  VK_SEMICOLON ,
/* LESS_THAN_SIGN                             0x003C */  VK_ ,
/* EQUALS_SIGN                                0x003D */  VK_EQUALS ,
/* GREATER_THAN_SIGN                          0x003E */  VK_ ,
/* QUESTION_MARK                              0x003F */  VK_ ,
/* COMMERCIAL_AT                              0x0040 */  VK_ ,
/* LATIN_CAPITAL_LETTER_A                     0x0041 */  VK_A ,
/* LATIN_CAPITAL_LETTER_B                     0x0042 */  VK_B ,
/* LATIN_CAPITAL_LETTER_C                     0x0043 */  VK_C ,
/* LATIN_CAPITAL_LETTER_D                     0x0044 */  VK_D ,
/* LATIN_CAPITAL_LETTER_E                     0x0045 */  VK_E ,
/* LATIN_CAPITAL_LETTER_F                     0x0046 */  VK_F ,
/* LATIN_CAPITAL_LETTER_G                     0x0047 */  VK_G ,
/* LATIN_CAPITAL_LETTER_H                     0x0048 */  VK_H ,
/* LATIN_CAPITAL_LETTER_I                     0x0049 */  VK_I ,
/* LATIN_CAPITAL_LETTER_J                     0x004A */  VK_J ,
/* LATIN_CAPITAL_LETTER_K                     0x004B */  VK_K ,
/* LATIN_CAPITAL_LETTER_L                     0x004C */  VK_L ,
/* LATIN_CAPITAL_LETTER_M                     0x004D */  VK_M ,
/* LATIN_CAPITAL_LETTER_N                     0x004E */  VK_N ,
/* LATIN_CAPITAL_LETTER_O                     0x004F */  VK_O ,
/* LATIN_CAPITAL_LETTER_P                     0x0050 */  VK_P ,
/* LATIN_CAPITAL_LETTER_Q                     0x0051 */  VK_Q ,
/* LATIN_CAPITAL_LETTER_R                     0x0052 */  VK_R ,
/* LATIN_CAPITAL_LETTER_S                     0x0053 */  VK_S ,
/* LATIN_CAPITAL_LETTER_T                     0x0054 */  VK_T ,
/* LATIN_CAPITAL_LETTER_U                     0x0055 */  VK_U ,
/* LATIN_CAPITAL_LETTER_V                     0x0056 */  VK_V ,
/* LATIN_CAPITAL_LETTER_W                     0x0057 */  VK_W ,
/* LATIN_CAPITAL_LETTER_X                     0x0058 */  VK_X ,
/* LATIN_CAPITAL_LETTER_Y                     0x0059 */  VK_Y ,
/* LATIN_CAPITAL_LETTER_Z                     0x005A */  VK_Z ,
/* LEFT_SQUARE_BRACKET                        0x005B */  VK_OPEN_BRACKET ,
/* REVERSE_SOLIDUS                            0x005C */  VK_ ,
/* RIGHT_SQUARE_BRACKET                       0x005D */  VK_CLOSE_BRACKET ,
/* CIRCUMFLEX_ACCENT                          0x005E */  VK_ ,
/* LOW_LINE                                   0x005F */  VK_ ,
/* GRAVE_ACCENT                               0x0060 */  VK_ ,
/* LATIN_SMALL_LETTER_A                       0x0061 */  VK_A ,
/* LATIN_SMALL_LETTER_B                       0x0062 */  VK_B ,
/* LATIN_SMALL_LETTER_C                       0x0063 */  VK_C ,
/* LATIN_SMALL_LETTER_D                       0x0064 */  VK_D ,
/* LATIN_SMALL_LETTER_E                       0x0065 */  VK_E ,
/* LATIN_SMALL_LETTER_F                       0x0066 */  VK_F ,
/* LATIN_SMALL_LETTER_G                       0x0067 */  VK_G ,
/* LATIN_SMALL_LETTER_H                       0x0068 */  VK_H ,
/* LATIN_SMALL_LETTER_I                       0x0069 */  VK_I ,
/* LATIN_SMALL_LETTER_J                       0x006A */  VK_J ,
/* LATIN_SMALL_LETTER_K                       0x006B */  VK_K ,
/* LATIN_SMALL_LETTER_L                       0x006C */  VK_L ,
/* LATIN_SMALL_LETTER_M                       0x006D */  VK_M ,
/* LATIN_SMALL_LETTER_N                       0x006E */  VK_N ,
/* LATIN_SMALL_LETTER_O                       0x006F */  VK_O ,
/* LATIN_SMALL_LETTER_P                       0x0070 */  VK_P ,
/* LATIN_SMALL_LETTER_Q                       0x0071 */  VK_Q ,
/* LATIN_SMALL_LETTER_R                       0x0072 */  VK_R ,
/* LATIN_SMALL_LETTER_S                       0x0073 */  VK_S ,
/* LATIN_SMALL_LETTER_T                       0x0074 */  VK_T,
/* LATIN_SMALL_LETTER_U                       0x0075 */  VK_U ,
/* LATIN_SMALL_LETTER_V                       0x0076 */  VK_V ,
/* LATIN_SMALL_LETTER_W                       0x0077 */  VK_W ,
/* LATIN_SMALL_LETTER_X                       0x0078 */  VK_X ,
/* LATIN_SMALL_LETTER_Y                       0x0079 */  VK_Y ,
/* LATIN_SMALL_LETTER_Z                       0x007A */  VK_Z ,
/* LEFT_CURLY_BRACKET                         0x007B */  VK_OPEN_BRACKET ,
/* VERTICAL_LINE                              0x007C */  VK_ ,
/* RIGHT_CURLY_BRACKET                        0x007D */  VK_CLOSE_BRACKET ,
/* TILDE                                      0x007E */  VK_ ,
/* DELETE                                     0x007F */  VK_DELETE ,
/* NO_BREAK_SPACE                             0x00A0 */  VK_ ,
/* INVERTED_EXCLAMATION_MARK                  0x00A1 */  VK_ ,
/* CENT_SIGN                                  0x00A2 */  VK_ ,
/* POUND_SIGN                                 0x00A3 */  VK_ ,
/* CURRENCY_SIGN                              0x00A4 */  VK_ ,
/* YEN_SIGN                                   0x00A5 */  VK_ ,
/* BROKEN_BAR                                 0x00A6 */  VK_ ,
/* SECTION_SIGN                               0x00A7 */  VK_ ,
/* DIAERESIS                                  0x00A8 */  VK_ ,
/* COPYRIGHT_SIGN                             0x00A9 */  VK_ ,
/* FEMININE_ORDINAL_INDICATOR                 0x00AA */  VK_ ,
/* LEFT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK  0x00AB */  VK_ ,
/* NOT_SIGN                                   0x00AC */  VK_ ,
/* SOFT_HYPHEN                                0x00AD */  VK_ ,
/* REGISTERED_SIGN                            0x00AE */  VK_ ,
/* MACRON                                     0x00AF */  VK_ ,
/* DEGREE_SIGN                                0x00B0 */  VK_ ,
/* PLUS_MINUS_SIGN                            0x00B1 */  VK_ ,
/* SUPERSCRIPT_TWO                            0x00B2 */  VK_ ,
/* SUPERSCRIPT_THREE                          0x00B3 */  VK_ ,
/* ACUTE_ACCENT                               0x00B4 */  VK_ ,
/* MICRO_SIGN                                 0x00B5 */  VK_ ,
/* PILCROW_SIGN                               0x00B6 */  VK_ ,
/* MIDDLE_DOT                                 0x00B7 */  VK_ ,
/* CEDILLA                                    0x00B8 */  VK_ ,
/* SUPERSCRIPT_ONE                            0x00B9 */  VK_ ,
/* MASCULINE_ORDINAL_INDICATOR                0x00BA */  VK_ ,
/* RIGHT_POINTING_DOUBLE_ANGLE_QUOTATION_MARK 0x00BB */  VK_ ,
/* VULGAR_FRACTION_ONE_QUARTER                0x00BC */  VK_ ,
/* VULGAR_FRACTION_ONE_HALF                   0x00BD */  VK_ ,
/* VULGAR_FRACTION_THREE_QUARTERS             0x00BE */  VK_ ,
/* INVERTED_QUESTION_MARK                     0x00BF */  VK_ ,
/* LATIN_CAPITAL_LETTER_A_WITH_GRAVE          0x00C0 */  VK_ ,
/* LATIN_CAPITAL_LETTER_A_WITH_ACUTE          0x00C1 */  VK_ ,
/* LATIN_CAPITAL_LETTER_A_WITH_CIRCUMFLEX     0x00C2 */  VK_ ,
/* LATIN_CAPITAL_LETTER_A_WITH_TILDE          0x00C3 */  VK_ ,
/* LATIN_CAPITAL_LETTER_A_WITH_DIAERESIS      0x00C4 */  VK_ ,
/* LATIN_CAPITAL_LETTER_A_WITH_RING_ABOVE     0x00C5 */  VK_ ,
/* LATIN_CAPITAL_LETTER_AE                    0x00C6 */  VK_ ,
/* LATIN_CAPITAL_LETTER_C_WITH_CEDILLA        0x00C7 */  VK_ ,
/* LATIN_CAPITAL_LETTER_E_WITH_GRAVE          0x00C8 */  VK_ ,
/* LATIN_CAPITAL_LETTER_E_WITH_ACUTE          0x00C9 */  VK_ ,
/* LATIN_CAPITAL_LETTER_E_WITH_CIRCUMFLEX     0x00CA */  VK_ ,
/* LATIN_CAPITAL_LETTER_E_WITH_DIAERESIS      0x00CB */  VK_ ,
/* LATIN_CAPITAL_LETTER_I_WITH_GRAVE          0x00CC */  VK_ ,
/* LATIN_CAPITAL_LETTER_I_WITH_ACUTE          0x00CD */  VK_ ,
/* LATIN_CAPITAL_LETTER_I_WITH_CIRCUMFLEX     0x00CE */  VK_ ,
/* LATIN_CAPITAL_LETTER_I_WITH_DIAERESIS      0x00CF */  VK_ ,
/* LATIN_CAPITAL_LETTER_ETH                   0x00D0 */  VK_ ,
/* LATIN_CAPITAL_LETTER_N_WITH_TILDE          0x00D1 */  VK_ ,
/* LATIN_CAPITAL_LETTER_O_WITH_GRAVE          0x00D2 */  VK_ ,
/* LATIN_CAPITAL_LETTER_O_WITH_ACUTE          0x00D3 */  VK_ ,
/* LATIN_CAPITAL_LETTER_O_WITH_CIRCUMFLEX     0x00D4 */  VK_ ,
/* LATIN_CAPITAL_LETTER_O_WITH_TILDE          0x00D5 */  VK_ ,
/* LATIN_CAPITAL_LETTER_O_WITH_DIAERESIS      0x00D6 */  VK_ ,
/* MULTIPLICATION_SIGN                        0x00D7 */  VK_MULTIPLY ,
/* LATIN_CAPITAL_LETTER_O_WITH_STROKE         0x00D8 */  VK_ ,
/* LATIN_CAPITAL_LETTER_U_WITH_GRAVE          0x00D9 */  VK_ ,
/* LATIN_CAPITAL_LETTER_U_WITH_ACUTE          0x00DA */  VK_ ,
/* LATIN_CAPITAL_LETTER_U_WITH_CIRCUMFLEX     0x00DB */  VK_ ,
/* LATIN_CAPITAL_LETTER_U_WITH_DIAERESIS      0x00DC */  VK_ ,
/* LATIN_CAPITAL_LETTER_Y_WITH_ACUTE          0x00DD */  VK_ ,
/* LATIN_CAPITAL_LETTER_THORN                 0x00DE */  VK_ ,
/* LATIN_SMALL_LETTER_SHARP_S                 0x00DF */  VK_ ,
/* LATIN_SMALL_LETTER_A_WITH_GRAVE            0x00E0 */  VK_ ,
/* LATIN_SMALL_LETTER_A_WITH_ACUTE            0x00E1 */  VK_ ,
/* LATIN_SMALL_LETTER_A_WITH_CIRCUMFLEX       0x00E2 */  VK_ ,
/* LATIN_SMALL_LETTER_A_WITH_TILDE            0x00E3 */  VK_ ,
/* LATIN_SMALL_LETTER_A_WITH_DIAERESIS        0x00E4 */  VK_ ,
/* LATIN_SMALL_LETTER_A_WITH_RING_ABOVE       0x00E5 */  VK_ ,
/* LATIN_SMALL_LETTER_AE                      0x00E6 */  VK_ ,
/* LATIN_SMALL_LETTER_C_WITH_CEDILLA          0x00E7 */  VK_ ,
/* LATIN_SMALL_LETTER_E_WITH_GRAVE            0x00E8 */  VK_ ,
/* LATIN_SMALL_LETTER_E_WITH_ACUTE            0x00E9 */  VK_ ,
/* LATIN_SMALL_LETTER_E_WITH_CIRCUMFLEX       0x00EA */  VK_ ,
/* LATIN_SMALL_LETTER_E_WITH_DIAERESIS        0x00EB */  VK_ ,
/* LATIN_SMALL_LETTER_I_WITH_GRAVE            0x00EC */  VK_ ,
/* LATIN_SMALL_LETTER_I_WITH_ACUTE            0x00ED */  VK_ ,
/* LATIN_SMALL_LETTER_I_WITH_CIRCUMFLEX       0x00EE */  VK_ ,
/* LATIN_SMALL_LETTER_I_WITH_DIAERESIS        0x00EF */  VK_ ,
/* LATIN_SMALL_LETTER_ETH                     0x00F0 */  VK_ ,
/* LATIN_SMALL_LETTER_N_WITH_TILDE            0x00F1 */  VK_ ,
/* LATIN_SMALL_LETTER_O_WITH_GRAVE            0x00F2 */  VK_ ,
/* LATIN_SMALL_LETTER_O_WITH_ACUTE            0x00F3 */  VK_ ,
/* LATIN_SMALL_LETTER_O_WITH_CIRCUMFLEX       0x00F4 */  VK_ ,
/* LATIN_SMALL_LETTER_O_WITH_TILDE            0x00F5 */  VK_ ,
/* LATIN_SMALL_LETTER_O_WITH_DIAERESIS        0x00F6 */  VK_ ,
/* DIVISION_SIGN                              0x00F7 */  VK_DIVIDE ,
/* LATIN_SMALL_LETTER_O_WITH_STROKE           0x00F8 */  VK_ ,
/* LATIN_SMALL_LETTER_U_WITH_GRAVE            0x00F9 */  VK_ ,
/* LATIN_SMALL_LETTER_U_WITH_ACUTE            0x00FA */  VK_ ,
/* LATIN_SMALL_LETTER_U_WITH_CIRCUMFLEX       0x00FB */  VK_ ,
/* LATIN_SMALL_LETTER_U_WITH_DIAERESIS        0x00FC */  VK_ ,
/* LATIN_SMALL_LETTER_Y_WITH_ACUTE            0x00FD */  VK_ ,
/* LATIN_SMALL_LETTER_THORN                   0x00FE */  VK_ ,
/* LATIN_SMALL_LETTER_Y_WITH_DIAERESIS        0x00FF */  VK_ ,
};

unsigned char ckeyCodes[] = {
/* HOME                       */ VK_HOME ,
/* END                        */ VK_END ,
/* INSERT                     */ VK_INSERT ,
/* PAGE_UP                    */ VK_PAGE_UP ,
/* PAGE_DOWN                  */ VK_PAGE_DOWN ,
/* LEFT_ARROW                 */ VK_LEFT ,
/* RIGHT_ARROW                */ VK_RIGHT ,
/* UP_ARROW                   */ VK_UP ,
/* DOWN_ARROW                 */ VK_DOWN ,
/* PRINT_SCREEN               */ VK_PRINTSCREEN ,
/* PAUSE                      */ VK_PAUSE ,
/* CAPS_LOCK                  */ VK_CAPS_LOCK ,
/* NUM_LOCK                   */ VK_NUM_LOCK ,
/* SCROLL_LOCK                */ VK_SCROLL_LOCK ,
/* LEFT_SHIFT                 */ VK_SHIFT ,
/* RIGHT_SHIFT                */ VK_SHIFT ,
/* LEFT_CTRL                  */ VK_CONTROL ,
/* RIGHT_CTRL                 */ VK_CONTROL ,
/* LEFT_ALT                   */ VK_ALT ,
/* RIGHT_ALT                  */ VK_ALT ,
/* PROGRAM                    */ VK_
};

unsigned char fkeyCodes[] = {
/* F1                         */ VK_F1 ,
/* F2                         */ VK_F2 ,
/* F3                         */ VK_F3 ,
/* F4                         */ VK_F4 ,
/* F5                         */ VK_F5 ,
/* F6                         */ VK_F6 ,
/* F7                         */ VK_F7 ,
/* F8                         */ VK_F8 ,
/* F9                         */ VK_F9 ,
/* F10                        */ VK_F10 ,
/* F11                        */ VK_F11 , 
/* F12                        */ VK_F12
};
