/*
 * external_wrappers.h
 * Non-shared library wrappers
 *
 * Copyright (c) 1996, 1997, 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "lib-license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"

/* These unwieldy pathname are necessary for building in a different
 * directory to the source code.
 */
#if defined(HAVE_LIBRARY_NATIVE)
KAFFE_LIBRARY(native)
#include "../../libraries/clib/native/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_IO)
KAFFE_LIBRARY(io)
#include "../../libraries/clib/io/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_MATH)
KAFFE_LIBRARY(math)
#include "../../libraries/clib/math/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_NET)
KAFFE_LIBRARY(net)
#include "../../libraries/clib/net/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_ZIP)
KAFFE_LIBRARY(zip)
#include "../../libraries/clib/zip/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_MANAGEMENT)
KAFFE_LIBRARY(management)
#include "../../libraries/clib/management/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_AWT)
KAFFE_LIBRARY(awt)
#include "../../libraries/clib/awt/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_SECURITY)
KAFFE_LIBRARY(security)
#include "../../libraries/clib/security/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_COMM)
KAFFE_LIBRARY(comm)
#include "../../libraries/clib/comm/external_wrappers.h"
#endif
#if defined(HAVE_LIBRARY_INPUT)
KAFFE_LIBRARY(input)
#include "../../libraries/clib/input/external_wrappers.h"
#endif
