/*
 * java.lang.Float.c
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include <math.h>
#include "../../../kaffe/kaffevm/gtypes.h"
#include "../../../kaffe/kaffevm/classMethod.h"
#include "../../../kaffe/kaffevm/fp.h"
#include <jni.h>
#include "defs.h"

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

/*
 * Convert float to bits.
 */
JNIEXPORT jint JNICALL
Java_java_lang_Float_floatToRawIntBits(JNIEnv* env, jclass flt, jfloat val)
{
	return (floatToInt(val));
}

/*
 * Convert bits to float.
 */
JNIEXPORT float JNICALL
Java_java_lang_Float_intBitsToFloat(JNIEnv* env, jclass flt, jint val)
{
	return (intToFloat(val));
}
