package java.awt;

import java.awt.image.ImageProducer;
import java.net.URL;
import java.net.URLConnection;

class TVDummyProducer
  extends NativeImageProducer
{
	static Image tvImage;
	static Color clrScreen = Color.black;

TVDummyProducer( URL url, Image target) {
	super( target);
}

static Image getTVImage() {
	if ( tvImage == null ){
		int d = Toolkit.screenSize.height / 64;

		tvImage = new Image( d, d);

		Graphics g = tvImage.getGraphics();
		if ( g != null ){
			g.setColor( clrScreen);
			g.fillRect( 0, 0, d, d);
			g.dispose();
		}
		
		tvImage.flags = Image.READY;
	}
	
	return tvImage;
}

void produce ( ) {
	getTVImage();

	img.width = tvImage.width;
	img.height = tvImage.height;
	img.nativeData = Toolkit.imgCreateScaledImage(tvImage.nativeData, img.width, img.height);
	img.flags |= Image.READY;
}

void produce ( URLConnection con ) {
}
}
