package kaffe.awt.dialogs;

import java.awt.TextField;
import java.awt.Window;
import kaffe.awt.widgets.TextPane;

public class TextPrompter
  extends BaseDialog
{
	TextField entry = new TextField(15);
	TextPane textPane;

public TextPrompter( String title, String msg, String text, Window owner) {
	super( title, owner);

	if ( msg != null ) {
		textPane = new TextPane( msg);
		add( "Center", textPane);
	}
	
	add( "South", entry);
	entry.addActionListener( this);
	
	if ( text != null ) {
		entry.setText( text);
	}
}

public String getSelection() {
	return entry.getText();
}

public static String prompt( String title, String msg, String text, Window owner) {
	TextPrompter p = new TextPrompter( title, msg, text, owner);
	return p.process();
}
}
