package kaffe.awt.doc;

import java.awt.Frame;
import java.awt.event.*;
import org.w3c.dom.*;

public class DocTest2
  extends Frame
  implements ActionListener
{
public DocTest2() {
	super( "DocTest2");
	
	DocumentImpl doc = new DocumentImpl();
	add( doc);
	
	Table t = (Table)doc.createElement( "kaffe.awt.doc.Table" );
	t.setAttribute( "halign", "1");
	t.setAttribute( "border", "1");
	t.setAttribute( "borderColor", "#000000");
	doc.appendChild(t);

	int rs = 4;
	int cs = 3;
	int keys = 12;
	
	TableRow r2 = (TableRow)doc.createElement( "kaffe.awt.doc.TableRow" );
	t.appendChild( r2);
	TableCell c2 = (TableCell)doc.createElement( "kaffe.awt.doc.TableCell" );
	c2.setAttribute( "colspan", "3");
	c2.setAttribute( "halign", "1");
	r2.appendChild( c2);
	Navigator n2 = (Navigator)doc.createElement( "kaffe.awt.doc.Navigator" );
	n2.setAttribute("action", "here");
	n2.setAttribute("action", "we");
	n2.setAttribute("action", "go");
	c2.appendChild(n2);

	TableRow r1 = (TableRow)doc.createElement( "kaffe.awt.doc.TableRow" );
	t.appendChild( r1);
	TableCell c1 = (TableCell)doc.createElement( "kaffe.awt.doc.TableCell" );
	c1.setAttribute( "colspan", "3");
	c1.setAttribute( "halign", "1");
	r1.appendChild( c1);
	Element e1 = doc.createElement( "kaffe.awt.doc.DocTextField" );
	c1.appendChild(e1);
		
	DocButton[] btns = new DocButton[keys];
	for ( int i=0; i<10; i++ ) {
		btns[i] = (DocButton)doc.createElement("kaffe.awt.doc.DocButton");
		btns[i].setAttribute("label", Integer.toString( i));
		// btns[i].onClick( this);
	}
	
	btns[10] = (DocButton)doc.createElement("kaffe.awt.doc.DocButton");
	btns[10].setAttribute( "label", ",");
	// btns[10].onClick( this);
	btns[11] = (DocButton)doc.createElement("kaffe.awt.doc.DocButton");
	btns[11].setAttribute( "label", "Calc");
	// btns[11].onClick( this);
	

	TableCell[] cells = new TableCell[keys];
	for ( int i=0; i<cells.length; i++ ) {
		cells[i] = (TableCell)doc.createElement("kaffe.awt.doc.TableCell");
	}

	TableRow[] rows = new TableRow[rs];
	for ( int i=0; i<rows.length; i++ ) {
		rows[i] = (TableRow)doc.createElement("kaffe.awt.doc.TableRow");
	}

	for ( int y=0; y<rs;y++ ) {
		t.appendChild( rows[y]);
		for ( int x=0; x<cs; x++ ) {
			int idx = 3*y+x;
			rows[y].appendChild( cells[idx] );
			cells[idx].appendChild( btns[idx] );
		}
	}

	addWindowListener( new WindowAdapter() {
		public void windowClosing( WindowEvent evt) {
			dispose();
		}
	} );
	
	setBounds( 100, 100, 400, 400);
	setVisible( true);
}

public void actionPerformed( ActionEvent evt) {
	System.out.println( evt);
}

public static void main( String[] args ) {
	new DocTest2();
}
}
