package kaffe.awt.doc;

import java.awt.Component;
import java.awt.Container;
import java.awt.event.*;

public class LinkListener
  implements MouseListener
{
	static LinkListener singleton = new LinkListener();

protected LinkListener() {
}

public static LinkListener getInstance() {
	return singleton;
}

public void mouseClicked( MouseEvent e) {
	Component obj = (Component)e.getSource();
	// Sometimes events come from object inside elements, so we have
	// to find the real element.
	while (!(obj instanceof ElementImpl)) {
		obj = obj.getParent();
	}
	String link = ((ElementImpl)obj).link;
        if (link != null && !link.equals("")) {
                com.pocketlinux.engine.Context.switchApp(link);
        }
}

public void mouseEntered( MouseEvent e) {
}

public void mouseExited( MouseEvent e) {
}

public void mousePressed( MouseEvent e) {
}

public void mouseReleased( MouseEvent e) {
}
}
