package kaffe.awt.doc;

import java.awt.*;
import org.w3c.dom.*;

class Bullet
  extends ElementImpl
{
	static int rad = 7;

Bullet() {
	fWidth = 2*rad;
	fHeight = getFontMetrics( FontAttributes.getFont()).getHeight();
}

public void paint( Graphics g) {
	Dimension d = getSize();
	g.setColor( Color.blue);
	g.fillOval( (d.width-rad)/2, (d.height-rad)/2, rad, rad);
}
}

public class List
  extends Table
{
	boolean ordered;

public List() {
}

public List( String title) {
	this( title, false);
}

public List( String title, boolean ordered) {
	super( 0, 0, 0, 0, 0, null);
	
	TableRow tr = new TableRow();
	add( tr );
	tr.add( new TableCell( 2, 1, 0, 0, TableCell.LEFT, TableCell.CENTER));
	currentCell.add( new TextImpl( title));
	this.ordered = ordered;
}

public static void addItem() {
/*
	List cl = (List)currentTable();
	TableRow tr = new TableRow();
	cl.add( tr);
	TableCell tc = new TableCell( 1, 1, 0, 0, TableCell.RIGHT, TableCell.TOP);
	tr.add( tc);
		
	if ( cl.ordered ) {
		tc.add( new TextImpl( cl.itemPrefix() ));
	}
	else {
		tc.add( new Bullet() );
	}

	tr.add( new TableCell( 1, 1, 0, 0, TableCell.LEFT, TableCell.TOP));
*/
}

String itemPrefix() {
	return ( " " + Integer.toString( rows.size()-1) + ". ");
}

public void setAttributeNS(String namespaceURI, String localName, String value) {
	if ( localName.equalsIgnoreCase( "title") )
		setTitle( value);
	else if ( localName.equalsIgnoreCase( "order") )
		ordered = value.equalsIgnoreCase( "ordered");
	else
		super.setAttributeNS( namespaceURI, localName, value);
}

public void setTitle(String title) {
	TableRow tr = new TableRow();
	add( tr );
	tr.add( new TableCell( 2, 1, 0, 0, TableCell.LEFT, TableCell.CENTER));
	currentCell.add( new TextImpl( title));
}
}
