package kaffe.awt.theme;

import java.awt.Component;
import java.awt.Graphics;
import kaffe.awt.Defaults;

public class SimpleButtonDeco
  extends SimpleComponentDeco
{
SimpleButtonDeco() {
	super( Defaults.BtnClr, Defaults.BtnTxtClr, Defaults.BtnFont);
	
	int d = Defaults.WidgetBorderWidth;
	insets.left += d;
	insets.right += d;
	insets.top += d;
	insets.bottom += d;
}

public void paintBorder( Component c, Graphics g, int x, int y, int w, int h, int state) {
	super.paintBorder( c, g, x, y, w, h, state);
	
	int d = Defaults.WidgetBorderWidth;
	int dw = 2*d+1;
	g.setColor( ((state & CS_CURSOR_OVER) > 0) ? Defaults.BtnPointClr : c.getBackground());
	g.draw3DRect( x+d, y+d, w-dw, h-dw, ((state & CS_ACTIVE) == 0));
}
}
