package kaffe.awt.theme;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Insets;
import kaffe.awt.AWT;
import kaffe.awt.Defaults;

public class SimpleComponentDeco
  extends ComponentDeco
{
public SimpleComponentDeco() {
	int d = Defaults.WidgetBorderWidth;
	insets = new Insets( d, d, d, d);
}

public SimpleComponentDeco( Color bg, Color fg, Font f) {
	super( bg, fg, f);
	int d = Defaults.WidgetBorderWidth;
	insets = new Insets( d, d, d, d);
}

public void paintBorder( Component c, Graphics parentGr, int x, int y, int w, int h, int state) {
	if ( c == AWT.keyTgt )
		parentGr.setColor( Defaults.FocusClr);
	else
		parentGr.setColor( Defaults.BorderClr);

	if (w-1 > 0 && h-1 > 0)
		parentGr.draw3DRect( x, y,  w-1, h-1, (state & CS_ACTIVE) == 0);

	if (w-3 > 0 && h-3 > 0)
		parentGr.draw3DRect( x+1, y+1, w-3, h-3, (state & CS_ACTIVE) > 0);
}
}
