package kaffe.io;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;

public class AccessibleBIStream
  extends BufferedInputStream
{
public AccessibleBIStream ( InputStream in ) {
	super( in);
}

public AccessibleBIStream ( InputStream in, int size ) {
	super( in, size);
}

public byte[] getBuffer() {
	return buf;
}

public int getCount() {
	return count;
}

public int getPos () {
	return pos;
}

public InputStream getFilteredStream() {
	return (in);
}

public int refillBuffer() throws IOException {

	count = in.read( buf, 0, buf.length);
	pos = 0;

	return count;
}

/*
int refillX() throws IOException {
	int n;
	
	if ( (pos > 0) && (pos < count) ){
		n = count - pos;
		System.arraycopy( buf, pos, buf, 0, n);
System.out.println( "refill move: " + n);
	}
	else {
		n = in.read( buf, 0, buf.length);
System.out.println( "refill read: " + n);
	}

	pos = 0;
	count = n;

	return n;
}
*/
}
