package kaffe.io;

import java.io.IOException;

class ByteToCharFilterDefault
	extends ByteToCharFilter {

private byte[] buf = new byte[16];;

public int read(char cbuf[], int off, int len) throws IOException {
	if (len > buf.length) {
		buf = new byte[len];
	}
	int count = super.read(buf, 0, len);
	for (int i = 0; i < count; i++) {
		cbuf[off+i] = (char)buf[i];
	}
	return (count);
}

}
