/*
 * Copyright (c) 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * $tvt: DefaultFileNameMap.java,v 1.12 2001/07/25 01:37:52 samc Exp $
 */

package kaffe.net;

import java.lang.String;
import java.net.FileNameMap;
import java.util.ResourceBundle;
import java.util.MissingResourceException;

public class DefaultFileNameMap
	implements FileNameMap 
{

  private ResourceBundle map = ResourceBundle.getBundle("kaffe.net.mimetypes");

  public String getContentTypeFor(String filename) 
    {
      try 
        {
          int i = filename.lastIndexOf('.');
          if (i != -1) 
            {
              return ((String)map.getObject(filename.substring(i+1).toLowerCase()));
            }
        }
      catch (MissingResourceException _) { }
      return (null);
    }
}
