/* -*- mode: C; mode: fold -*- */ 

#include "fgl.h"
#include <sys/timeb.h>
#include <unistd.h>

#define TEST 4
#define SIZE 200
#define VERIFY 10000

int main ( int argc, char* argv[] ) /*{{{*/
{
  fgl_slc_t *src;
  fgl_slc_t *dst;
  fgl_slc_t *s;
  fgl_slc_t *d;
  
  int v,si,test1,test2;
  struct timeb start,end;
  float time;

  src = (fgl_slc_t *)malloc((SIZE+4)*sizeof(u32));
  dst = (fgl_slc_t *)malloc((SIZE+4)*sizeof(u32));

  /* set the test cases */

  /* run test 0 */
  ftime(&start);

  for(test1 = 0; test1 < TEST; test1++ ) {
  for(test2 = 0; test2 < TEST; test2++ ) {
    s = src + test1;
    d = dst + test2;
    for (si = 1; si < SIZE ; si++) {
      for (v = 0; v <VERIFY ;v ++) {
	fgl_cpySlc(s,0,d,0,si);
      }
    }
  }
  }
  ftime(&end);
  time = end.time - start.time + (end.millitm - start.millitm)/1000.0;

  fprintf(stderr,"MC TEST TIME (%8.3f)\n",time);

  free(src);
  free(dst);

  return 1;
}
/*}}}*/
