/*
 * heap_posix.h - fgl module for posix specific heap management
 *                (essentially a dummy providing the macros)
 * 
 * Copyright (c) 2000, 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 */

#ifndef FGL_HEAP_INCLUDED
#define FGL_HEAP_INCLUDED

#define FGL_MALLOC(_n)      malloc( _n)

#define FGL_CALLOC(_n,_sz)  calloc( (_n), (_sz))

#define FGL_FREE(_r)        free( _r)

#define FGL_ALLOCA(_n)      alloca( _n)

#define FGL_ALLOCA_FREE(_r)

#endif /* FGL_HEAP_INCLUDED */
