#!/bin/sh
#
# Shell script that should be run to generate all the initial makefile.
# This script calls the generic autogen.sh in the 'macros' module.
#
# $tvt: autogen.sh,v 1.5 2001/06/15 03:05:15 samc Exp $

srcdir=`dirname $0`
test -z "$srcdir" && srcdir=.

MACROS=$srcdir/macros
ACLOCAL_FLAGS="-I $MACROS"

. $MACROS/autogen.sh
