package com.pocketlinux.awt.theme;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import kaffe.awt.*;

public class Deco2I
  extends StyleComponentDeco
  implements SizeInfo
{
	final private static String[] filenames = new String[]{
	"icon.gif",
	"pattern.gif",
};

public Deco2I(Style style, String widgetname) {
	super(style, widgetname, filenames);
}

public Insets getInsets() {
	return (new Insets(0, images[0].getWidth(null), 0, 0));
}

public Dimension getPreferredSize() {
	return (new Dimension(1, images[0].getHeight(null)));
}

public boolean hasBackgroundImage() {
	return (true);
}

public boolean paintBackground( Component c, Component p, Graphics g, int cx, int cy, int cw, int ch, int x, int y, int w, int h, int xOff, int yOff, int state) {
	AWT.extension.drawBorder( g, x, y, w, h, Theme.ALIGN_OUTER, images[0], images[1], null, null, null, null, null, null );
	return true;
}
}
