package com.pocketlinux.awt.theme;

import java.awt.*;
import kaffe.awt.*;

public class DecoTran
  extends StyleComponentDeco
{
	private boolean draw;
	private boolean border;

public DecoTran(Style style, boolean draw, boolean border) {
	super(style, "tran");
	this.draw = draw;
	this.border = border;
	if (border) {
		insets = new Insets(1, 1, 1, 1);
	}
}

public boolean paintBackground(Component c, Component p, Graphics g, int cx, int cy, int cw, int ch, int x, int y, int w, int h, int xOff, int yOff, int state) {
        if (p instanceof BackgroundImage) {
                Image img = ((BackgroundImage)p).getBackgroundImage();
		if (img != null && Theme.toolkit.prepareImage(img, -1, -1, null)) {
			AWT.extension.drawBackground( g, cx, cy, cw, ch, x, y, w, h, xOff, yOff, img, null, Theme.FILL_TILE);
			return (true);
		}
	}
	return (draw);
}

public void paintBorder(Component c, Graphics g, int x, int y, int w, int h, int state) {
	if (border) {
		g.setColor(fgClr);
		g.drawRect(x, y, w-1, h-1);
	}
}

public void reload() {
}
}
