/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: LocaleSubsystem.java,v 1.3 2001/10/22 20:42:34 colin Exp $
 */
package org.xoe.core;

import org.xoe.core.Constants;

import java.util.Locale;

import org.w3c.dom.Document;


public class LocaleSubsystem
  implements ISubsystem, Constants
{
  public void initSubsystem(Document doc)
  {
    Locale l = Locale.getDefault ();

    // get the country
    String country = Engine.getConfig (COUNTRY_PROPERTY, l.getCountry ());

    // get the launguage
    String language = Engine.getConfig (LANGUAGE_PROPERTY, l.getLanguage ());

    // assign the new locale
    Locale.setDefault (new Locale (language, country));
  }
}
