/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: ProtocolSubsystem.java,v 1.3 2001/10/22 20:42:34 colin Exp $
 */
package org.xoe.core;

import java.net.URL;
import java.net.URLConnection;

import org.w3c.dom.Document;

import org.xoe.core.protocol.DefaultURLStreamHandlerFactory;


public class ProtocolSubsystem
  implements ISubsystem
{
  public void initSubsystem(Document configDoc)
  {
    URLConnection.setDefaultRequestProperty ("User-agent", "Mozilla/5.0 (compatible; Xoe 1.0)");
    URL.setURLStreamHandlerFactory (new DefaultURLStreamHandlerFactory ());
  }
}
