/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: DOMException.java,v 1.2 2001/12/13 00:46:35 jason Exp $
 */
package org.xoe.core.dom;

/**
 * DOMException.java
 *
 */
public class DOMException 
  extends org.w3c.dom.DOMException 
{
   public static final short XOE_EXCEPTION = 100;

   private Throwable t;
/**
*DOMException 
*/
   public DOMException ()
   {
     super (XOE_EXCEPTION, "Something went wrong.");
   }
/**
*DOMException
*
*@param code Error code
*@param message Error message
*/
   public DOMException (short code, String message) 
   {
      super (code, message);
   }
/**
*DOMException
*/
   public DOMException (Throwable t) 
   {
      this ();
      this.t = t;
   }
/**
*printStackTrace
*/
   public void printStackTrace ()
   {
     if (t != null)
       {
	 t.printStackTrace ();
       }

     super.printStackTrace ();
   }
} 
