/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: IPackageQuery.java,v 1.2 2001/12/13 23:51:18 erik Exp $
 */
package org.xoe.core.packages;

/**
 * Represents a query that can be converted to XPath and performed
 * against a package description
 */
public interface IPackageQuery
{
  /**
   * Build an XPath query out of this IPackageQuery
   */
  public String toXPath ();
}
