/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: ILogger.java,v 1.1 2001/10/21 03:07:21 colin Exp $
 */
package org.xoe.core.util;

import org.xoe.core.services.IService;

import java.io.PrintWriter;


public interface ILogger
  extends IService
{
  public static final String INTERFACE = ILogger.class.getName ();
  public static final String FUNCTIONALITY = "logger";

  public static final int DEBUG = 1;
  public static final int STATUS = 2;

  public void register (PrintWriter writer, int level);
  public void unregister (PrintWriter writer, int level);
}
