package org.xoe.mime;

import org.xoe.test.AssertionFailedException;
import org.xoe.test.Test;

import com.pocketlinux.content.Stash;
import com.pocketlinux.content.ContentElement;

import java.io.InputStream;
import java.net.URL;

public class MimeParsingTest extends Test
{
  protected void test()
    throws AssertionFailedException
  {
    InputStream is = null;
    try
      {
	URL wd = Stash.getWorkingDirectory(this);
	is = Stash.fetch(new URL(wd, "mime.data")).getInputStream();
      }
    catch(Exception ex)
      {
	report(ex);
	ASSERT(false, "Unexpected exception: " + ex);
      }

    try
      {
	Multipart mp = new Multipart(is);
      }
    catch(MultipartParsingException ex)
      {
	report(ex);
	ASSERT(false, "Failed to parse 'mime.data'");
      }
  }
}
