#!/bin/sh
#
# Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
# See the file "license.terms" for details.
#
# Run this script to clean all the packages.
#
# [SBC]
#
# $tvt: clean-all.sh,v 1.5 2001/11/03 01:27:49 samc Exp $

packagedir=`dirname $0`

rm -fr xoe-build-log

echo "Removing all binary packages (*.xoe) ..."
find $packagedir -name "*.xoe" -type f | xargs rm -f

echo "Removing all cached dependancies (.xoedeps) ..."
find $packagedir -name ".xoedeps" -type f | xargs rm -f

echo "Removing all package build directories (XOE_BUILD) ..."
find $packagedir -name XOE_BUILD -type d | xargs rm -rf
