/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: Emulator.java,v 1.5 2001/11/14 20:53:08 damian Exp $
 */
package org.xoe.device;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.Window;

abstract public class Emulator
  extends Screen
{
  protected Emulator ()
  {
    super ();
  }

  protected Window getWindow ()
  {
    return (new Frame (this.getClass ().getName ()) 
    {
      public void update (Graphics g)
      {
        paint (g);
      }
    });
  }

  public int getDefaultRotation ()
  {
    return 0;
  }


  protected abstract Dimension getScreenSize ();
}
