package org.xoe.protocol.http;

import java.net.URL;
import org.xoe.core.util.Logger;

public class HttpURLConnection
  extends kaffe.net.www.protocol.http.HttpURLConnection
{
  public HttpURLConnection(URL url)
  {
    super(url);

  }

  protected void setHeaderField(String key, String value)
  {
    super.setHeaderField (key, value);
    if(key.equalsIgnoreCase("set-cookie"))
      {
	try
	  {
	    Cookie.processCookies(getURL(), value);
	  }
	catch(CookieException ex)
	  {
	    Logger.log(this, ex);
	  }
      }
  }

  protected void setRequestProperties()
  {
    super.setRequestProperties();
    String cookies = Cookie.getCookieField(getURL ());
    if(cookies != null)
      {
	setRequestProperty("Cookie", cookies);
      }
    else
      {
        deleteRequestProperty("Cookie");
      }
  }
}
