#!/bin/sh
#
# Shell script that should be run to generate all the initial makefile.
# This script calls the generic autogen.sh in the 'macros' module.
#
# $tvt: autogen.sh,v 1.3 2001/11/22 03:59:54 samc Exp $

srcdir=`dirname $0`
test -z "$srcdir" && srcdir=.

MACROS=$srcdir/../../../macros
ACLOCAL_FLAGS="-I $MACROS"
RUN_AUTOHEADER=1

. $MACROS/autogen.sh $*
