/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: MPlayerService.java,v 1.2 2001/11/30 00:23:34 samc Exp $
 */

package org.xoe.plugin;

import org.xoe.core.Constants;

import org.xoe.core.services.IService;
import org.xoe.core.services.ServiceFactory;

import org.xoe.display.dom.plugin.NPServiceBase;

public class MPlayerService
  extends NPServiceBase
  implements ServiceFactory
{

  static final String LIB_PATH = "/tmp/libmplayer.so";
  static MPlayerService defaultInstance = new MPlayerService ();

  public IService newInstance ()
  {
    return defaultInstance;
  }


  public String[] getFeatures (String func)
  {
    if (func.equals (FUNCTION_CONTENT_HANDLER))
      {
	 return new String[]{ FEATURE_MIMETYPE,  "video/mpeg" ,
			      FEATURE_EXTENSION, "mpg" ,
			      FEATURE_EXTENSION, "mpe" ,
			      FEATURE_EXTENSION, "mpeg" ,
			      FEATURE_EXTENSION, "mov" };
      }
     return new String[0];
  }
   

  public String getLibrary() 
  {
    return LIB_PATH;
  }
   
}








