/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: Shutdown.java,v 1.2 2001/11/12 19:08:35 samc Exp $ 
 */
package org.xoe.controlpanel;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.xoe.core.Engine;
import org.xoe.core.util.Logger;
import org.xoe.servlet.XoeServlet;


public class Shutdown
  extends XoeServlet
{
  protected void doGet (HttpServletRequest req, HttpServletResponse res)
    throws ServletException, IOException
  {
    res.setContentType ("text/html");
    String path = req.getPathInfo ();

    if ("".equals (path))
      {
	res.getWriter ().print (getRelativeDocument ("index.xhtml"));
      } 
    else if ("SHUTDOWN".equals (path))
      {
        Engine.shutdown (1);
      }
  }
}
