package org.xoe.soap.server;



import java.util.Hashtable;


public class SimpleSoapServerRegistry 
{

  private Hashtable serviceTable;


  public void registerService (String urn, String classname)
  {
    if (serviceTable == null)
      {
	serviceTable = new Hashtable ();
      }

    serviceTable.put (urn, classname);

  }

  
  public String lookupService (String urn)
    throws SimpleSoapServerException
  {
    if (serviceTable == null)
      {
	throw new SimpleSoapServerException ("Hashtable is null");
      }
    return (String)serviceTable.get (urn);
  }


}


