/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: XElementSoapParameter.java,v 1.1 2001/11/09 22:39:12 ben Exp $
 */ 
package org.xoe.soap;

import org.w3c.dom.Element;

import org.xoe.core.util.DOMUtils;
import org.xoe.core.dom.XElement;

public class XElementSoapParameter 
  implements SoapParameter
{
  private XElement paramObj;
  
  public void setParameter (Object obj)
  {
    paramObj = (XElement)obj;
  }

  public void generate (SoapDocument soapDocument)
  {
    Element c1 = soapDocument.createElementNS (null, "return");    
    //c1.setAttribute (SoapConstants.ATTRIBUTE_PREFIX + SoapConstants.ENCODING_STYLE , SoapConstants.LITERAL_XML_ENCODING_STYLE_URL);
          
    c1.appendChild (soapDocument.importNode (paramObj, true));
    soapDocument.getCurrentMethodElement().appendChild (c1);    
  }
}
