package org.xoe.display.dom.wml;

import org.w3c.dom.NodeList;

import org.xoe.core.xpath.XPath;
import org.xoe.display.dom.LayoutCursor;


public class Select
  extends org.xoe.display.dom.xhtml.Select 
{

  /**
   * When laying-out a select, we add in the option nodes if we're not watching
   * anything else.
   */
  public void layout (LayoutCursor cur) 
  {
    cur.newline ();
    setPreferredWidth (-100);
    if (vis == null) 
      {
	makeList ();
      }

    if (cur.isPhase1())
      {
	NodeList nl = XPath.findNodes (this, OPTION_PATH);
	size = nl.getLength ();
	if (size > 0)  
	  {
	    setList (nl);
	  }
      }

    vis.setForeground (cur.anchorclr);
    super.layout (cur);
  }

}
