/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IViewableDocumentBuilder.java,v 1.2 2001/10/22 21:39:23 colin Exp $
 */
package org.xoe.display.dom;

import java.io.IOException;

import org.xoe.core.content.ContentElement;
import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;


public interface IViewableDocumentBuilder 
  extends IService
{
  public static final String INTERFACE = IViewableDocumentBuilder.class.getName ();

  public XDocument getViewableDocument (ContentElement content)
    throws IOException;
}
