/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IPackageSelector.java,v 1.4 2001/11/02 20:37:04 erik Exp $
 */
package org.xoe.services;

import org.w3c.dom.Document;

import org.xoe.core.packages.InstallOption;
import org.xoe.core.packages.SearchResults;
import org.xoe.core.services.IService;


public interface IPackageSelector
  extends IService
{
  public static final String FUNCTIONALITY = "PackageSelector";
  public static final String INTERFACE = IPackageSelector.class.getName ();

  public Document showSearchResults (String title, String summary, SearchResults results);
  public Document upgradePackage (String title, String summary, InstallOption[] iopts);
}
