package org.xoe.services;

import java.io.IOException;
import java.net.URL;

import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;


public interface IWebBrowser
  extends IService
{
  public static final String INTERFACE = IWebBrowser.class.getName ();
  public static final String FUNCTIONALITY = "web-browsing";

  public XDocument getWebPage (String src)
    throws IOException;

  public XDocument getWebPage (URL url)
    throws IOException;
}
