package org.xoe.servlet;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.xoe.servlet.XoeServlet;

import org.xoe.core.dom.XDocument;


public class IndexServlet 
  extends XoeServlet
{
   /**
    *  Displays the file <code>index.xhtml</code>.
    */
   protected void doGet (HttpServletRequest req, HttpServletResponse res) 
     throws ServletException, IOException
   {     
      res.setContentType ("text/html");

      XDocument doc = getRelativeDocument ("index.xhtml");
      if (doc == null)
        {
          throw new ServletException ("index.xhtml not found.");
        }

      res.getWriter ().print (doc);
   }
}
