/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: XoePrintWriter.java,v 1.4 2001/10/22 23:17:39 colin Exp $
 */
package org.xoe.servlet;

import java.io.OutputStreamWriter;
import java.io.PrintWriter;

import org.w3c.dom.Document;


class XoePrintWriter
  extends PrintWriter
{
  Document doc;

  XoePrintWriter (OutputStreamWriter out, boolean autoflush)
  {
    super (out, autoflush);
  }

  public void print (Object obj)
  {
    if (obj instanceof Document)
      {
	doc = (Document)obj;
      }
    else if (obj != null)
      {
	super.print (obj);
      }
  }

  public void println (Object obj)
  {
    if (obj instanceof Document)
      {
	doc = (Document)obj;
      }
    else if (obj != null)
      {
	super.println (obj);
      }
  }
}
