/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: XoeServletContext.java,v 1.3 2001/10/22 23:17:39 colin Exp $
 */
package org.xoe.servlet;

import java.util.Hashtable;
import java.util.Enumeration;

import javax.servlet.Servlet;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;

import org.xoe.core.util.Logger;


public class XoeServletContext
  implements ServletContext
{

  private Hashtable servlets = new Hashtable ();

  public Servlet getServlet (String name) 
    throws ServletException
  {
    return ((Servlet)servlets.get (name));
  }

  public Enumeration getServlets ()
  {
    return (servlets.elements ());
  }

  public Enumeration getServletNames ()
  {
    return (servlets.keys ());
  }

  public void log (String msg)
  {
    Logger.log ("XoeServlet", msg);
  }

  public void log (Exception exception, String msg)
  {
    Logger.log ("XoeServlet", msg);
    Logger.log ("XoeServlet", exception);
  }

  public String getRealPath (String path)
  {
    throw new kaffe.util.NotImplemented ();
  }

  public String getMimeType (String file)
  {
    throw new kaffe.util.NotImplemented ();
  }

  public String getServerInfo ()
  {
    throw new kaffe.util.NotImplemented ();
  }

  public Object getAttribute (String name)
  {
    throw new kaffe.util.NotImplemented ();
  }

  // -----------------------------------------------------------

  public void putServlet (String name, Servlet servlet)
  {
    servlets.put (name, servlet);
  }

}
