/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: XoeServletOutputStream.java,v 1.2 2001/10/10 18:13:50 samc Exp $
 */
package org.xoe.servlet;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import javax.servlet.ServletOutputStream;

class XoeServletOutputStream
  extends ServletOutputStream
{
  ByteArrayOutputStream buffer = new ByteArrayOutputStream ();

  public void write (int ch) 
    throws IOException
  {
    buffer.write (ch);
  }

  public void write (byte b[], int off, int len) 
    throws IOException
  {
    buffer.write (b, off, len);
  }

  // -------------------------------------------------------------------

  ByteArrayOutputStream getBuffer ()
  {
    return (buffer);
  }

  void reset ()
  {
    buffer.reset ();
  }

  int size ()
  {
    return (buffer.size ());
  }
}
