/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XsTest.java,v 1.1 2001/07/31 23:22:13 samc Exp $
 */
package kaffe.xs;

import java.net.MalformedURLException;
import java.net.URL;

public class XsTest 
{
  static
    {
      System.out.println("*** loading XS library ***");
      System.loadLibrary ("xs");
      System.out.println("*** done loading XS library ***");
    }

  public static void main (String args[])
    {
      if (args.length < 1)
        {
          System.err.println("XsTest: please specify a URL");
          return;
        }

      URL url = null;
      try 
        {
          url = new URL ("file:///home/nick/index.html");
        }
      catch (MalformedURLException mue)
        {
          System.out.println (mue);
        }

      System.out.println("*** creating XsEngine ***");
      XsEngine engine = new XsEngine ();
      System.out.println("*** calling createDocument ***");
      engine.createDocument (url);
      System.out.println("*** done test ***");
    }
}
