/* entities.h -- Header for recognize HTML ISO entities

  (c) 1998-2000 (W3C) MIT, INRIA, Keio University
  Copyright (c) 1998-2000 World Wide Web Consortium
  (Massachusetts Institute of Technology, Institut National de
  Recherche en Informatique et en Automatique, Keio University).
  All Rights Reserved.

  Contributing Author(s):

     Dave Raggett <dsr@w3.org>
     
     
  Modified for use in xs by Philippe Laporte Oct 5 2001
  
  Copyright (c) 2001
       Transvirtual Technologies, Inc.  All rights reserved.
 
  See the file "license.terms" for information on usage and redistribution 
  of this file. 
   
   
   

  The contributing author(s) would like to thank all those who
  helped with testing, bug fixes, and patience.  This wouldn't
  have been possible without all of you.

  COPYRIGHT NOTICE:
 
  This software and documentation is provided "as is," and
  the copyright holders and contributing author(s) make no
  representations or warranties, express or implied, including
  but not limited to, warranties of merchantability or fitness
  for any particular purpose or that the use of the software or
  documentation will not infringe any third party patents,
  copyrights, trademarks or other rights. 

  The copyright holders and contributing author(s) will not be
  liable for any direct, indirect, special or consequential damages
  arising out of any use of the software or documentation, even if
  advised of the possibility of such damage.

  Permission is hereby granted to use, copy, modify, and distribute
  this source code, or portions hereof, documentation and executables,
  for any purpose, without fee, subject to the following restrictions:

  1. The origin of this source code must not be misrepresented.
  2. Altered versions must be plainly marked as such and must
     not be misrepresented as being the original source.
  3. This Copyright notice may not be removed or altered from any
     source or altered source distribution.
 
  The copyright holders and contributing author(s) specifically
  permit, without fee, and encourage the use of this source code
  as a component for supporting the Hypertext Markup Language in
  commercial products. If you use this source code in a product,
  acknowledgment is not required but would be appreciated.
  
  
*/

#ifndef ENTITIES_H_INCLUDED
#define ENTITIES_H_INCLUDED

#include <stdio.h>


#include "xs_config.h"


#ifdef KAFFELIB  //if used as a kaffe jni lib (useless??)
#include <jni.h>
#else
#include <stdlib.h>
#endif


#define HASHSIZE 731

struct nlist
{
    struct nlist *next;
    char *name;
    unsigned code;
};

static struct nlist *hashtab[HASHSIZE];







/*  returns zero on error */
char EntityCode(char *name);

void InitEntities(void);

//void FreeEntities(void);

//char *EntityName(char n);




#endif /* ENTITIES_H_INCLUDED */
