/*
 * queue of pending beginning tags to be matched
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 *
 * @author Philippe Laporte 
 *
 */
 
// linked list implemntation is slower and requires more heap access but is easier to write than array one
// so ultimately replace with array one

#ifndef QUEUE_H_INCLUDED
#define QUEUE_H_INCLUDED




#include "xs_config.h"

#ifdef KAFFELIB  //if used as a kaffe jni lib

#include <jni.h>

#else

#include <stdlib.h>

#endif


typedef struct queueNode{
        char* tag;
	struct queueNode* next;   
} QUEUENODE;

void initTagQueue(void);
//bool isTagQueueEmpty(void){
void enqueueTag(char* tag);
bool findTagInTagQueue(char* tag);
//char* dequeue(void);
//char* peek(void);
//void emptyQueue(void);
void deleteTagQueue(void);



/*
void initTagStack();

void deleteTagStack();

//int getStackPointer();

void pushTag(char* tag);

void popTag();

char* peekTop();

bool onStack(char* tag);
*/

#endif /* QUEUE_H_INCLUDED */
